//##############################################################################
//                                                                            //
// A_INTERN.CPP                                                               //
//                                                                            //
// Subsystem: Diffraktometrie/ Reflektometrie                                 //
//            intern genutzte Fenster fr AreaScan                            //
// Benutzung durch andere Subsysteme erforderlich: NEIN                       //
//                                                                            //
//##############################################################################
//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI

#include <direct.h>

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include "help\help_def.h"     // Help-IDs
#pragma hdrstop

#include "difrkmty\a_intern.h" // SCHNITTSTELLE fr diese Datei
#include "difrkmty\a_extern.h" // TAreaScanWindow
#include "internls\l_layer.h" // fr extern lpDBase

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

__declspec(dllimport) LPDataBase lpDBase; // aus L_LAYER.CPP

//#############################################################################
// globale Typen und Konstanten
//#############################################################################

const UINT _RELATIONDIGITS= 2;
const UINT _MAXTIMEDIGITS= 1;

//#############################################################################
// sprachspezifische Konstanten
//#############################################################################

#ifdef GermanVersion
	static const char szDlgFailure[]= "Fehler";
	static const char szDlgMessage[]= "Meldung";
	static const char szInfoType0[]= "         Medetektor";
	static const char szInfoType1[]= "Integrale Intensitt";
	static const char szInfoType2[]= "    Absorberposition";
	static const char szInfoType3[]= "  Monitor-Intensitt";
	static const char szInfoType4[]= "       reale Mezeit";
	static const char szDlgMsgLine001[]= "Kein gltiger Scantyp";
	static const char szDlgMsgLine002[]= "Vorgang bitte wiederholen !";
	static const char szDlgMsgLine003[]= "kein Absorber verfgbar";
	static const char szDlgMsgLine004[]= "gltige Kanalnummern: 0 bis %d";
	static const char szDlgMsgLine005[]= "Bereichsberschreitung (Omega)";
	static const char szDlgMsgLine006[]= "Bereichsberschreitung (Theta)!\n\nMinimum %s ist ungltig.";
	static const char szDlgMsgLine007[]= "Bereichsberschreitung (Theta)!\n\nMaximum %s ist ungltig.";

	static const char szDlgMsgLine100[]= "Datei existiert bereits !\r\nberschreiben ?";
	static const char szDlgMsgLine101[]= "Probleme beim Anlegen der Datei !";
	static const char szDlgMsgLine102[]= "Bitte mit der Maus eine Linie festlegen.";
	static const char szDlgMsgLine103[]= "Kein Monitor";
	static const char szDlgMsgLine104[]= "Datenbasis-Datei whlen";
#else
	static const char szDlgFailure[]= "Failure";
	static const char szDlgMessage[]= "Message";
	static const char szInfoType0[]= "       Detector-type";
	static const char szInfoType1[]= "  Integral Intensity";
	static const char szInfoType2[]= "    Absorberposition";
	static const char szInfoType3[]= "   Monitor-Intensity";
	static const char szInfoType4[]= "  real Measure-Time ";
	static const char szDlgMsgLine001[]= "No valid Scan Type";
	static const char szDlgMsgLine002[]= "Please repeat the procedure !";
	static const char szDlgMsgLine003[]= "no absorber available";
	static const char szDlgMsgLine004[]= "valid Channelnumber: 0 to %d";
	static const char szDlgMsgLine005[]= "Area-overstepping (Omega)!";
	static const char szDlgMsgLine006[]= "Area-overstepping (Theta)!\n\nMinimum is invalid.";
	static const char szDlgMsgLine007[]= "Area-overstepping (Theta)!\n\nMaximum is invalid.";

	static const char szDlgMsgLine100[]= "File already exists !\r\nOverwrite ?";
	static const char szDlgMsgLine101[]= "Error, creating the file !";
	static const char szDlgMsgLine102[]= "Draw a line with the mouse.";
	static const char szDlgMsgLine103[]= "No Monitor";
	static const char szDlgMsgLine104[]= "Choose database-file";
#endif

//##############################################################################
// TSetupAreaScanDlg
//##############################################################################

TSetupAreaScanDlg::TSetupAreaScanDlg( TAreaScanWindow *aScan ) : TModalDlg( "AREASCANPARAMETERS", GetMainInstance() ), Areascan(0)
{
	//! einige Parameter vom AreaScan-fenster uebernehmen
	Areascan= aScan;
	nOmega= Areascan->nOmega;
	nTheta= Areascan->nTheta;
	//JP 12.08.2002	 nOldMotor= mlGetAxis();
	hDetectorList= 0;
	d2ThetaStart= Areascan->d2ThetaStart;
	//! o-t-offset aus AreaScanfenster holen
	dThetaOffset= Areascan->dOffsetTheta;
	dOmegaOffset= Areascan->dOffsetOmega;
	mlSetAxis( nTheta );
};
//*****************************************************************************

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TSetupAreaScanDlg::Dlg_OnInit( HWND, HWND hwndCtl, LPARAM lParam )
{
	CtrlSetDouble(id_2Theta, d2ThetaStart, mlGetDigits(nTheta), _DECIMAL); // 12.06.2003 hier wurde immer eine Nachkommastellengenauigkeit von 4 verwendet?!
	//! FIX Fehler 74
	if (!mlIsAxisValid(Theta))
	{
		Areascan->eScanType= stStandardScan;
		CtrlSetEnabled(id_2Theta, FALSE);
	}
	//! Werte fuer Checkboxen 'Save on Ready' und 'Using Absorber' setzen
	CheckDlgButton( GetHandle(), id_SaveOnReady, Areascan->bSaveOnReady );
	//! nur wenn absorber exist diesen ev. aktivieren
	if (mlIsAxisValid(Absorber))
		CheckDlgButton( GetHandle(), id_AbsorberUsed, Areascan->ReportUse.bAbsorber );
	//! diverse Werte in Dialogbox setzen
	CtrlSetDouble(id_MaxTime, Areascan->fMaxTime, _MAXTIMEDIGITS, _DECIMAL);
	//! Fehler id_ThetaUnit existiert nicht
	CtrlSetText(id_ThetaUnit, mlGetUnitName(nTheta));
	mlSetAxis( nOmega );
	CtrlSetText(id_Unit, mGetUnitName());
	CtrlSetDouble(id_AngleMin, Areascan->dOmegaMin, mlGetDigits(nOmega), _DECIMAL);
	CtrlSetDouble(id_AngleMax, Areascan->dOmegaMax, mlGetDigits(nOmega), _DECIMAL);
	CtrlSetLong(id_MaxCounts, Areascan->dwMaxCounts);
	CheckDlgButton( GetHandle(), id_Standard,
					Areascan->eSaveFormat == ffStandardFile );
	//	 CheckDlgButton( GetHandle(), id_DIB_Format, Areascan->eSaveFormat == Bitmap );
	CheckDlgButton( GetHandle(), id_SaveContinuous, Areascan->bSaveContinuous );
	//! FIX Fehler 38
	CtrlSetDouble(id_AngleWidth, Areascan->dOmegaWidth, mlGetDigits(nOmega)+1, _DECIMAL);
	CtrlSetText(id_Catalog, Areascan->szDataPath);
	CtrlSetDouble(id_Relation, Areascan->dMoveRelation, _RELATIONDIGITS, _DECIMAL);

	//! neu akk
	//! einstellen der Art der Darstellungsaktualisierung
	CheckDlgButton( GetHandle(), id_Final, !Areascan->bAccumulatedDisplay );
	CheckDlgButton( GetHandle(), id_Akkumulation, Areascan->bAccumulatedDisplay );

	//! aufnehmen aller verfuegbaren Detektoren in Combobox und vorauswahl des
	//! aktuell eingestellten Det.
	hDetectorList= GetDlgItem( GetHandle(), id_ChooseDetector );
	TDetectorManager::DetectorManager().FillDetectorComboBox( hDetectorList);
	ComboBox_SelectString( hDetectorList, 0 , Areascan->GetDetector()->GetCharacteristic() );

	//! aufnehmen aller verfuegbaren Detektoren in Combobox
	HWND hMonitorList= GetDlgItem( GetHandle(), id_ChooseMonitor );

	ComboBox_AddString( hMonitorList, szDlgMsgLine103 );
	TDetectorManager::DetectorManager().FillDetectorComboBox( hMonitorList);

	if (Areascan->GetMonitor() != 0)
		ComboBox_SelectString( hMonitorList, 0 , Areascan->GetMonitor()->GetCharacteristic() );
	else
		ComboBox_SelectString( hMonitorList, 0 , szDlgMsgLine103 );

	//! bewirkt aufruf von Dlg_OnCommand mit den Kommandos cm_ParamSet und
	//! cm_SetupParameters
	FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, SendMessage );
	FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, hwndCtl, 0, SendMessage );
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );

	// HotKey's fr Hilfe
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_SetupAreaScanDlg)) ); // Accelerator aus Ressourcen laden
	return TRUE;
};
//*****************************************************************************

//! behandelt Kommandos in der Dialogbox
void TSetupAreaScanDlg::Dlg_OnCommand( HWND, int id, HWND hwndCtl, UINT codeNotify )
{
	//! abhaengig von Dialogelement bzw. Kommando
	switch ( id )
	{
		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_SetupAreaScanDlg);
			break;

		//! initialisierung
		case cm_ParamSet:
			OnParamSet(GetHandle());
			break;

		//! 'Update Parameters'-Button betaetigt
		case cm_SetupParameters:
			FORWARD_WM_COMMAND( GetHandle(), cm_InquireRelevantData, hwndCtl, 0, SendMessage );
			FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, SendMessage );
			break;

		//! uebernehmen von einigen Dialogeintraegen ohne pruefung (fehler)
		//! 'Data Catalog','Save each Scan',Omegaschrittweite,Thetarelation,
		//! Speicherformat
		case cm_InquireRelevantData:
			OnInquireRelevantData();
			break;

		//! Detektor-auswahlbox angewaehlt
		case id_ChooseDetector:
			OnChooseDetector(GetHandle(), hwndCtl, codeNotify);
			break;

		case id_ChooseMonitor:
			OnChooseMonitor(codeNotify);
			break;

		//! 'Detector Settings'-Button betaetigt
		//! bewirkt Aufruf der zum eingestellten Detekt. gehoerigen Settingsbox
		//! und uebernahme der akt. Einstellungen ohne pruefung
		case cm_SpecificParameters:
			// spezifische Parameter fuer einen Sensor setzen
			if ( Areascan->GetDetector()->RunSpecificParametersDlg( Areascan->GetHandle() ) )
				FORWARD_WM_COMMAND( GetHandle( ), cm_ActivateChanges, 0, 0, PostMessage ); // Dialog in den Vordergrund verschieben
			else
				FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, SendMessage ); // Parameter aktualisieren und anzeigen
			break;

		//! FIX Fehler 74
		case id_FixThetaAxis:
			OnFixThetaAxis();
			break;

		//! anclicken der folgenden Dialogelemente bewirkt uebernahme der akt.
		//! Einstellungen ohne pruefung

		/*case id_DIB_Format:
		case id_Standard:
			FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, PostMessage );
			break;*/

		//! neu akk
		//! exclusives oder bei aktualisierungsoptionen
		case id_Akkumulation:
			CheckDlgButton(GetHandle(), id_Final, FALSE);
			break;

		case id_Final:
			CheckDlgButton(GetHandle(), id_Akkumulation, FALSE);
			break;

		//! FIX Fehler 71
		case id_SaveContinuous:
			CheckDlgButton(GetHandle(), id_SaveOnReady, FALSE);
			break;

		case id_SaveOnReady:
			CheckDlgButton(GetHandle(), id_SaveContinuous, FALSE);
			break;

		//! auswaehlen von absorberbenutz. nur eraubt wenn absorber exist.
		case id_AbsorberUsed:
			if (!mlIsAxisValid(Absorber))
			{
				MessageBox(szDlgMsgLine003, szDlgFailure, MBINFO);
				CtrlSetChecked(id_AbsorberUsed, FALSE);
			}
			break;

		default:
			TModalDlg::Dlg_OnCommand( GetHandle(), id, hwndCtl, codeNotify );
	}
};
//*****************************************************************************

void TSetupAreaScanDlg::OnParamSet(HWND)
{
	CtrlSetEnabled(cm_SpecificParameters, Areascan->GetDetector()->HasSpecificParametersDlg() );

	//! abhaengig vom Scantyp einige Dialogelemente sperren bzw. freigeben
	switch ( Areascan->eScanType )
	{
			case stOmega2ThetaScan:
				CtrlSetEnabled(id_Relation, TRUE );
				//! abhaengig ob PSD verfuegbar oder nicht Dialogelemente sperren
				//! bzw. freigeben
				//! FIX Fehler 53
				CheckDlgButton( GetHandle(), id_FixThetaAxis, FALSE );
				if ( Areascan->GetPsd() != 0 )
				{
					//! FIX Fehler 59
					CtrlSetEnabled(id_MaxCounts, FALSE);
					//! FIX Fehler 55
					CtrlSetEnabled(id_AbsorberUsed, TRUE );
					CtrlSetEnabled(id_FixThetaAxis, TRUE );
					CtrlSetEnabled(id_ThetaWidth, FALSE );
					CtrlSetEnabled(id_ThetaWindow, FALSE );
					Areascan->nAddedChannels= Areascan->GetPsd()->GetAddedChannels();
					CtrlSetDouble(id_ThetaWidth, Areascan->GetPsd()->GetWidth(), Areascan->GetPsd()->GetAngleStepDigits(), _DECIMAL); // 17.06.2003 hier wurde eine Nachkommastellengenauigkeit von 3 verwendet
					//! neu akk
					//! bei psd Darstellungsaktualisierungmodus erlaubt
					CtrlSetEnabled(id_Akkumulation, TRUE );
					CtrlSetEnabled(id_Final, TRUE );

				}
				else
				{
					//! FIX Fehler 59
					CtrlSetEnabled(id_MaxCounts, TRUE);
					//! FIX Fehler 55
					CtrlSetEnabled(id_AbsorberUsed, FALSE);
					CheckDlgButton(GetHandle(), id_AbsorberUsed, FALSE);
					//! FIX Fehler 53
					CtrlSetEnabled(id_FixThetaAxis, FALSE );
					CtrlSetEnabled(id_ThetaWindow, TRUE );
					CtrlSetEnabled(id_ThetaWidth, TRUE );
					CtrlSetDouble(id_ThetaWindow, Areascan->dThetaWindow, mlGetDigits(nTheta)+1, _DECIMAL);
					CtrlSetDouble(id_ThetaWidth, Areascan->dThetaWidth, mlGetDigits(nTheta)+1, _DECIMAL);
					//! neu akk
					//! bei 0-dim. detektor Darstellungsaktualisierungmodus nicht
					//! erlaubt
					CtrlSetEnabled(id_Akkumulation, FALSE );
					CtrlSetEnabled(id_Final, FALSE );
					CheckDlgButton( GetHandle(), id_Akkumulation , FALSE);
					CheckDlgButton( GetHandle(), id_Final , TRUE);
				}
				break;

			case stStandardScan:
				//! FIX Fehler 59
				CtrlSetEnabled(id_MaxCounts, FALSE);
				//! FIX Fehler 55
				CtrlSetEnabled(id_AbsorberUsed, TRUE );
				CheckDlgButton( GetHandle(), id_FixThetaAxis, TRUE );
				CtrlSetEnabled(id_FixThetaAxis, TRUE );
				CtrlSetEnabled(id_ThetaWindow, FALSE );
				CtrlSetEnabled(id_ThetaWidth, FALSE );
				CtrlSetEnabled(id_Relation, FALSE );

				Areascan->nAddedChannels= Areascan->GetPsd()->GetAddedChannels();
				CtrlSetDouble(id_ThetaWidth, Areascan->GetPsd()->GetWidth(), Areascan->GetPsd()->GetAngleStepDigits(), _DECIMAL);
				CtrlSetDouble(id_ThetaWindow, Areascan->dThetaWindow, mlGetDigits(nTheta)+1, _DECIMAL);
				//! neu akk
				//! bei psd Darstellungsaktualisierungmodus erlaubt
				CtrlSetEnabled(id_Akkumulation, TRUE );
				CtrlSetEnabled(id_Final, TRUE );
				break;

			default:
				MessageBox( szDlgMsgLine001, szDlgFailure, MBSTOP );
				break;
	}
};
//*****************************************************************************

void TSetupAreaScanDlg::OnInquireRelevantData()
{
	BOOL bValid= TRUE;
	CtrlGetText(id_Catalog, Areascan->szDataPath, MaxString);
	Areascan->bSaveContinuous= IsDlgButtonChecked( GetHandle(),
							id_SaveContinuous );
	// Bestimmen der Schrittweite und Schrittrelation
	Areascan->dOmegaWidth= CtrlGetDouble(id_AngleWidth, mlGetDigits(nOmega)+1, _DECIMAL, bValid);
	Areascan->dMoveRelation= CtrlGetDouble(id_Relation, _RELATIONDIGITS, _DECIMAL, bValid);
	//! uebernahme von Scantyp und abhaengig davon weitere werte
	switch ( Areascan->eScanType )
	{
		case stOmega2ThetaScan:
			if ( Areascan->GetPsd() != 0)
			{
				if ( IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ) )
				{
					Areascan->eScanType= stStandardScan;
					break;
				}
				CtrlSetDouble(id_ThetaWidth, Areascan->dMoveRelation * Areascan->dOmegaWidth, mlGetDigits(nTheta)+1, _DECIMAL);
			}
			else
			{
				Areascan->dThetaWindow= CtrlGetDouble(id_ThetaWindow, mlGetDigits(nTheta)+1, _DECIMAL, bValid);
				Areascan->dThetaWidth= CtrlGetDouble(id_ThetaWidth, mlGetDigits(nTheta)+1, _DECIMAL, bValid);
			}
			break;

		case stStandardScan:
			if ( !IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ) )
			{
				Areascan->eScanType= stOmega2ThetaScan;
				if ( Areascan->GetPsd() != 0)
				{
					CtrlSetDouble(id_ThetaWidth, Areascan->dMoveRelation * Areascan->dOmegaWidth, mlGetDigits(nTheta)+1, _DECIMAL);
				}
			}
			break;

		default:
			MessageBox( szDlgMsgLine001, szDlgFailure, MBSTOP );
	}
	Areascan->eSaveFormat= ffStandardFile;
	//!		  if ( IsDlgButtonChecked( GetHandle(), id_DIB_Format ) )
	//!				Areascan->eSaveFormat= Bitmap;
	//!		  if ( IsDlgButtonChecked( GetHandle(), id_Standard ) )
	//!				Areascan->eSaveFormat= StandardFile;
};
//*****************************************************************************

void TSetupAreaScanDlg::OnChooseDetector(HWND, HWND hwndCtl, UINT codeNotify )
{
	if ( codeNotify == CBN_SELCHANGE )
	{
		//! wenn neuer det. ausgewaehlt, dann diesen als aktuellen Det.
		//! setzen und neuinitialisierung (cm_ParamSet)
		int idx= ComboBox_GetCurSel( hDetectorList );

		if (idx == CB_ERR)
			return;

		TDetector* newDetector= TDetectorManager::DetectorManager().GetDetector(idx);

		if ( Areascan->GetDetector() != newDetector )
		{
			Areascan->SetDetector(newDetector);
			//! FIX Fehler 74
			if (Areascan->GetPsd() != 0)
			{
				Areascan->eScanType= stStandardScan;
			}
			else
			{
				if (mlIsAxisValid(Theta) == FALSE)
				{
					Areascan->SetDetector( TDetectorManager::DetectorManager().GetDetector( 0, 1) );
					ComboBox_SelectString( hDetectorList, 0, Areascan->GetDetector()->GetCharacteristic() );
				}
				else
				{
					Areascan->eScanType= stOmega2ThetaScan;
				}
			}
			FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, PostMessage );
		}
	}
};
//*****************************************************************************

void TSetupAreaScanDlg::OnFixThetaAxis()
{
	if (!mlIsAxisValid(Theta))
		CheckDlgButton(GetHandle(), id_FixThetaAxis, TRUE);

	//! 2thetawert bei fixierter Thetaachse vorgeben wenn Theta exist.
	if (IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ))
	{
		if (mlIsAxisValid(Theta))
		{
			double dPos;
			mlGetDistance(nTheta, dPos);
			CtrlSetDouble(id_2Theta, dPos, mlGetDigits(nTheta), _DECIMAL);
		}
		else
      CtrlSetText(id_2Theta, "  ");
	}
	FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, PostMessage );
};
//*****************************************************************************

void TSetupAreaScanDlg::OnChooseMonitor(UINT codeNotify )
{
	if ( codeNotify == CBN_SELCHANGE )
	{
		int idx= ComboBox_GetCurSel( GetDlgItem( GetHandle(), id_ChooseMonitor ) );

		if (idx == CB_ERR)
			return;

		// Ersten Eintrag "Kein Monitor" beruecksichtigen
		if (idx == 0)
		{
			Areascan->SetMonitor(0);
			return;
		}
		idx--;

		TDetector* newMonitor= TDetectorManager::DetectorManager().GetDetector( idx );
		if ( Areascan->GetDetector() != newMonitor )
			Areascan->SetMonitor(newMonitor);
	}
};
//*****************************************************************************

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode false wenn die Dialogbox nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TSetupAreaScanDlg::CanClose( void )
{
	char buf[ MaxString ];
	BOOL bValid= TRUE;
	float valueF;
	long valueL;
	BOOL bFailure= FALSE;
	//! lokale Wert fuer o-t-offset
	double dTO= dThetaOffset, dOO= dOmegaOffset;

	//! uebernehmen von einigen werten ohne pruefung
	FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, SendMessage );
	//! uebernahme der CheckButtons 'Save on Ready' und 'Using Absorber'
	Areascan->bSaveOnReady= IsDlgButtonChecked( GetHandle(), id_SaveOnReady );
	Areascan->ReportUse.bAbsorber= IsDlgButtonChecked( GetHandle(), id_AbsorberUsed );
	//! o-t-offset verwenden bzw. nicht verwenden
	switch (Areascan->eScanType)
	{
			case stStandardScan:
				dTO= 0.0;
				break;

			case stOmega2ThetaScan:
				dTO= dOO= 0.0;
				break;
	}
	//! Psd-spezifische parameter
	if (Areascan->GetPsd() != 0)
	{
		//! neu akk
		//! art der darstellungsaktualisierung an Scanfenster uebergeben
		Areascan->bAccumulatedDisplay= IsDlgButtonChecked( GetHandle(), id_Akkumulation );
	}

	//! uebernahme des Omega-Maximum mit Pruefung, ob der Wert kleiner als der
	//! maximal erlaubte
	//! wenn Wert nicht kleiner als der max. erlaubte dann auf
	//! Max.Wert-Schrittweite setzen + Setzen des korrekten Wertes fuer
	//! Theta-Window? (Fehler) + Box wird nicht verlassen
	valueF= CtrlGetDouble(id_AngleMax, mlGetDigits(nOmega), _DECIMAL, bValid);
	//! FIX Fehler 50,52
	if (!bValid) bFailure= TRUE;
	else if ( (valueF + dOO < mlGetValue( nOmega, MaxDistanceRel )) &&
			  (valueF + dOO > mlGetValue( nOmega, MinDistanceRel )))
		Areascan->dOmegaMax= valueF;
	else
	{
		Areascan->dOmegaMax= ( mlGetValue( nOmega, MaxDistanceRel ) -
							mlGetValue( nOmega, MinWidth ) );
		CtrlSetDouble(id_AngleMax, Areascan->dOmegaMax, mlGetDigits(nOmega), _DECIMAL);
		MessageBox(szDlgMsgLine005, szDlgMessage, MBINFO);
		CtrlSetFocus(id_AngleMax);
		bFailure= TRUE;
	}

	//! uebernahme des Omega-Minimum mit Pruefung, ob der Wert groesser als der
	//! maximal erlaubte
	//! wenn Wert nicht groesser als der max. erlaubte dann auf
	//! Min.Wert+Schrittweite setzen + Setzen des korrekten Wertes fuer
	//! Minimum + Box wird nicht verlassen
	valueF= CtrlGetDouble(id_AngleMin, mlGetDigits(nOmega), _DECIMAL, bValid);	
	//! FIX Fehler 50
	if (!bValid) bFailure= TRUE;
	else if ( (valueF + dOO < mlGetValue( nOmega, MaxDistanceRel )) &&
			( valueF + dOO > mlGetValue( nOmega, MinDistanceRel ) ))
		Areascan->dOmegaMin= valueF;
	else
	{
		Areascan->dOmegaMin= ( mlGetValue( nOmega, MinDistanceRel ) +
							mlGetValue( nOmega, MinWidth ) );
		CtrlSetDouble(id_AngleMin, Areascan->dOmegaMin, mlGetDigits(nOmega), _DECIMAL);
		MessageBox(szDlgMsgLine005, szDlgMessage, MBINFO);
		CtrlSetFocus(id_AngleMin);
		bFailure= TRUE;
	}
	//! FIX Fehler 50,52
	if (Areascan->dOmegaMin >= Areascan->dOmegaMax)
	{
		valueF= Areascan->dOmegaMax;
		Areascan->dOmegaMax= Areascan->dOmegaMin;
		CtrlSetDouble(id_AngleMax, Areascan->dOmegaMax, mlGetDigits(nOmega), _DECIMAL);
		Areascan->dOmegaMin= valueF;
		CtrlSetDouble(id_AngleMin, Areascan->dOmegaMin, mlGetDigits(nOmega), _DECIMAL);
		CtrlSetFocus(id_AngleMin);
		bFailure= TRUE;
	}

	//! 2theta aus Dialogbox wird fuer bereichsuebrschreitungstests gebraucht
	d2ThetaStart= CtrlGetDouble(id_2Theta, mlGetDigits(nTheta), _DECIMAL, bValid);
	if (!bValid) bFailure= TRUE;
	//!FIX Fehler 60
	switch (Areascan->eScanType)
	{
		case stOmega2ThetaScan:
			//! Relation ermitteln
			valueF= CtrlGetDouble(id_Relation, _RELATIONDIGITS, _DECIMAL, bValid);
			if (!bValid) bFailure= TRUE;
			else if ( valueF>0 ) 
				Areascan->dMoveRelation= valueF;
			else {
				Areascan->dMoveRelation= 2;
				CtrlSetDouble(id_Relation, Areascan->dMoveRelation, _RELATIONDIGITS, _DECIMAL);
				MessageBeep(0);
				CtrlSetFocus(id_Relation);
				bFailure= TRUE;
			}

				if ( Areascan->GetPsd() == 0 )
				{
					//! uebernahme des Theta-Window mit Pruefung, ob der
					//! Wert groesser 0 wenn nicht, setzen auf
					//! (OmegaMax-OmegaMin)*Relation + eintragen des
					//! entsprechenden Wertes in Dlg.Box + Box wird nicht
					//! verlassen
					valueF= CtrlGetDouble(id_ThetaWindow, mlGetDigits(nTheta)+1, _DECIMAL, bValid);
					//! FIX Fehler 50
					if (!bValid) bFailure= TRUE;
					else if ( valueF>0 )
						Areascan->dThetaWindow= valueF;
					else
					{
						Areascan->dThetaWindow= ( Areascan->dOmegaMax - Areascan->dOmegaMin ) *
											 Areascan->dMoveRelation;
						CtrlSetDouble(id_ThetaWindow, Areascan->dThetaWindow, mlGetDigits(nTheta)+1, _DECIMAL);
						MessageBeep(0);
						CtrlSetFocus(id_ThetaWindow);
						bFailure= TRUE;
					}

					//! uebernahme der Theta-Schrittweite mit Pruefung, ob der Wert ungleich 0
					//! (Fehler) wenn nicht, setzen auf OmegaSchrittweite*Relation + eintragen
					//! des entsprechenden Wertes in Dlg.Box + Box wird nicht verlassen
					valueF= CtrlGetDouble(id_ThetaWidth, mlGetDigits(nTheta)+1, _DECIMAL, bValid);
					//! FIX Fehler 50
					if (!bValid) bFailure= TRUE;
					else if ( valueF>0 )
						Areascan->dThetaWidth= valueF;
					else
					{
						Areascan->dThetaWidth= Areascan->dOmegaWidth * Areascan->dMoveRelation;
						CtrlSetDouble(id_ThetaWidth, Areascan->dThetaWidth, mlGetDigits(nTheta)+1, _DECIMAL);
						MessageBeep(0);
						CtrlSetFocus(id_ThetaWidth);
						bFailure= TRUE;
					}

					//! uebernahme der Messimpulse mit Pruefung, ob der Wert ungleich 0 (Fehler)
					//! wenn nicht, wird Box wird nicht verlassen
					valueL= CtrlGetLong(id_MaxCounts, bValid);
					//! FIX Fehler 50
					if (!bValid) bFailure= TRUE;
					else if ( valueL>0 )
						Areascan->dwMaxCounts= valueL;
					else {
						Areascan->dwMaxCounts= 1;
						CtrlSetLong(id_MaxCounts, Areascan->dwMaxCounts);
						MessageBeep(0);
						CtrlSetFocus(id_MaxCounts);
						bFailure= TRUE;          
					}				

					Areascan->ReportUse.bTime= FALSE;
					Areascan->ReportUse.bIntegral= FALSE;
					//! test ob Thetabereichsueberschreitung bei sld
					if (!bFailure)
					{
						valueF= d2ThetaStart - 0.5*Areascan->dThetaWindow;
						if ( ((valueF + dTO) <= mlGetValue(nTheta, MaxDistanceRel)) &&
							 ((valueF + dTO) >= mlGetValue(nTheta, MinDistanceRel)) )
						{
							Areascan->dThetaMin= valueF;
							//! Thetawinkel fuer letzten punkt des letzten spektrums
							//! ermitteln + test ob dieser wert gueltig
							valueF= d2ThetaStart + (Areascan->dOmegaMax - Areascan->dOmegaMin) *
									 Areascan->dMoveRelation + 0.5 * Areascan->dThetaWindow;

							if ( valueF + dTO <= mlGetValue(nTheta, MaxDistanceRel) )
								Areascan->d2ThetaStart= d2ThetaStart;
							else
							{
								char buf2[_MAXLENDOUBLE];
								Double2String(buf2, valueF, mlGetDigits(nTheta), FALSE, _DECIMAL);
								sprintf(buf, szDlgMsgLine007, buf2);
								MessageBox(buf, szDlgMessage, MBINFO);
								CtrlSetFocus(id_Relation);
								bFailure= TRUE;
							}
						}
						else
						{
							char buf2[_MAXLENDOUBLE];
							Double2String(buf2, valueF, mlGetDigits(nTheta), FALSE, _DECIMAL);
							sprintf(buf, szDlgMsgLine006, buf2);
							MessageBox(buf, szDlgMessage, MBINFO);
							CtrlSetFocus(id_2Theta);
							bFailure= TRUE;
						}

					}
				}
				else //! O2T-Scan mit Psd
				{
					//! test Thetabereichsueberschreitung O2T mit Psd
					if (!bFailure)
					{
						if ( ((d2ThetaStart + dTO) >= mlGetValue(nTheta, MinDistanceRel)) && 
							 ((d2ThetaStart + dTO) <= mlGetValue(nTheta, MaxDistanceRel)) )
						{
							Areascan->d2ThetaStart= d2ThetaStart;
							//! ermitteln des Thetawinkel fuer letztes Spektrum + test ob
							//! Bereichsueberschreitung
							valueF= d2ThetaStart + (Areascan->dOmegaMax - Areascan->dOmegaMin) *
									 Areascan->dMoveRelation;
							if ( ((valueF + dTO) >= mlGetValue(nTheta, MinDistanceRel)) &&
								 ((valueF + dTO) <= mlGetValue(nTheta, MaxDistanceRel)) )
							{
								Areascan->dThetaMax= valueF;								Areascan->dThetaMin= d2ThetaStart;
							}
							else
							{
								char buf2[_MAXLENDOUBLE];
								Double2String(buf2, valueF, mlGetDigits(nTheta), FALSE, _DECIMAL);
								sprintf(buf, szDlgMsgLine007, buf2);
								MessageBox(buf, szDlgMessage, MBINFO);
								CtrlSetFocus(id_Relation);
								bFailure= TRUE;
							}
						}
						else
						{
							char buf2[_MAXLENDOUBLE];
							Double2String(buf2, d2ThetaStart, mlGetDigits(nTheta), FALSE, _DECIMAL);
							sprintf(buf, szDlgMsgLine006, buf2);
							MessageBox(buf, szDlgMessage, MBINFO);
							CtrlSetFocus(id_2Theta);
							bFailure= TRUE;
						}

					}
					//! bei Psd diese infos immer anlegen
					Areascan->ReportUse.bTime= TRUE;
					Areascan->ReportUse.bIntegral= TRUE;

				}
				break;

			case stStandardScan:  //! bei Psd diese infos immer anlegen
				Areascan->ReportUse.bTime= TRUE;
				Areascan->ReportUse.bIntegral= TRUE;

				//! test Thetabereichsueberschreitung StandardScan
				if (!bFailure)
					//! test ob Theta exist. wenn ja wert testen+ ev.uebernehmen
					//! sonst nicht
					if ( mlIsAxisValid(Theta) )
						if ( (d2ThetaStart >=mlGetValue(nTheta, MinDistanceRel)) && 
							 (d2ThetaStart <=mlGetValue(nTheta, MaxDistanceRel)) )
						{
							Areascan->dThetaMin= d2ThetaStart;
							Areascan->dThetaMax= d2ThetaStart;
							Areascan->d2ThetaStart= d2ThetaStart;
						}
						else
						{
							char buf2[_MAXLENDOUBLE];
							Double2String(buf2, d2ThetaStart, mlGetDigits(nTheta), FALSE, _DECIMAL);
							sprintf(buf, szDlgMsgLine006, buf2);
							MessageBox(buf, szDlgMessage, MBINFO);
							CtrlSetFocus(id_2Theta);
							bFailure= TRUE;
						}
				break;
	}
	//! wenn bis hier schon Fehlern aufgetretenen sind: cm_ParamSet senden und Dialogbox nicht schliessen
	if ( bFailure )
	{
		PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0l );
		return FALSE;
	}

	//! uebernahme der Messzeit mit Pruefung, ob der Wert ungleich 0
	//! wenn nicht, wird Box wird nicht verlassen
	valueF= CtrlGetDouble(id_MaxTime, _MAXTIMEDIGITS, _DECIMAL, bValid);
	//! FIX Fehler 50
	if (!bValid) bFailure= TRUE;
	else if ( valueF>0.0 )
		Areascan->fMaxTime= valueF;
	else {
		Areascan->fMaxTime= 0.1f;
		CtrlSetDouble(id_MaxTime, Areascan->fMaxTime, _MAXTIMEDIGITS, _DECIMAL);
		MessageBeep(0);
		CtrlSetFocus(id_MaxTime);
		bFailure= TRUE;
	}

	//! uebernahme des Datenpfades, wenn er sich beschreiben laesst
	//! ansonsten auf "C:\\" setzen + Box wird nicht verlassen
	CtrlGetText(id_Catalog, Areascan->szDataPath, MaxString);
	if ( !PathCanWrite(Areascan->szDataPath) ) {
		strcpy( Areascan->szDataPath, "c:\\" );
		//! FIX Fehler 38
		CtrlSetText(id_Catalog, Areascan->szDataPath);
		CtrlSetFocus(id_Catalog);
		MessageBeep(0);
		bFailure= TRUE;
	}

	//! FIX Fehler 38,51
	valueF= CtrlGetDouble(id_AngleWidth, mlGetDigits(nOmega)+1, _DECIMAL, bValid);
	if (!bValid) bFailure= TRUE;
	else if ( valueF>=mGetValue(MinWidth) )
		Areascan->dOmegaWidth= valueF;
	else
	{
		Areascan->dOmegaWidth= mGetValue(MinWidth);
		CtrlSetDouble(id_AngleWidth, Areascan->dOmegaWidth, mlGetDigits(nOmega)+1, _DECIMAL);
		MessageBeep(0);
		CtrlSetFocus(id_AngleWidth);
		bFailure= TRUE;
	}	

	//! wenn bisher keine fehler auftraten diverse werte an Areasanfenster
	//! uebergeben
	if ( !bFailure)
	{
		//! Offsetwerte uebernehmen
		Areascan->dOffsetOmega= dOO;
		Areascan->dOffsetTheta= dTO;
		Areascan->dPsdOffset= 0;
		Areascan->nMeasurementChannel= 0;
		//! gewollte zusatzinfos
		Areascan->ReportUse.bAbsorber= IsDlgButtonChecked( GetHandle(), id_AbsorberUsed );
	}

	//! bei aufgetretenen Fehlern cm_ParamSet senden und Dialogbox nicht
	//! schliessen
	if ( bFailure )
	{
		PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0l );
		return FALSE;
	}

	return TRUE;
};

//#############################################################################
// TAquisitionDlg
//#############################################################################

TAquisitionDlg::TAquisitionDlg( TAreaScanWindow *aScan ) : TModalDlg( "AQUISITION", GetMainInstance() )
{
	Areascan= aScan;
	Areascan->bAquisitionActive= FALSE;
};
//*****************************************************************************

//! eintragen von Defaultwerten fuer alle Elemente bei Aufruf der Dlg.Box
//! rueckkehrcode immer true
BOOL TAquisitionDlg::Dlg_OnInit( HWND, HWND hwndCtl, LPARAM lParam )
{
	//! Anzahl der Messpunkte
	CtrlSetLong(id_LinePoints, Areascan->nLinePoints);
	//! Umgebung
	CtrlSetLong( id_AddedPoints, Areascan->nEnvironment );
	CtrlSetText( id_FileName, Areascan->DataFile );
	//! ?
	CheckDlgButton( GetHandle(), id_DX, Areascan->bSetDXZero );
	CheckDlgButton( GetHandle(), id_DY, Areascan->bSetDYZero );
	CheckDlgButton( GetHandle(), id_RL, Areascan->bSetRLSave );
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );
	return TRUE;
};
//*****************************************************************************

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor Verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode false wenn die Dialogbox nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TAquisitionDlg::CanClose( void )
{
	int value;
	OFSTRUCT of;
	int hFile;
	BOOL bValid= TRUE;

	//! Werte der CheckBoxen uebernehmen wenn nicht beide markiert, sonst 'dX=0'
	//! auf unmarkiert setzen, CheckButtons neu setzen und Box nicht verlassen
	Areascan->bSetDXZero= IsDlgButtonChecked( GetHandle(), id_DX );
	Areascan->bSetDYZero= IsDlgButtonChecked( GetHandle(), id_DY );
	Areascan->bSetRLSave= IsDlgButtonChecked( GetHandle(), id_RL );
	if ( Areascan->bSetDXZero * Areascan->bSetDYZero )
	{
		Areascan->bSetDXZero= !Areascan->bSetDYZero;
		CheckDlgButton( GetHandle(), id_DX, Areascan->bSetDXZero );
		CheckDlgButton( GetHandle(), id_DY, Areascan->bSetDYZero );
		return FALSE;
	}
	//! uebernehmen der 'Umgebung', wenn Wert im Bereich von 0 bis 3 liegt, sonst
	//! Wert auf entsprechende Grenze setzen + Wert in Box eintragen + Box nicht
	//! verlassen
	value= CtrlGetLong( id_AddedPoints, bValid );
	Areascan->nEnvironment= max( 0, min( 3, value ) );
	if (!bValid) return FALSE;
	else if ( value!=Areascan->nEnvironment )
	{
		CtrlSetLong( id_AddedPoints, Areascan->nEnvironment );
		MessageBeep(0);
		CtrlSetFocus(id_AddedPoints);
		return FALSE;
	}
	//! uebernehmen der 'Messpunkte', wenn Wert im Bereich von 0 bis 1100 liegt,
	//! sonst Wert auf entsprechende Grenze setzen + Wert in Box eintragen + Box
	//! nicht verlassen
	value= CtrlGetLong( id_LinePoints, bValid );
	Areascan->nLinePoints= max( 0, min( 1100, value ) );
	if (!bValid) return FALSE;
	else if ( value!=Areascan->nLinePoints )
	{
		CtrlSetLong( id_LinePoints, Areascan->nLinePoints );
		MessageBeep(0);
		CtrlSetFocus(id_LinePoints);
		return FALSE;
	}
	//! Test, ob angeg. Datei bereits existiert + evtl. Fehlermeldung
	//! anlegen der Datei
	CtrlGetText( id_FileName, Areascan->DataFile, MaxString );
	// Testen, ob sich das File auch erzeugen laesst
	if ( OpenFile( Areascan->DataFile, &of, OF_EXIST )!=HFILE_ERROR )
	{
		if ( IDYES == MessageBox( szDlgMsgLine100, szDlgMessage, MBASK ) )
			goto Exit;
		else
			return FALSE;
	}

	//! Fehlermeldung bei Problemen beim Anlegen der Datei
	hFile= OpenFile( Areascan->DataFile, &of, OF_CREATE );
	if ( hFile == HFILE_ERROR )
	{
		MessageBox( szDlgMsgLine101, szDlgMessage, MBINFO );
		return FALSE;
	}
	else
		_lclose(hFile);
	//!	 remove( DataFile );

	//! wenn alles erfolgreich Marke setzen + Info + DataAquisiton auf true
	//!setzen
Exit:
	Areascan->bAquisitionActive= TRUE;
	SetInfo( szDlgMsgLine102 );

	return TRUE;
};

//##############################################################################
// TChooseScanDlg
//##############################################################################

TChooseScanDlg::TChooseScanDlg( TAreaScanWindow *aScan, TModelessDlg **aRef ) : TModelessDlg( "CHOOSESCAN", aRef, GetMainInstance() ), InfoField(0, 0), Report(0), Report2(0), BarHandle(0), hInfoList(0)
{
	Areascan= aScan;
	Report= Areascan->ScanReport;
	Report2= Areascan->ScanReport2;
	nMaxScan= nInfoNumber= 0;
};
//*****************************************************************************

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TChooseScanDlg::Dlg_OnInit( HWND, HWND hwndCtl, LPARAM )
{
	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	scrInfo.fMask= SIF_RANGE;
	//! 1.zusatzinfo auf Detektortyp setzen
	nInfoNumber= 0;
	//! anzahl der Kurven eintragen + Scrollbar initialisieren
	nMaxScan= lpDBase->GetCNumber() - 1;
	CtrlSetLong(id_Limit, nMaxScan);
	BarHandle= GetDlgItem( GetHandle(), id_Bar );

	scrInfo.nMin= 0;
	scrInfo.nMax= nMaxScan;
	SetScrollInfo(BarHandle,SB_CTL,&scrInfo,TRUE);

	//! alle zur datenbasis verfuegbaren Infos in combobox eintragen
	hInfoList= GetDlgItem( GetHandle() , id_ChooseInfo );
	ComboBox_AddString( hInfoList , szInfoType0 );
	InfoField.Append(0);
	if (Areascan->ReportUse.bIntegral == TRUE)
	{
		ComboBox_AddString( hInfoList , szInfoType1 );
		InfoField.Append(1);
	}
	if (Areascan->ReportUse.bAbsorber == TRUE)
	{
		ComboBox_AddString( hInfoList , szInfoType2 );
		InfoField.Append(2);
	}
	if (Areascan->ReportUse.bMonitor == TRUE)
	{
		ComboBox_AddString( hInfoList , szInfoType3);
		InfoField.Append(3);
	}
	if (Areascan->ReportUse.bTime == TRUE)
	{
		ComboBox_AddString( hInfoList , szInfoType4 );
		InfoField.Append(4);
	}
	ComboBox_SelectString( hInfoList, 0 , szInfoType0 );

	FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, SendMessage );
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );
	return TRUE;
};
//*****************************************************************************

//! behandelt Kommandos in der Dialogbox
void TChooseScanDlg::Dlg_OnCommand( HWND, int id, HWND hwndCtl,
									UINT codeNotify )
{
	BOOL bValid= TRUE;
	char buf[ MaxString ];
	float x, y, fIntegral, fPeakPos, fMonitor, fAbsorber, fTime, fdummy;

	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	scrInfo.fMask= SIF_POS;

	switch ( id )
	{
		//! Update-Button gedrueckt
		case id_CurveShow:
			//! Scannummer aus Dialogbox holen + diese Darstellen
			lpDBase->SetCurveIdx( CtrlGetLong(id_ScanNumber, bValid) );
			FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, SendMessage );
			break;

		//! aktualisieren
		case cm_ParamSet: {
			//! aktuelle Kurve in Maincurve + Dialogboxeintraege eintragen +
			//! Fenster neuzeichnen
			Areascan->nActiveScan= lpDBase->GetCurveIdx();
			Areascan->MainCurve= lpDBase->GetCurve( Areascan->nActiveScan );
			CtrlSetLong(id_ScanNumber, Areascan->nActiveScan);
			scrInfo.nPos= nMaxScan - Areascan->nActiveScan;
			SetScrollInfo(BarHandle,SB_CTL,&scrInfo,TRUE);
			Report->SetPP( Areascan->nActiveScan );
			Report->PGet( x, y, fIntegral );
			Report2->SetPP( Areascan->nActiveScan );
			Report2->PGet( fTime, fMonitor, fAbsorber);
			//! FIX Fehler 42
			CtrlSetDouble(id_Omega, x, 3, _DECIMAL);
			TCurve *Curve= Areascan->MainCurve;
			CtrlSetDouble(id_PeakIntensity, Curve->GetMax( 1 ), 1, _DECIMAL);

			//! je nach ausgewhltem Combobox-eintrag den zugehrigen Infowert eintragen
			Curve->GetGravityCenter(fPeakPos, fdummy, fdummy);
			if (Areascan->VisualDB.bPsd)
				fPeakPos= y + fPeakPos;
			CtrlSetDouble(id_PeakPosition, fPeakPos, 3, _DECIMAL);
			switch (nInfoNumber)
			{
				case 0:
					if (Areascan->VisualDB.bPsd)
						sprintf( buf, "Psd");
					else
						sprintf( buf, "0-dim.");
					break;

				case 1:
					sprintf( buf, "%.1f", fIntegral);  //! integrale Intens.
					break;

				case 2:
					sprintf( buf, "%.3f", fAbsorber);  //! Absorber
					break;

				case 3:
					sprintf( buf, "%.1f", fMonitor);  //! Monitor
					break;

				case 4:
					sprintf( buf, "%.3f", fTime);  //! Zeit
					break;

				default:
					sprintf( buf, "????");
			};
			CtrlSetText(id_Info, buf);

			//! Kurve im Hintergrund neu zeichnen
			Areascan->UpdateWnd();
			break;
		}
		
		case id_ChooseInfo: //! auswaehlen einer anderen Zusatzinfo
			if ( codeNotify==CBN_SELCHANGE ) { //! wenn neue info ausgewaehlt, dann diesen ins nachbarfeld(in cm_ParamSet
				nInfoNumber= InfoField[ ComboBox_GetCurSel(hInfoList) ];
				FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, SendMessage );
			};
			break; //Fehler? Kullmann+Reinecker: Fehlt hier vielleicht ein break?

		//! behandelt OK und Abbruch
		default:
			TModelessDlg::Dlg_OnCommand( GetHandle(), id, hwndCtl, codeNotify );
	}
};
//*****************************************************************************

//! wird aufgerufen, wenn in der Dialogbox die linke Maustaste nach Druecken
//! wieder losgelassen wird (sinnvoll wenn Dialogbox waehrend eines Areascans
//! aktiv ist)
void TChooseScanDlg::Dlg_OnLButtonUp( HWND, int, int, UINT )
{
	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	scrInfo.fMask= SIF_RANGE;
	//! aktualisiert Anzahl der Scans der Datenbasis + anpassen des Scrollbar
	nMaxScan= lpDBase->GetCNumber() - 1;
	CtrlSetLong(id_Limit, nMaxScan);
	BarHandle= GetDlgItem( GetHandle(), id_Bar );

	scrInfo.nMin= 0;
	scrInfo.nMax= nMaxScan;
	SetScrollInfo(BarHandle,SB_CTL,&scrInfo,TRUE);
	FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, 0, 0, SendMessage );
};
//*****************************************************************************

//! wird aufgerufen, wenn Scrollbar angeclickt wurde
void TChooseScanDlg::Dlg_OnVScrollBar( HWND, HWND hwndCtl, UINT code,
									   int pos )
{
	switch ( code )
	{
		case SB_LINEUP://! Klick auf oberen Pfeil
			lpDBase->SetCurveIdx( Areascan->nActiveScan + 1 );
			break;
			
		case SB_LINEDOWN://! Klick auf unteren Pfeil
			lpDBase->SetCurveIdx( Areascan->nActiveScan - 1 );
			break;

		case SB_THUMBPOSITION://! anclicken + bewegen des Scrollschiebers
			lpDBase->SetCurveIdx( nMaxScan - pos );
			break;

		case SB_PAGEUP://! anklicken oberhalb des schiebers
			lpDBase->SetCurveIdx( Areascan->nActiveScan + 10 );
			break;

		case SB_PAGEDOWN://! anklicken unterhalb des schiebers
			lpDBase->SetCurveIdx( Areascan->nActiveScan - 10 );
			break;

		case SB_ENDSCROLL://! Skrolling ist beendet, Daten nun anzeigen
			FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, 0, 0, SendMessage );
			break;
	}
};
//*****************************************************************************

//! wird aufgerufen beim druecken des OK-Buttons
//! Rueckkehrcode immer true
BOOL TChooseScanDlg::CanClose( void )
{
	return TRUE;
};

//##############################################################################
// TComposeDBDlg
//##############################################################################

TComposeDBDlg::TComposeDBDlg( TAreaScanWindow *aScan ) : TModalDlg( "COMPOSEDATABASE", GetMainInstance() )
{
	//! sichern aktueller Werte fuer Dateinamen und Dateianzahl
	Areascan= aScan;
	strcpy( oldFirstFile, Areascan->FirstFile );
	strcpy( oldLastFile, Areascan->LastFile );
	oldMaxFiles= Areascan->MaxFiles;
};
//*****************************************************************************

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TComposeDBDlg::Dlg_OnInit(HWND, HWND hwndCtl, LPARAM lParam)
{
	//! Eintraege in Dialogbox setzen fuer Dateinamen und Dateizahl
	CtrlSetText(cm_StartFile, oldFirstFile);
	CtrlSetText(id_LastFile, oldLastFile);
	CtrlSetLong(id_NumberSpectrum, oldMaxFiles);
	//! wenn Dateizahl 0 deaktivieren des Eingabefeldes
	if ( oldMaxFiles == 0 ) CtrlSetEnabled(id_NumberSpectrum, FALSE );
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );
	return TRUE;
};
//*****************************************************************************

//! behandelt alle kommandos der Dialogbox
void TComposeDBDlg::Dlg_OnCommand(HWND, int id, HWND hwndCtl, UINT codeNotify)
{
	HFILE hFile;
	OFSTRUCT of;
	char buf[ MaxString ], FileName[ MaxString ];
	int counter= 0, oldcounter= 0;
	char drive[ _MAX_DRIVE+1 ], path[ _MAX_DIR+1 ], name[ _MAX_FNAME+1 ], ext[ _MAX_EXT+1 ];

	switch ( id )
	{
		case cm_StartFile://! Start-Datei-Button gedrueckt
			//! ins Arbeitverzeichnis wechseln + 'Datei nachladen'-Dialog oeffnen + Dateinamen prfen
			char NewFilename[ _MAX_PATH ];
			strcpy( NewFilename, "*.crv" ); // Fehler? warum *.crv beim AreaScan
			_chdir( Areascan->szDataPath );
			if ( !FileOpenDialog( szDlgMsgLine104, "", NewFilename, Areascan->szDataPath ) ) return; // 'Abbruch' geklickt
			if ( strlen(NewFilename)==0 || strcmp(NewFilename, "*")==0 ) return;

			//! nach Auswahl des Dateinamen bestimmen der maximalen Anzahl
			//! zusammenfassbarer Spektren abhaengig von fortlaufendem Vorhandensein
			//! der entsprechenden Dateien
			//! zunaechst: Bestimmung des Dateinamens(ohne Numerierung)
			_splitpath( NewFilename, drive, path, name, ext );
			counter= oldcounter= atoi( &name[ max(0, strlen(name)-4) ] );
			strcpy( buf, name );
			buf[ max(0, strlen(name)-4) ]= '\0';
			strcpy( Areascan->DismantleFile, buf );
			strcpy( oldFirstFile, name );
			strcat( oldFirstFile, ext );
			SetWindowText( GetDlgItem( GetHandle(), cm_StartFile ), oldFirstFile );
			hFile= OpenFile( oldFirstFile, &of, OF_READ );
			//! fortlaufender Test auf vorhandene Dateien
			do
			{
				_lclose( hFile );
				strcpy( oldLastFile, name );
				strcpy(buf, "");
				sprintf( buf, "%.4d", counter++ );
				strcpy( name, Areascan->DismantleFile );
				strcat( name, buf );
				_makepath( FileName, drive, path, name, ext );
				hFile= OpenFile( FileName, &of, OF_READ );
			} while ( hFile!=HFILE_ERROR );
			//! Eintragen von Dateizahl, Start- , End-Datei in Dialogbox
			CtrlSetLong(id_NumberSpectrum, counter - oldcounter - 1);
			strcat( oldLastFile, ext );
			CtrlSetText(id_LastFile, oldLastFile );
			oldMaxFiles= counter - oldcounter - 1;
			CtrlSetEnabled(id_NumberSpectrum, TRUE );
			break;

		default://! behandelt IDOK, IDCANCEL
			TModalDlg::Dlg_OnCommand( GetHandle(), id, hwndCtl, codeNotify );
	}
};
//*****************************************************************************

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
//! der Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
//! (Werte inkonsistent) sonst true
BOOL TComposeDBDlg::CanClose()
{
	BOOL result= TRUE;
	BOOL bValid= TRUE;
	char buf[ _MAX_PATH+1 ];
	int counter;

	//! auslesen der Spektrenzahl, event. Korrektur, wenn Wert zu gross bzw. klein
	int valueI= CtrlGetLong(id_NumberSpectrum, bValid);
	if (!bValid) result= FALSE; // Wert konnte nicht ausgelesen werden
	else if ( valueI!=oldMaxFiles )
	{
		if ( (valueI<=oldMaxFiles) && (valueI >= 1) )
		{
			oldMaxFiles= valueI;
			strcpy( buf, oldLastFile );
			buf[ max(0, strlen(buf)-8) ]= '\0';
			strcpy( oldLastFile, buf );
			counter= atoi( &oldFirstFile[ max(0, strlen(oldFirstFile)-8) ] );
			sprintf( buf, "%.4d", counter + oldMaxFiles - 1 );
			strcat( oldLastFile, buf );
			strcat( oldLastFile, ".CRV" );
		}
		//! setzen der neuen Eintraege
		CtrlSetText(id_LastFile, oldLastFile );
		CtrlSetLong(id_NumberSpectrum, oldMaxFiles);
		CtrlSetFocus(id_NumberSpectrum);
		result= FALSE;
	}
	else 
	{
		//! uebergeben der neuen Werte an das AreaScan-Fenster
		Areascan->MaxFiles= oldMaxFiles;
		CtrlGetText(cm_StartFile, Areascan->FirstFile, _MAX_PATH);
		CtrlGetText(id_LastFile, Areascan->LastFile, _MAX_PATH);
	}
	return result;
};

//##############################################################################
// TDismantleDBDlg
//##############################################################################

TDismantleDBDlg::TDismantleDBDlg( TAreaScanWindow *scan ) : TModalDlg( "DISMANTLEDATABASE", GetMainInstance() ), Areascan(0)
{
	//! Einlesen der Id's in Feld-Variablen zur komfortableren Nutzung
	Areascan= scan;
};
//*****************************************************************************

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TDismantleDBDlg::Dlg_OnInit(HWND, HWND hwndCtl, LPARAM lParam)
{
	//! setzen des Datenpfades
	CtrlSetText(id_Catalog, Areascan->szDataPath);
	strcpy(Areascan->DismantleFile, "");
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );
	return TRUE;
};
//*****************************************************************************

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
//! der Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
//! (Werte inkonsistent) sonst true
BOOL TDismantleDBDlg::CanClose()
{
	BOOL retval= TRUE;

	CtrlGetText(id_Catalog, Areascan->szDataPath, MaxString);
	//! Testen, ob sich der Pfad auch beschreiben laesst
	if ( Areascan->szDataPath[ max(0, strlen(Areascan->szDataPath)-1) ] != '\\' )
		strcat( Areascan->szDataPath, "\\" );
	if ( !PathCanWrite(Areascan->szDataPath) ) {
		strcpy( Areascan->szDataPath, "c:\\" );
		CtrlSetText(id_Catalog, Areascan->szDataPath);
		CtrlSetFocus(id_Catalog);
		MessageBeep(0);
		retval= FALSE;
	}
	//! Dateinamen auslesen und auf Laenge <5 testen
	//! sonst nur erste 4 Zeichen nehmen und Dialogbox bleibt geoeffnet
	if (retval)
	{
		CtrlGetText(id_FileName, Areascan->DismantleFile, MaxString );
		if ( strlen( Areascan->DismantleFile ) > 4 )
		{
			char buf[ MaxString ];
			strcpy( buf, Areascan->DismantleFile );
			buf[4]= '\0';
			strcpy( Areascan->DismantleFile, buf );
			CtrlSetText(id_FileName, buf );
			retval= FALSE;
		}
	}
	return retval;
};