//##############################################################################
//                                                                            //
// S_EXTERN.CPP                                                               //
//                                                                            //
// Subsystem: Diffraktometrie/ Reflektometrie                                 //
//            DAS MDI-Fenster fr Continious-, Step- und DynamicStepScan      //
// Benutzung durch andere Subsysteme erforderlich: JA                         //
//                                                                            //
//##############################################################################
//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI

#include <direct.h>

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include "help\help_def.h"     // Help-IDs
#pragma hdrstop

#include "difrkmty\s_extern.h" // SCHNITTSTELLE fr diese Datei
#include "difrkmty\s_intern.h" // TSetupContinuousScanDlg, TSetupStepScanDlg, TSetupDynamicStepDlg

#include "datavisa\datavisa.h"
#include "detecuse\detecuse.h"
#include "motrstrg\motrstrg.h"
#include "workflow\workflow.h"

//! neu: klier Allgemeine Einstellungen
#include "mespara\mespara.h" 
//! neu: klier Protokollbuch
#include "protocol\protocol.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//##############################################################################
// externe Abhngigkeiten
//##############################################################################

extern TMain Main; // in M_MAIN.CPP deklariertes Hauptprogramm
extern TSteering Steering; // in M_STEERG.CPP

//! neu: klier Allgemeine Einstellungen
extern TMeasurementParameter MeasurementParameter; // in M_MAIN.CPP

#define ContinuousScanCapability
//17.07.2003 #define WRITE OF_WRITE

//#############################################################################
// sprachspezifische Konstanten
//#############################################################################

#ifdef GermanVersion
	static const char szTitle[]= "LineScan: ";
	static const char szMessageScan[]= "Meldung";
	static const char szMsgFailureScan[]= "Fehler";
	static const char szMsgLine101[]= "Einen Standard-Scan mit %s\r\nBereich (%s >> %s) \r\nstarten ?";
	static const char szMsgLine102[]= "Einen Omega2Theta-Scan mit Omega\nvon %s bis %s starten ?";
	static const char szMsgLine103[]= "%smit Omega von %s bis %s starten ?";
	static const char szMsgLine104[]= "Einen kontinuierlichen Scan mit %s\nvon %s nach %s starten ?";
	static const char szMsgLine105[]= "Es ist ein Fehler aufgetreten. %d";
	static const char szMsgLine106[]= "Die Messung wurde abgeschlossen \nund gespeichert.";
	static const char szMsgLine107[]= "Die Messung wurde abgeschlossen. Fehler beim Speichern.";
	static const char szMsgLine108[]= "Header ist nicht korrekt";
	static const char szMsgLine109[]= "Datei existiert nicht !";
	static const char szMsgLine110[]= "Alte Datendatei laden ...";
	static const char szMsgLine111[]= "Datei wurde nicht geoeffnet !";
	static const char szMsgLine112[]= "Punkte : %d";
	static const char szMsgLine113[]= "Die Messung wurde abgeschlossen.";
	static const char szMsgLine114[]= "Bereiche : %d";
	static const char szMsgLine115[]= "Start Scan";
	static const char szMsgLine116[]= "Anfahren der Startposition";
	static const char szMsgLine117[]= "Anfahren der letzten Position";
	static const char szMsgLine118[]= "Bereich von %f bis %f  Intensitt %f";
	static const char szMsgLine119[]= "Messung wurde unterbrochen !";
	static const char szMsgLine120[]= "Scanachse ???"; // max. _MAXLENUNIT-Zeichen
	static const char szMsgLine121[]= "kontinuierlichen &Scan starten";
	static const char szMsgLine122[]= "Step&Scan starten";
	static const char szMsgLine123[]= "Die Messung wurde abgebrochen !";

	//! neu: klier Protokollbuch
	static const char szMsgLine133[]= "Soll die Messung im Protokollbuch gespeichert werden?";

	static const char szAngleUnit[]= "Winkel von %s\nin %s";
	static const char szAngleUnitEZ[]= "Winkel von %s";
#else
	static const char szTitle[]= "LineScan: ";
	static const char szMessageScan[]= "Message";
	static const char szMsgFailureScan[]= "Failure";
	static const char szMsgLine101[]= "Execute Scan with %s\r\nfrom %s to %s ?";
	static const char szMsgLine102[]= "Do you want to start a Omega2Theta-Scan\n with Omega from %s to %s ?";
	static const char szMsgLine103[]= "%swith Omega from %s to %s ?";
	static const char szMsgLine104[]= "Do you want to start a continuous Scan with %s\n from %s to %s ?";
	static const char szMsgLine105[]= "There is a failure appeared. %d";
	static const char szMsgLine106[]= "The Measurement is completed\nand the data were saved.";
	static const char szMsgLine107[]= "The Measurement is completed.\nFailure on saving data.";
	static const char szMsgLine108[]= "Incorrect Header.";
	static const char szMsgLine109[]= "File not exist ! ";
	static const char szMsgLine110[]= "Load old Datafile ...";
	static const char szMsgLine111[]= "File not opened !";
	static const char szMsgLine112[]= "Points : %d";
	static const char szMsgLine113[]= "The Measurement is completed.";
	static const char szMsgLine114[]= "Areas : %d";
	static const char szMsgLine115[]= "Starting Scan";
	static const char szMsgLine116[]= "Move to Startposition";
	static const char szMsgLine117[]= "Move to last position";
	static const char szMsgLine118[]= "Area from %f to %f  intensity %f";
	static const char szMsgLine119[]= "The Measurement was interrupted !";
	static const char szMsgLine120[]= "Scanaxis ???";
	static const char szMsgLine121[]= "start Continuous&Scan";
	static const char szMsgLine122[]= "start Step&Scan";
	static const char szMsgLine123[]= "The measurement was stoped !";

	//! neu: klier Protokollbuch
	static const char szMsgLine133[]= "Soll die Messung im Protokollbuch gespeichert werden?";

	static const char szAngleUnit[]= "angles of %s\nin %s";
	static const char szAngleUnitEZ[]= "angles of %s";
#endif

//##############################################################################
// TScanParameters
//##############################################################################

//! einlesen der Ini-daten zu [Scan] und setzen von default-werten fuer StepScan
//! wird nur durch TScanWindow-konstruktor aufgerufen
TScanParameters::TScanParameters() : Scaler(2*nMaxScaleIdx, 0.0), Detector(0), Monitor(0)
{
	char Param[ MaxString ];
	char buf[ MaxString ];
	int idx, mid= mlGetAxis();

	Detector= TDetectorManager::DetectorManager().GetDetector(0, 0);

	//! testet ob Omega-Motor angeschlossen ist
	//! wenn ja => akt.Motor Omega setzen
	//! wenn nein => akt. Motor
	if ( mlIsAxisValid( Omega ) )
	{
		nMotor= mlGetIdByName( Omega );
		mlSetAxis( nMotor );
	}
	else
		nMotor= mlGetAxis();
	
	//! setzen von Werten mit ihren Motorspez. Daten ..
	/*17.07.2003
	dArgumentMax= dArgumentWidth * 100.0;
	dArgumentMin= -dArgumentWidth * 100.0;*/
	dArgumentWidth= mGetValue( Width );
	if ( !mGetDistance( dArgumentMin ) ) dArgumentMin= mGetValue(MinDistanceRel);
	dArgumentMax= min( mGetValue(MaxDistanceRel), dArgumentMin + dArgumentWidth*200.0);
	dSpeed= mGetValue( Speed );
	//! 2thetawert initialisieren (symmetr. reflex)
	d2ThetaStart= min( mlGetValue(mlGetIdByName(Theta), MaxDistanceRel), 2.0 * dArgumentMin);

	nCollectionAmount= 100;
	nNumberCycle= 1;
	//! setzen von einigen Defaultwerten
	eSaveFormat= ffTupel;
	eScanType= stStandardScan;
	bSaveContinuous= FALSE;
	//! Aenderung Dynamische Schrittweite
	bDynamicStepWidth= FALSE;
	nStepScaleLevels= 0;


	//! auslesen von ExposureTime,ExposureCounts,DynamicStepWidth aus Scan-Teil
	//! in der Ini-Datei
	GetPrivateProfileString( "Scan", "ExposureTime", "1.0", buf, MaxString,
							 GetCFile() );
	fMaxTime= atof( buf );

	GetPrivateProfileString( "Scan", "ExposureCounts", "10000", buf, MaxString,
							 GetCFile() );
	dwMaxCounts= atol( buf );
	//! wenn im inifile CreateIniDefaults=1 => dann ExposureCounts in Ini-File
	//! speichern
	if ( CreateDefaults() )
		WritePrivateProfileString( "Scan", "ExposureCounts", buf, GetCFile() );

	//! einlesen der Level fuer Schrittweitensteuerung aus ini-datei
	//! (falls exist.)
	//! einlesen der Level-Werte aus Ini-File
	//! wenn nicht vorhanden, Default-Werte setzen
	for (idx= 0; idx < nMaxScaleIdx; idx++)
	{
		char buf2[MaxString];
		sprintf( Param, "Level%d", idx );
		sprintf(buf2, "%f %f", (float)(idx + 1)*1000, (float) 1.0);
		GetPrivateProfileString( "Scan", Param, buf2, buf, MaxString, GetCFile() );
		sscanf( buf, "%f %f", &Scaler[ idx ], &Scaler[ idx + nMaxScaleIdx ] );
	}
	bSaveOnReady= GetPrivateProfileInt( "Scan", "SaveOnReady", 1, GetCFile() );

	//! setzt die Achse, die auch beim Aufruf des Konstr. gesetzt war
	mlSetAxis( mid );
};

//##############################################################################
// TScanWindow
//##############################################################################

TScanWindow::TScanWindow( HINSTANCE aInstance ) : TScanParameters(), TPlotWindow(aInstance), oldDetector(0)
{
	bInterrupted= FALSE;
	WindowType= wtScan;
	bLineScanStarted= FALSE;
	bScanSetupOk= FALSE;

	//! erstellen der Meneintraege 
	hHoleMenu= LoadMenu(GetMainInstance(), MAKEINTRESOURCE(menu_Scan));
    // Fix fr PopupMens aus Ressourcen (Dummy Popup)
    TheMenu= GetSubMenu(hHoleMenu, 0); 

	//! speicher fuer 50 Messpunkte reservieren und Curve initializieren
	MainCurve= ( TCurve* ) new TCurve();
	//! FIX Fehler 77
	bScanSetupOk= FALSE;
	oldDetector= TDetectorManager::DetectorManager().GetDetector();

	//! setzen der Filter und der Extension
	strcpy( szExtension, "crv" );
	strcpy( szFilter, "Scan Standard (*.crv)|*.crv||" );
};
//*****************************************************************************

//! loeschen der Kurve,des Menues und speichern von Werten in der Ini-Datei
TScanWindow::~TScanWindow()
{
	char buf[ MaxString ];
	RECT rc, rcm;

	//! loeschen der Kurve
	_FREEOBJ(MainCurve);	//hp

	//! loeschen des Menues
	DestroyMenu( hHoleMenu );
	//! anhalten des Detektor + Det. neustarten
	mSetCorrectionState( FALSE );
	Detector->MeasureStop();
	Detector->SetControlWnd( NULL );
	//! ermitteln der Pos. des Scanfensters + speichern der Koord., des aktuellen
	//! Verzeichnisses, der ExposureTime und von 'SaveOnReady' im Ini-file
	GetWindowRect( GetFrameHandle(), &rcm );
	GetWindowRect( GetHandle(), &rc );
	sprintf( buf, "%d", rc.left - rcm.left - 4 );
	WritePrivateProfileString( "Scan", "xo", buf, GetCFile() );
	sprintf( buf, "%d", rc.top - rcm.top - 42 );
	WritePrivateProfileString( "Scan", "yo", buf, GetCFile() );
	sprintf( buf, "%d", rc.right - rc.left );
	WritePrivateProfileString( "Scan", "dx", buf, GetCFile() );
	sprintf( buf, "%d", rc.bottom - rc.top );
	WritePrivateProfileString( "Scan", "dy", buf, GetCFile() );
	WritePrivateProfileString( "Scan", "DataPath", szDataPath, GetCFile() );
	sprintf( buf, "%.2f", fMaxTime );
	WritePrivateProfileString( "Scan", "ExposureTime", buf, GetCFile() );
	sprintf( buf, "%d", bSaveOnReady );
	WritePrivateProfileString( "Scan", "SaveOnReady", buf, GetCFile() );
	// Kanal- oder Winkeldarstellung: zuletzt benutze Darstellungsoption speichern
	IniWriteBool( GetCFile(), "Scan", "ChannelsOnXAxis", bSecondaryCoor );

	//! Aenderung Dynamische Schrittweite
	//! schreiben der aktuellen Einstellungen fuer Dyn. Schrittweite ins Ini-File
	for (int idx= 0; idx < nMaxScaleIdx; idx++)
	{
		char Param[ MaxString ];
		sprintf( Param, "Level%d", idx );
		sprintf(buf, "%.0f %.2f", Scaler[ idx ], Scaler[ idx + nMaxScaleIdx ]);
		WritePrivateProfileString( "Scan", Param, buf, GetCFile() );
	}
	//! registr. des Scanfenster als Kindfenster und sein handle geloescht
	Main.hScanWindow= NULL;
	Main.ScanWindow= NULL;

	TDetectorManager::DetectorManager().SetDetector(oldDetector);
	if ( oldDetector ) oldDetector->MeasureStart();
};
//*****************************************************************************

//! Darstellen des StepScan-Fenster
void TScanWindow::OnCreate()
{
	RECT rc;

	//! ScanFenster als Kindfenster + sein Handle
	Main.hScanWindow= GetHandle();
	SetScanHandle( GetHandle() );
	Main.ScanWindow= this;

	// HotKey's fr F1
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_Scan)) ); // Accelerator aus Ressourcen laden

	Delay( 2000 );

	//! koordinaten des stepscanfenster,Arbeitsverzeichnis aus dem IniFile holen
	//! .crv als Datei endung festlegen
	rc.left= GetPrivateProfileInt( "Scan", "xo", 500, GetCFile() );
	rc.top= GetPrivateProfileInt( "Scan", "yo", 400, GetCFile() );
	rc.right= rc.left + GetPrivateProfileInt( "Scan", "dx", 170, GetCFile() );
	rc.bottom= rc.top + GetPrivateProfileInt( "Scan", "dy", 50, GetCFile() );
	GetPrivateProfileString( "Scan", "DataPath", "c:\\", szDataPath, _MAX_PATH,
							 GetCFile() );
	if ( szDataPath[ max(0, strlen(szDataPath)-1) ] != '\\' )
		strcat( szDataPath, "\\" );
	// Kanal- oder Winkeldarstellung: zuletzt benutze Darstellungsoption wiederherstellen
	bSecondaryCoor = IniReadBool( GetCFile(), "Scan", "ChannelsOnXAxis", FALSE );

	//! Titelzeile des Fensters bestimmen + aktualisieren des Hauptmenues +
	//! darstellen des Scanfensters
	//! passt y-Scale(Intensitaet) an aktuelle Messkurve an
	SetTitle();
	SetRanges();
	SetWindowPos( GetHandle(), NULL, rc.left, rc.top, rc.right - rc.left,
				  rc.bottom - rc.top, SWP_NOZORDER );
};
//*****************************************************************************

LRESULT TScanWindow::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	TModalDlg *dlg= 0;
	WPARAM Cmd= GET_WM_COMMAND_ID(wParam, lParam);
	switch (Cmd)
	{
		case cm_New:  // Hauptmen 
			Steering.Reset();
			bLineScanStarted= FALSE; // fr Steering.Reset() abschalten
			bInterrupted= FALSE;
			SetFileName("");
			New(); // das alles darf nicht in New() verschoben werden = NUR HIER wenn Menpunkt geklickt wurde
			return 0l;

		case cm_SetupStepScan: //! Aufruf der Dialogbox 'Einstellungen StepScan'
			dlg= new TSetupStepScanDlg( this );
			if ( dlg ) dlg->ExecuteDialog( GetHandle() );
			_FREEOBJ(dlg);
			SetRanges();
			//! Scanstart ist erlaubt (param. gueltig)
			bScanSetupOk= TRUE;
			//! fenster neuzeichnen
			UpdateWnd();
			return 01;
			
		case cm_SetupContinuousScan: //! Aufruf der Dialogbox 'Einstellungen ContinuousScan'
			dlg= new TSetupContinuousScanDlg( this );
			if ( dlg ) dlg->ExecuteDialog( GetHandle() );
			_FREEOBJ(dlg);
			SetRanges();
			//! Scanstart ist erlaubt (param. gueltig)
			bScanSetupOk= TRUE;
			//! fenster neuzeichnen
			UpdateWnd();
			return 01;

		case cm_InitializeScan: // vom Kontextmen
		case cm_InitializeLineScan: // via SendMessage zum wiederholten Aufruf (warten bis Startposition erreicht)
			switch ( eScanType ) {
				case stStandardScan: //! standard scan starten
					InitializeStandardScanTask();
					break;
					
				case stOmega2ThetaScan: //! Omega2ThetaScan starten
					InitializeOmega2ThetaScanTask();
					break;
					
				case stContinuousScan: //! ContinuousScan starten
					InitializeContinuousScanTask();
					break;
			}
			return 01;

		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_LineScan);
			return 0l; // Botschaft verarbeitet		

		default:
			return TPlotWindow::OnCommand(wParam, lParam);
	}
}
//*****************************************************************************

//! loescht aktuelle Kurve + baut StepScanfenster neu auf
//! Rueckkehrcode immer True
BOOL TScanWindow::New( void )
{
	//! zuruecksetzen der akt. Kurve auf seine Initial.Werte
	MainCurve->New();

	//! ruecksetzen von Parametern + loeschen des Fensterinhalt + neuen
	//! Fenstertitel
	return TPlotWindow::New();
};
//*****************************************************************************

//! setzt Titel des ScanFensters
//! Rueckkehrcode immer True
BOOL TScanWindow::SetTitle()
{
	strcpy( m_Title, szTitle );
	//! haengt "<untitled.crv>" bei neuer Datei , sonst FileName an
	//! und schreibt ihn ins Fenster
	if ( bIsNewFile )
		strcat( m_Title, "<untitled.crv>" );
	else
		strcat( m_Title, FileName );
	return TMDIWindow::SetTitle();
};
//*****************************************************************************

//! setzt x-achse von startwinkel -> endwinkel (default 0.01,100)
//! setzt y-achse auf min -> max intensitaet siehe Dlg.box 'Displayoptions'
//! (default 1E1,1E5)
void TScanWindow::SetRanges( void )
{
	TPlotWindow::SetRanges();
	CoorSys.xMin= dArgumentMin;
	CoorSys.xMax= dArgumentMax;
};
//*****************************************************************************

void TScanWindow::InitializeStandardScanTask()
{
	char fmt[ MaxString ];
	char buf[ MaxString ];

	//! setzt geschwindigkeit des akt. motors auf 1000? warum!
	mSetValue( Speed, 1000.0 );
	//! ? nicht weiter verfolgt
	mSetCorrectionState( TRUE );
	// Motor initialisieren
	//! Motor einstellen
	mlSetAxis( nMotor );
	sprintf( fmt, szMsgLine101, mGetAxisName(), mGetDF(), mGetDF() );
	sprintf( buf, fmt, dArgumentMin, dArgumentMax );
	//! sicherheitsabfrage, ob scan wirklich starten
	if ( IDNO == MessageBox( buf, szMsgLine115, MBASK ) )
		return;

	bLineScanStarted= TRUE; // beginnt nach Akzeptieren des Meldungsfensters
	//! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
	//! Detektor auf inaktiv
	Detector->MeasureStop();
	//! gibt die Werte Zeit,Impulse und Fehler an Detektor weiter
	Detector->SetControlWnd( GetHandle() );
	Detector->SetExposureSettings( TExposureSettings(fMaxTime, dwMaxCounts) );

	//! FIX Fehler 15
	if (Monitor != 0 )
	{
		Monitor->MeasureStop();
		Monitor->SetControlWnd( GetHandle() );
		Monitor->SetExposureSettings(
			TExposureSettings( 0.8*fMaxTime, dwMaxCounts) );
	}

	//! FIX Fehler 70
	MainCurve->New();
	//! abfrage des Dateinamens, unter dem die Kurve bei Staendig Sichern
	//! oder bei Bei Beenden speichern abgelegt werden soll
	//! FIX Fehler 5
	if ( bSaveContinuous || bSaveOnReady )
		SaveFile( atNewName );

	//klier 01.03.2003
	if (MessageBox( szMsgLine133, szMessageScan, MBASK ) == IDYES)
		InitializeMeasurementProtocol();
	else
		SetProtocolDiffractometryOff();

	//! ? ruecksetzen aller Steering-kommandos und Events
	Steering.Reset(FALSE);
	//! ? setzen des eingestellten Motors,Detektors und Kontrollfenster
	Steering.StartUp( GetHandle(), nMotor, Detector );
	//! alt // Scan starten
	//! Darstellungsoptionen fuer Scan setzen
	Steering.Visualising( TRUE, FALSE );
	//! starten des standardscan
	strcpy( buf, "" );
	Steering.StartCmdExecution( Scan, ForScan, 0, buf, GetHandle() );
}
//*****************************************************************************

void TScanWindow::InitializeOmega2ThetaScanTask()
{
	char fmt[ MaxString ];
	char buf[ MaxString ];

	// Motor initialisieren
	//! Motor einstellen
	mlSetAxis( nMotor );
	//! setzt geschwindigkeit des akt. motors auf 1000? warum!
	mSetValue( Speed, 1000 );
	//! ? von uns nicht weiter verfolgt
	mSetCorrectionState( TRUE );
	// Sensoren initialisieren
	sprintf( fmt, szMsgLine102, mGetDF(), mGetDF() );
	sprintf( buf, fmt, dArgumentMin, dArgumentMax );
	//! sicherheitsabfrage, ob scan wirklich starten
	if ( IDNO == MessageBox( buf, szMsgLine115, MBASK ) )
		return;

	bLineScanStarted= TRUE; // beginnt nach Akzeptieren des Meldungsfensters
	//! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
	//! Detektor auf inaktiv
	Detector->MeasureStop();
	//! gibt die Werte Zeit,Impulse und Fehler an Detektor weiter
	Detector->SetControlWnd( GetHandle() );
	Detector->SetExposureSettings( TExposureSettings(fMaxTime, dwMaxCounts) );

	//! FIX Fehler 15
	if (Monitor != 0 )
	{
		Monitor->MeasureStop();
		Monitor->SetControlWnd( GetHandle() );
		Monitor->SetExposureSettings( TExposureSettings( 0.8*fMaxTime, dwMaxCounts) );
	}

	//! ? setzen des eingestellten Motors,Detektors und Kontrollfenster
	Steering.Reset(FALSE);
	//! abfrage des Dateinamens, unter dem die Kurve bei Staendig Sichern
	//! oder bei Bei Beenden speichern abgelegt werden soll (fehler)
	if ( bSaveContinuous || bSaveOnReady )
		SaveFile( atNewName );

	//klier 16.08.02
	if (MessageBox( szMsgLine133, szMessageScan, MBASK ) == IDYES)
		InitializeMeasurementProtocol();
	else
		SetProtocolDiffractometryOff();

	//! ? setzen des eingestellten Motors,Detektors und Kontrollfenster
	Steering.StartUp( GetHandle(), nMotor, Detector );
	//! alt // Scan starten
	//! Darstellungsoptionen fuer Scan setzen
	Steering.Visualising( TRUE, FALSE );
	//! starten des Omega2ThetaScan
	strcpy( buf, "" );
	Steering.StartCmdExecution( Scan, ForScan, stOmega2ThetaScan, buf,
								GetHandle() );
}
//*****************************************************************************

void TScanWindow::InitializeContinuousScanTask()
{
	//! gibt Vorbereitungsschritt an in dem sich kont. Scan befindet
	static int nContStep= 1; //! neu cont
	static double dStartPos; //! neu cont
	static double dAccelerationDistance= 0.0; //! neu cont
	static float fAccelerationTime= 0.0; //! neu cont
	float fdummy1, fdummy2, fdummy3; //! neu cont
	static int nAreaNumber; //! neu cont
	static HCURSOR hOldCursor= 0; //! neu cont

	char fmt[ MaxString ];
	char buf[ MaxString ];

	//! neuen Scan starten (auch nach abgebrochenem Scan)
	if ( !bLineScanStarted || bInterrupted)
		nContStep= 1;

	switch (nContStep)
	{	
		case 1: //! start eines neuen Scan savedialog+scanstart meldung
			//! mit hoher Geschwindigkeit zur Startpos.
			mlSetAxis( nMotor );
			mSetValue(Speed, 1000.0);
			sprintf( fmt, szMsgLine104, mGetAxisName(), mGetDF(), mGetDF() );
			sprintf( buf, fmt, dArgumentMin, dArgumentMax );
			//! sicherheitsabfrage, ob scan wirklich starten
			if ( IDNO == MessageBox( buf, szMsgLine115, MBASK ) )
				return;

			bLineScanStarted= TRUE; // beginnt nach Akzeptieren des Meldungsfensters
			//! speicherdialog
			if ( bSaveOnReady )
				SaveFile( atNewName );

			//klier 01.03.2003
			if (MessageBox( szMsgLine133, szMessageScan, MBASK ) == IDYES)
				InitializeMeasurementProtocol();
			else
				SetProtocolDiffractometryOff();

			//! loescht akt. Kurve
			New();
			//! Beschleunigungs- bzw. Bremsweg und -zeit berechnen
			//! vorerst auskomment. da die Ini-File-Param. fehlerhaft sind
			/*       fAccelerationTime= fabs(dSpeed / mGetValue( Acceleration ));
						dAccelerationDistance= fabs(0.5 * mGetValue( Acceleration ) *
														(fAccelerationTime * fAccelerationTime));*/ 
			//! merken der Motorposition vor Scanstart (spaeter dahin zurueck)
			mlGetDistance(nMotor, Steering.dStartPoint);
			//! noch vorlauf(Beschleunigungsweg) einrechnen
			dStartPos= dArgumentMin - dAccelerationDistance;
			//! Anzahl der zu messenden Bereiche
			nAreaNumber= nCollectionAmount;
			//! Zeiger, dass Messung aktiv ist, setzen
			bMeasurementActive= TRUE;
			// Schritt abgeschlossen
			nContStep++;
			// diese Methode (zeitversetzt) erneut fr nchstes <nContStep> aufrufen
			PostMessage( GetHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
			break;

		case 2:
			//! setzen des ausgewaehlten Detektor und Motor
			TDetectorManager::DetectorManager().SetDetector( Detector );
			//! Scanfenster dem Detektor bekannt machen (fuer benachrichtigung)
			(dynamic_cast<TZeroDimDetector*>(Detector))->SetEventHost(GetHandle());
			//! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
			//! Detektor auf inaktiv
			Detector->MeasureStop();
			//! gibt die Werte Zeit,Impulse und Fehler an Detektor weiter
			Detector->SetControlWnd( GetHandle() );
			Detector->SetExposureSettings( TExposureSettings(fMaxTime, dwMaxCounts) );
			//! eventuell laufende kommandos loeschen
			Steering.Reset(FALSE);
			//! Startposition anfahren
			mlMoveToDistance(nMotor, dStartPos );
			//! Fenster neuzeichnen und wait-Cursor
			UpdateWnd( ptFlush );
			hOldCursor= SetDefaultCursor( IDC_WAIT );
			// Schritt abgeschlossen
			nContStep++;
			// diese Methode (zeitversetzt) erneut fr nchstes <nContStep> aufrufen
			PostMessage( GetHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
			break;
			
		case 3: //! warten bis startpositionerreicht und anschliessend bewegung zur endpos. starten
			if (mlIsMoveFinish(nMotor))
			{
				/*double distance;
				mlGetDistance(nMotor,distance);
				 sprintf(buf," %f %d",distance,nAreaNumber);
				 MessageBox(GetFocus(),buf,"hh",MBINFO);*/
				DelayTime(100);
				//! normalen cursor setzen
				SetCursor( hOldCursor );
				//! setzt geschwindigkeit des akt. Motors
				mlSetAxis(nMotor);
				mSetValue( Speed, dSpeed );
				//! motor startet zur angeg. Pos. + Bremsweg
				mlMoveToDistance(nMotor, (dArgumentMax + dAccelerationDistance));
				//! Beschleunigungszeit abwarten
				if ( fAccelerationTime >= 0.03)
					DelayTime((int)(fAccelerationTime * 1000 - 20));
				//! startet einen wiederkehrenden Event (jeweils nach fMaxTime) aufruf
				//! von EventHandler() des jeweiligen Det. der waehrend des scans
				//! CounterSetRequest und wenn fertig SteeringReady aufruft
				(dynamic_cast<TZeroDimDetector*>(Detector))->InitializeEvent( GetHandle(), nAreaNumber );
				//! fenster neuzeichnen 
				UpdateWnd();
				nContStep++;
				// KEIN cm_InitalizeLineScan !!! case 4 wird zum Fortsetzen eines unterbrochenen Scans verwendet
			}
			else
				PostMessage( GetFrameHandle(), WM_COMMAND, cm_InitializeLineScan, 0 );
			break;

		//! Fortsetzen eines unterbrochenen Scans
		case 4:
			//! endwert des letzen gemessenen bereiches ermitteln
			MainCurve->SetPPLast();
			MainCurve->PGet(fdummy1, fdummy2, fdummy3);
			//! Beschleunigungsweg einrechnen
			dStartPos= (double)fdummy3 - dAccelerationDistance;
			MainCurve->BackStep();
			//! verbleibende Anzahl von Bereichen ermitteln
			nAreaNumber= nCollectionAmount - MainCurve->GetPNumber();
			//! wieder bei case 2 anfangen
			nContStep= 2;
			PostMessage( GetHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
			SetInfo(szMsgLine117);
			break;
	} //! end switch nContStep
}
//*****************************************************************************

//#############################################################################
// Schnittstellen fuer Ablaufsteuerung 
//#############################################################################

//! behandelt eigentlichen Scanablauf
//! aufruf aus m_main.cpp wenn cm_CounterSet
void TScanWindow::CounterSetRequest( LPARAM lParam)
{
	float x, y;
	//! FIX Fehler 15
	static float z= 0.0;
	//! merkt sich bei kont.scan das akuelle Bereichsende
	//! (ist im naechsten durchgang bereichsanfang)
	static float fLeft;
	// double dDistance;

	// Funktion behandelt Meldung cm_CounterSet
	//! wenn Messung unterbrochen oder keine Messung aktiv dann abbrechen
	if ( bInterrupted )
		return;
	if ( !bMeasurementActive )
		return;
	//! (Kurve wurde geaendert) setzen
	bFileChanged= TRUE;

	if ( eScanType == stContinuousScan )
	{
		//! bei erstem Aufruf Bereichsanfang festlegen
		if (MainCurve->GetPNumber() < 1)
			fLeft= (float) dArgumentMin;

		char buf[MaxString];
		//! ermittelt akt. position + ablegen in x
		mlSetAxis(nMotor);
		x= mGetDistanceProcess();
		//		x= dDistance;
		//! holt gemessene Intensitaet des gerade abgefahrenen Bereiches von
		//! Detektor
		(dynamic_cast<TZeroDimDetector*>(Detector))->GetEventIntensity( y );

		//! Statuszeile ausgeben
		sprintf(buf, szMsgLine118, fLeft, x, y);
		SetInfo(buf);
		//! Intensitaet ueber Bereichsmittelpunkt einzeichnen
		z= (x + fLeft) / 2;
		//! Punkt zu Kurve hinzufuegen
		MainCurve->PAdd( z , y, x);
		//! akt. Endpunkt ist naechster Startpunkt
		fLeft= x;
		//! Neuen punkt ins Fenster zeichnen
		UpdateWnd( ptPaintPoint );
		//! test ob Motor die Endposition unerwartet frueh erreicht hat
		//! kann vorkommen wenn die Motorparameter im ini-file nicht korrekt sind
		//! und somit der Motor schneller faehrt, als er es laut Speed sollte
		if (mlIsMoveFinish(nMotor))
		{
			//! Detektor anhalten
			(dynamic_cast<TZeroDimDetector*>(Detector))->KillEvent();
			//! Scan beenden
			PostMessage( GetHandle(), WM_COMMAND, cm_SteeringReady , 0 );
		}
	}
	else
	{
		//! wenn Monitoring dann holen der Intensitaet von diesem Detektor
		//! und ablegen dieses Wertes z (in steering) sonst z=0 setzen
		if ( Monitor != 0 )
		{ //! FIX Fehler 15
			if ( lParam == Monitor->GetId() )
			{
				// normalize signal
				Monitor->GetIntegral( z );
				Steering.SetNorm( z );
				return;
			}
		}
		else
			z= 0.0;

		//! wenn motor auf position fuer eine Messung
		if ( Steering.IsPositionValid() )
		{
			// dann motorpos. in x
			x= mlGetValue( nMotor, Distance );
			// Detektorintensitaet in y
			Detector->GetIntegral( y );
			if ( eScanType == stOmega2ThetaScan )
				// Thetamotorpos. in z
				z= mlGetValue( mlGetIdByName( Theta ), Distance );

			// tripel(x,y,z) an Kurve anhaengen
			MainCurve->PAdd( x, y, z );
			UpdateWnd( ptPaintPoint ); // update data window

			//! wenn Staendig sichern eingestellt wurde dann cm_UpdateFile senden
			if ( bSaveContinuous ) // store actual value
				SendMessage( GetHandle(), WM_COMMAND, cm_UpdateFile, 0 );
		}
		//! sendet wieder cm_CounterSet ab
		Detector->UpdateViews(TRUE);
		//! ? wenn monitor eingest. dann normieren der Detektorintensitaet mit
		//! der Monitorint. + naechste pos. anfahren
		Steering.DetectorRequest();
	}
};
//*****************************************************************************

void TScanWindow::GetTitleX(int i, int tilesx, char *buf,bool reduceLines) {
	// Zahlenwerte
	TPlotWindow::GetTitleX(i, tilesx, buf, reduceLines); 

	// letzte Beschriftung = Beschriftung der Abzissen-Achse
	if ( i == tilesx ) { 
		if ( eLoadFormat != ffDtnFile) {
			if ( !strcmp(abzisse, szMsgLine120) ) sprintf(buf, abzisse); // Scanachse ???
			else if ( reduceLines || strcmp(abzisse, mGetAxisName()) ) sprintf(buf, szAngleUnitEZ, abzisse);
			else sprintf(buf, szAngleUnit, abzisse, mGetUnitName() );
		}
		// ansonsten <buf> unverndert lassen: dann wird die Achse mit Zahlenwerten beschriftet
	}
};
void TScanWindow::GetTitleY(int i, int titlesy, char *buf, bool reduceLines) {
	// Zahlenwerte
	TPlotWindow::GetTitleY(i, titlesy, buf, reduceLines); 

	// letzte Beschriftung = Beschriftung der Ordinaten-Achse
	if ( i==tilesy ) switch ( eOutputType ) {
		case otMatrixBitmap:
		case otReciprokeLatticeBitmap:
			sprintf(buf, ""); // keine Beschriftung
			break;

		// ansonsten <buf> unverndert lassen: dann wird "linear oder logarithmisch" beschriftet
	}
}
//*****************************************************************************

void TScanWindow::SetKSProperties( TKSProperties* ksp ) 
{ // Kullmann, Reinecker: ATOS-Testfall MS.2 Fehlerbehebung
	if (!ksp)
		return;

	// !!! LowerBound und UpperBound setzen, sonst gehen ksp->fMinY und ksp->fMaxY beim nchsten SetRanges verloren
	LowerBound= CoorSys.yMin= ksp->fMinY;
	UpperBound= CoorSys.yMax= ksp->fMaxY;
	dArgumentMin= CoorSys.xMin= ksp->fMinX;
	dArgumentMax= CoorSys.xMax= ksp->fMaxX;
	if (ksp->bLogarithmicY)
		CoorSys.yScal= sLogarithmic;
	else
		CoorSys.yScal= sLinear;

	CoorSys.xScal= sLinear; // Logarithmic; geaendert, weil xST meiner Meinung nach nie Logarithmic
	bAltCoorSystem= FALSE;

	UpdateWnd();
}
//*****************************************************************************

//! wird augerufen nachdem AreaScan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReset
void TScanWindow::SteeringReset( LPARAM lParam )
{
	if ( !bLineScanStarted ) return;

	// Funktion behandelt Meldung cm_CmdExecuted
	// Funktion behandelt Meldung cm_SteeringReady
	//! Messung als beendet erklaeren
	bLineScanStarted= FALSE;
	bMeasurementActive= FALSE;
	if ( Detector ) Detector->MeasureStop();
	SetInfo(szMsgLine123);
}
//*****************************************************************************

//! wird augerufen nachdem Scan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReady
void TScanWindow::SteeringReady( LPARAM lParam )
{
	if ( !bLineScanStarted ) return;
	char buf[ MaxString ];

	// Funktion behandelt Meldung cm_SteeringReady
	//! Messung als beendet erklaeren
	bLineScanStarted= FALSE;
	bMeasurementActive= FALSE;
	//! abhaengig von ScanTyp
	switch ( eScanType )
	{			
		//! standard u. Omega2Theta
		case stStandardScan: 
		case stOmega2ThetaScan:
			// Step-Scan wurde ausgefuehrt
			switch ( HIWORD( lParam ) )
			{				
				case R_Failure: //! wenn fehler
					//klier 16.08.02
					SetProtocolDiffractometryOff();

					sprintf( buf, szMsgLine105, LOWORD( lParam ));
					MessageBox( buf, szMsgFailureScan, MBSTOP );
					break;

				//! sonst
				default:
					//! bei eingestelltem Staendig sichern, Headerinfo aktualisieren
					//! FIX Fehler 6
					if ( bSaveContinuous )
					{
						// Header aktualisieren
						SaveMeasurementInfo( TRUE ); // update file header
						bFileChanged= FALSE;
					}
					//! bei eingest. Bei Beenden speichern Kurve+ Header speichern
					//! (Fehler)
					if ( bSaveOnReady )
						if ( SaveFile( atNoAsk ) )
							sprintf( buf, szMsgLine106 );
						else
							sprintf( buf, szMsgLine107 );
					//! FIX Fehler 76
					else if ( bSaveContinuous )
						sprintf( buf, szMsgLine106 );
					else
						sprintf( buf, szMsgLine113 );
					MessageBox( buf, szMessageScan, MBINFO );

					//klier 01.03.2003
					if (IsProtocolDiffractometryOn())
					{
						if (!bSaveContinuous && !bSaveOnReady)
						{
							SetMeasurementProtocolParameter();
							SaveProtocolDiffractometryParameter();
						}
						ViewOnProtocolDiffractometryDlg();
						SetProtocolDiffractometryReadOnly();
						SetProtocolDiffractometryOff();
					}
			}
			//! ? von uns nicht weiter verfolgt
			mSetCorrectionState( FALSE );
			//! entfernt alle wm_Timer nachrichten aus warteschlange und setzt
			//! Detektor auf inaktiv
			Detector->MeasureStop();
			//! ? Parameter zuruecksetzen
			Detector->PopSettings();
			//! kontrollfenster auf NULL setzen
			Detector->SetControlWnd( NULL );
			//! setzt timer wieder auf alten fExposureTime(Messzeit)
			Detector->MeasureStart();
			break;
			
		case stContinuousScan: //! bei ContinuousScan
			//! test ob Zielposition noch nicht erreicht
			//! kann vorkommen, wenn der Motor langsamer faehrt, als er es laut speed
			//! duerfte (Ursache fehlerhafte ini-parameter des motors)
			if (!mlIsMoveFinish(nMotor))
			{
				//! weitere 10 Bereiche messen (hoechstens)
				bLineScanStarted= TRUE;
				bMeasurementActive= TRUE;
				(dynamic_cast<TZeroDimDetector*>(Detector))->InitializeEvent( GetHandle(), 10 );
				break;
			}
			//! messung als beendet kennzeichnen			
			bLineScanStarted= FALSE;
			bMeasurementActive= FALSE;
			//! siehe m_layer.h :-(
			//! motor sofort stoppen
			mStopDrive( TRUE );
			//! Detektor-Parameter zuruecksetzen
			Detector->PopSettings();
			//! setzt timer wieder auf alten fExposureTime(Messzeit) + Fenster neuz.
			Detector->MeasureStart();
			UpdateWnd();
			//! Motor zurueck auf position vor scanstart fahren
			mlSetAxis(nMotor);
			mSetValue(Speed, 1000.0);
			mlMoveToDistance(nMotor, Steering.dStartPoint);
			//! in abhaenigkeit von speicheroption Meldung ausgeben
			if (bSaveOnReady)
				if ( SaveFile( atNoAsk ) )
					sprintf( buf, szMsgLine106 );
				else
					sprintf( buf, szMsgLine107 );
			else
				sprintf( buf, szMsgLine113 );

			MessageBox( buf, szMessageScan, MBINFO );

			//klier 01.03.2003
			if (IsProtocolDiffractometryOn())
			{
				if (!bSaveContinuous && !bSaveOnReady)
				{
					SetMeasurementProtocolParameter();
					SaveProtocolDiffractometryParameter();
				}
				ViewOnProtocolDiffractometryDlg();
				SetProtocolDiffractometryReadOnly();
				SetProtocolDiffractometryOff();
			}
			break;
	}
};
//*****************************************************************************

//! aktive Messung unterbrechen und fortsetzen ueber Menue oder esc-taste
void TScanWindow::Interrupt()
{
	if ( !bLineScanStarted ) return;

	//! in Abhaengigkeit von Art des Scan
	switch ( eScanType )
	{
		case stStandardScan:
		case stOmega2ThetaScan:
			//! bInterrupted umkehren wenn Messung aktiv ist
			TMDIWindow::Interrupt();			
			if ( bInterrupted ) //! Messung unterbrechen (wenn Messung nicht luft, mssen wir auch eine andere Makroverarbeitung abbrechen knnen - wenn gerade unser Fenster geffnet ist)
			{
				Steering.ToggleInterrupt();
				//! motor anhalten
				mStopDrive( TRUE );
				//! Detekor anhalten !!!
				(dynamic_cast<TZeroDimDetector*>(Detector))->KillEvent();
				mSetCorrectionState( FALSE );
				SetInfo( szMsgLine119 );
			} else { //! Messung fortsetzen
				mSetCorrectionState( TRUE );
				Steering.ToggleInterrupt();
			}
			break;
			
		case stContinuousScan: //! kont. scan
			//! messung unterbrechen/fortsetzen (menuepunkt aktualisieren)
			TMDIWindow::Interrupt();
			if ( bInterrupted ) //! Messung unterbrechen (wenn Messung nicht luft, mssen wir auch eine andere Makroverarbeitung abbrechen knnen - wenn gerade unser Fenster geffnet ist)
			{
				Steering.ToggleInterrupt();	
				//! motor anhalten
				mStopDrive( TRUE );
				//! Detekor anhalten !!!
				(dynamic_cast<TZeroDimDetector*>(Detector))->KillEvent();
				//! statuszeilenmeldung
				SetInfo( szMsgLine119 );
			} else { //! Messung fortsetzen
				//! wiederaufnehmen des kont.scan erfolgt in InitializeTask unter case 4
				PostMessage( GetHandle(), WM_COMMAND, cm_InitializeLineScan , 0 );
			}
			break;
	}
};
//#############################################################################
// Read/Write
//#############################################################################

//! laden der Messungsinfos aus einer .crv bzw. .bk/.dtn datei
//! wird von TScanWindow::LoadOldData() in m_scan.cpp aufgerufen
//! hFile ist Filehandle der Messdatei
//! Rueckkehrcode False wenn Datei zu kurz, [HEADER] nicht vorhanden oder
//! Filetyp ungleich 1 ist
//! true sonst
BOOL TScanWindow::LoadMeasurementInfo( TTxtRead &aFile ) {
	strcpy(abzisse, szMsgLine120);

	// Header-Informationen auswerten
	aFile.Restart();
	bool HeaderGef= false;
	while ( !aFile.IsEOF() ) { // zeilenweise einlesen
		char *line= aFile.NextLine(); // line nicht freigeben, das erledigt TTxtRead
		if ( strstr(line, "[Header]") ) { // [Header] gefunden :-)
			HeaderGef= true; 
			continue; // Zeile berlesen
		}
		if ( !HeaderGef ) continue; // solange [Header] nicht gefunden: Zeilen berlesen
		if ( strstr(line, "[Data]") ) break; // bei [Data]: Header komplett = fertig :-)


		char *keyword= strtok( line, " =\n\r" ); // den ersten Teil vor "=" auslesen
		char *info= strtok( NULL, " =\n\r" ); // den ersten Teil nach "=" auslesen
		while ( keyword && info ) { // solange weitere Daten in dieser Zeile
			/*if ( !strcmp(keyword, "Date") ||
				 !strcmp(keyword, "Time") ||
				 !strcmp(keyword, "HV") ) 
			{
				// einfach berlesen

			} else */ if ( !strcmp(keyword, "User") ) {
				MeasurementParameter.SetUser( info );

			} else if ( !strcmp(keyword, "Target") ) {
				MeasurementParameter.SetTarget( info );

			} else if ( !strcmp(keyword, "Orientation") ) {
				MeasurementParameter.SetOrientation( info );

			} else if ( !strcmp(keyword, "Reflection") ) {
				MeasurementParameter.SetReflection( info );

			} else if ( !strcmp(keyword, "WaveLength") ) {
				MeasurementParameter.SetWaveLength( info );

			} else if ( !strcmp(keyword, "ArgumentMin") ) {
				dArgumentMin= atof( info );

			} else if ( !strcmp(keyword, "ArgumentMax") ) {
				dArgumentMax= atof( info );

			} else if ( !strcmp(keyword,"ArgumentWidth") ) {
				dArgumentWidth= atof( info );

			} else if ( !strcmp(keyword, "Scanaxis") ) {
				strcpy(abzisse, info);

			} else if ( !strcmp(keyword, "TimePerScan") ) {
				fMaxTime= atof( info );

			} else if ( !strcmp( keyword, "FileType" ) ) {   
				//! Standard-scan
				if ( !strcmp(info, "1") || !strcmp(info, "Standard") ) {
					eScanType= stStandardScan;
					eSaveFormat= ffStandardFile;					
					TPlotWindow::SetLoadFormat(eSaveFormat);

				//! bkFile Format eingefuehrt
				} else if ( !strcmp(info, "2") || !strcmp(info, "Comparison") ) {
					eScanType= stStandardScan;
					eSaveFormat= ffBkFile;					
					TPlotWindow::SetLoadFormat(eSaveFormat);

				//! dtnFile Format eingefuehrt
				} else if ( !strcmp(info, "3") || !strcmp(info, "Aquisition") ) {
					eScanType= stStandardScan;
					eSaveFormat= ffDtnFile;					
					TPlotWindow::SetLoadFormat(eSaveFormat);

				//! Omega2Thetascan
				} else if ( !strcmp(info, "Omega2Theta") ) {   
					eScanType= stOmega2ThetaScan;
					eSaveFormat= ffStandardFile;
					TPlotWindow::SetLoadFormat(eSaveFormat);

				//! kont.scan
				} else if ( !strcmp( info, "Continuous") ) {   
					eScanType= stContinuousScan;
					eSaveFormat= ffStandardFile;
					TPlotWindow::SetLoadFormat(eSaveFormat);

				// falsches Datei-Format
				} else {
					TPlotWindow::SetLoadFormat(ffUnknown);
					return false; 
				} 
			}

			keyword= strtok( NULL, " =\n\r" ); // den nchsten Teil vor "=" auslesen
			info= strtok( NULL, " =\n\r" ); // den nchsten Teil nach "=" auslesen
		}
	}
	if ( !HeaderGef ) return FALSE; // [Header] nicht vorhanden

	return TRUE;
};
//*****************************************************************************

//! Speichern bzw. Aktualisieren der Headerinformation
//! UpdateHeader ==0 => neu erstellen
//! ==1 => aktualisieren
//! Rueckkehrcode False wenn Fehler bei speichern sonst true
BOOL TScanWindow::SaveMeasurementInfo( BOOL UpdateHeader )
{
	//! FIX Fehler 11
	int hFile;
	OFSTRUCT of;
	UINT nSize;
	char format[ MaxString ];
	char buf[ 2 * MaxString ], buf2[ 20 ], buf3[ 20 ];
	SYSTEMTIME t;


	//klier 01.03.2003
	SetMeasurementProtocolParameter();
	SaveProtocolDiffractometryParameter();

	//! UpdateHeader ==0 => neu erstellen
	//! ==1 => aktualisieren
	//! FIX Fehler 11
	if ( UpdateHeader )
		hFile= OpenFile(FileName, &of, OF_WRITE);
	else
	{
		hFile= OpenFile(FileName, &of, OF_CREATE);
	}
	//! Fehler bei oeffnen der Datei => abbruch
	//! FIX Fehler 11
	if ( hFile==HFILE_ERROR )
		return FALSE;
	//! akt. Uhrzeit + Datum holen
	GetLocalTime( &t );
	//! Headerinformationen in String ablegen
	char *data= new char[ DATAOFFSET + 1 ];
	strcpy( format, "Comment=%s" );
	sprintf( buf, format, MeasurementParameter.GetComment() );
	strcpy( data, buf );
	strcat( data, EOL );

	strcat( data, "[Header]" );
	strcat( data, EOL );
	strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d DataOffset=%d" );
	sprintf( buf, format, MeasurementParameter.GetUser(), t.wDay, t.wMonth, t.wYear, t.wHour, t.wMinute, t.wSecond, DATAOFFSET );
	strcat( data, buf );
	strcat( data, EOL );

	//! bezeichnerstring der linescanart ermitteln
	switch (eScanType)
	{
		case stContinuousScan:
			strcpy(buf2, "Continuous");
			break;

		case stOmega2ThetaScan:
			strcpy(buf2, "Omega2Theta");
			break;

		default:   // auch StandardScan
			strcpy(buf2, "Standard");
	}

	strcpy( format, "Point_Number=%d FileType=%s" );
	sprintf( buf, format, MainCurve->GetPNumber(), buf2 );
	strcat( data, buf );
	strcat( data, EOL );

	strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
	MeasurementParameter.GetReflection(buf2);
	MeasurementParameter.GetOrientation(buf3);
	sprintf( buf, format, MeasurementParameter.GetTarget(), buf2, buf3);
	strcat( data, buf );
	strcat( data, EOL );

	mlSetAxis( nMotor );
	sprintf( format, "ArgumentMin=%s ArgumentWidth=%s ArgumentMax=%s", mGetDF(),
			 mGetSF(), mGetDF() );
	sprintf( buf, format, dArgumentMin, dArgumentWidth, dArgumentMax );
	sprintf(format, " Scanaxis=%s", mGetAxisName());
	strcat(buf, format);
	strcat( data, buf );

	//klier 30.01.2003  Der Wert fr das Offset wird mit ausgegeben
	//    sprintf(format, " Offset=%s", mGetDF());
	//    sprintf(buf, format, mlGetOffset(nMotor));
	//    strcat( data, buf );

	strcat( data, EOL );

	strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
	sprintf( buf, format, MeasurementParameter.GetWaveLength(), \
			 MeasurementParameter.GetCurrent(), MeasurementParameter.GetVoltage() );
	strcat( data, buf );
	strcat( data, EOL );

	strcpy( format, "TimePerScan=%.2f" );
	sprintf( buf, format, fMaxTime );
	strcat( data, buf );

	//! string am ende der Info. bis zum Wert DATAOFFSET(=1000) mit Leerzeichen
	//! auffuellen incl. mit [DATA] abschliessen
	for ( nSize= strlen( data ); nSize < DATAOFFSET - 10; nSize++ )
		data[ nSize ]= ' ';
	data[ nSize ]= 0x0;
	strcat( data, EOL );
	strcat( data, "[Data]" );
	strcat( data, EOL );
	//! schreiben der Headerinfo. in die Datei + schliessen der Datei
	//! FIX Fehler 11
	_lwrite(hFile, data, strlen(data));
	_lclose(hFile);
	_FREELIST(data);
	return TRUE;
};
//*****************************************************************************

//! klier 01.03.2003 Protokollbuch
//! initialisiert Speicherung im Protokollbuch
void TScanWindow::InitializeMeasurementProtocol( void )
{
	SetProtocolDiffractometryOn();
	//klier 01.03.2003
	SetProtocolDiffractometryDetektor(Detector->GetCharacteristic());
	//     SetProtocolDiffractometryDetektor(Detector->GetDimension());

	//JP 20.08.2002
	// Fall kann nicht eintreten, da in Auswahlbox nur 0dim.-Detektoren
	// auswaehlbar sind
	//     if(Detector->GetDetectorDimensions()==1) {
	//         TOneDimDetector* Psd= dynamic_cast<TOneDimDetector*>(Detector);
	//         SetProtocolDiffractometryWinkelbereich( Psd->GetAngleRange() );
	//         SetProtocolDiffractometryKanalabstand( Psd->GetAngleStep() );
	//         SetProtocolDiffractometryMesskanal( Psd->GetWidth() );
	//         SetProtocolDiffractometryAddiere( Psd->GetAddedChannels() );
	//     }
	SetProtocolDiffractometryMonitor("-");
	if (eScanType != stContinuousScan)
		if ( Monitor != 0 )
			SetProtocolDiffractometryMonitor(Monitor->GetCharacteristic());
	SetProtocolDiffractometryMesszeit(fMaxTime);
	SetProtocolDiffractometryImpulse(dwMaxCounts);

	SetMeasurementProtocolParameter();
	ViewOnProtocolDiffractometryDlg();
};
//*****************************************************************************

//! klier 01.03.2003 Protokollbuch
//! Speichert Informationen im Protokollbuch
void TScanWindow::SetMeasurementProtocolParameter( void )
{
	char buf[ MaxString ];

	if (IsProtocolDiffractometryOn())
	{
		if (bSaveContinuous || bSaveOnReady)
			SetProtocolDiffractometryMessdatei(FileName);
		SetProtocolDiffractometryNutzer(MeasurementParameter.GetUser());
		SetProtocolDiffractometryScanart("LineScan");
		//! bezeichnerstring der linescanart ermitteln
		switch (eScanType)
		{
			case stContinuousScan:
				SetProtocolDiffractometryScanmethode("ContinuousScan");
				SetProtocolDiffractometryScantyp("Omega");
				sprintf( buf, mGetDF(), dSpeed );
				SetProtocolDiffractometryGeschwindigkeit1(buf);
				break;

			case stOmega2ThetaScan:
				SetProtocolDiffractometryScanmethode("StepScan");
				SetProtocolDiffractometryScantyp("Omega2Theta");
				break;

			case stStandardScan:
				//Fehler? Kullmann+Reinecker: Entweder ein break oder gleich default?			
			default:
				SetProtocolDiffractometryScanmethode("StepScan");
				SetProtocolDiffractometryScantyp("Omega");
		}
		MeasurementParameter.GetReflection(buf);
		SetProtocolDiffractometryUReflex(buf);
		MeasurementParameter.GetOrientation(buf);
		SetProtocolDiffractometryOrientierung(buf);

		if (eScanType == stOmega2ThetaScan)
		{
			SetProtocolDiffractometryScanachse2("Theta");
			sprintf(buf, mGetDF(), d2ThetaStart);
			SetProtocolDiffractometryMinimum2(buf);
			sprintf(buf, mGetSF(), 2*dArgumentWidth);
			SetProtocolDiffractometrySchrittweite2(buf);
			sprintf(buf, mGetDF(), (dArgumentMax - dArgumentMin)*2 + d2ThetaStart);
			SetProtocolDiffractometryMaximum2(buf);
			sprintf(buf, mGetDF(), mlGetOffset(mlGetIdByName( Theta )));
			SetProtocolDiffractometrySOffset2(buf);
		}
		mlSetAxis( nMotor );
		SetProtocolDiffractometryScanachse1(mGetAxisName());
		sprintf(buf, mGetDF(), dArgumentMin);
		SetProtocolDiffractometryMinimum1(buf);
		sprintf(buf, mGetSF(), dArgumentWidth);
		SetProtocolDiffractometrySchrittweite1(buf);
		sprintf(buf, mGetDF(), dArgumentMax);
		SetProtocolDiffractometryMaximum1(buf);
		//klier 30.01.2003  Der Wert fr das Offset wird mit ausgegeben
		sprintf(buf, mGetDF(), mlGetOffset(nMotor));
		SetProtocolDiffractometrySOffset1(buf);

		sprintf(buf, "%.3f", MeasurementParameter.GetWaveLength());
		SetProtocolDiffractometryWellenlaenge(buf);
		sprintf(buf, "%d", MeasurementParameter.GetCurrent());
		SetProtocolDiffractometryStrom(buf);
		sprintf(buf, "%d", MeasurementParameter.GetVoltage());
		SetProtocolDiffractometrySpannung(buf);
	}
};
//*****************************************************************************

//! speichern einer .crv Datei
//! Rueckkehrcode False wenn Fehler bei anlegen der Datei oder bei speichern
//! der Headerinfo. sonst true
BOOL TScanWindow::SaveFile( EAskType ask )
{
	char fmt[ 30 ], buf[ MaxString ];
	FILE* hFile;
	float x, y, z, x2, y2, z2;

	//! anlegen der Datei (event. mit eingabe des Dateinamen)
	if ( !TPlotWindow::SaveFile( ask ) )
		return FALSE;

	//! ueberschreiben der Datei mit Headerinfo.
	if ( !SaveMeasurementInfo( FALSE ) )
	{
		MessageBox( szMsgLine108, szMessageScan, MBINFO );
		return FALSE;
	}
	//! oeffnen der datei + mauszeiger beschaeftigtsymbol
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );
	hFile= fopen( FileName, "r+" );
	//! auf ersten Messpunkt der Kurve gehen
	MainCurve->SetPP();
	//! setzt Dateizeiger auf ende der Datei
	fseek( hFile, 0, SEEK_END );
	sprintf( fmt, "%s %s %s\r\n", mGetSF(), "%.4f", "%.4f" );
	// 07.05.2004 MainCurve->FastOpen();
	//! Bereichstartpunkt fuer ersten bereich festlegen
	y2= dArgumentMin;
	//! holt einzelne tripel aus Kurve + fuegt sie an datei an
	while ( MainCurve->PGet( x, y, z ) ) // 07.05.2004 FastP...
	{
		//! bedeutung der kurvenwerte bei kont.scan anders
		if (eScanType == stContinuousScan)
		{
			//! zuordnung kont.Format
			//! Bereichsanfang,Bereichsende,Intensitaet
			x2= y2;
			y2= z;
			z2= y;
		}
		else
		{
			//! zuordnung normales Format
			//! motorpos,Intens.,sonderinfo(Monitorint. o. thetapos bei O2T-scan)
			x2= x;
			y2= y;
			z2= z;
		}
		sprintf( buf, fmt, x2, y2, z2 );
		fwrite( buf, strlen( buf ), 1, hFile );
	}
	//! nNumber sollte evtl. zur Fehlerbehandlung verwendet werden
	//! nicht von diffr.gruppe auskommentiert
	//! nNumber= fclose(hFile);

	//! schliessen der Datei + setzen des alten Mauszeigers + schliessen der
	//! Kurve
	fclose( hFile );
	SetCursor( hOldCursor );
	// 07.05.2004 MainCurve->FastClose();
	//! variabl. setzen, um fenster ohne weitere Speicheranfrage verlassen zu
	//! koennen
	bFileChanged= FALSE;
	return TRUE;
};
//*****************************************************************************

//! haengt aktuelles tripel der Messkurve an Datei mit FileName an
//! aufruf nur bei kontinuierlichem Speichern
//! Rueckkehrcode False wenn fehler bei oeffnen der Datei sonst true
BOOL TScanWindow::UpdateFile( void )
{
	float x, y, z;
	char buf[ MaxString ];
	char fmt[ MaxString ];
	int hFile;
	OFSTRUCT of;

	//! test ob neuer Dateiname (Fehler)
	if ( bIsNewFile )
		SaveFileAs();
	//! datei oeffnen + test auf fehler mit Fehlermeldung
	hFile= OpenFile( FileName, &of, OF_WRITE );
	if ( hFile==HFILE_ERROR )
	{
		MessageBox( szMsgLine109, szMsgFailureScan, MBINFO );
		return FALSE;
	}
	//! aktuelles tripel Messwerte (x,y,z) aus Kurve formatiert an datei
	//! anhaengen + datei schliessen
	MainCurve->PGet( x, y, z );
	sprintf( fmt, "%s %s %s\r\n", mGetSF(), "%.4f", "%.4f" );
	sprintf( buf, fmt, x, y, z );
	_llseek( hFile, 0, SEEK_END );
	_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
	_lclose( hFile );
	return TRUE;
};
//*****************************************************************************

//! liest gespeicherte Kurve (.crv/.bk)
//! Rueckkehrcode false wenn Fehler beim oeffnen der Datei, fehlerhaften
//! Headerinfo. oder keine Eintraege nach[DATA] sonst true
BOOL TScanWindow::LoadOldData()
{
	//>>>
	const int LLength= 2500;
	char buf[ MaxString ];
	char buf2[ MaxString ];
	float x, y, z;
	int hFile, cnt;
	OFSTRUCT of;
	//! FIX Fehler 7
	BOOL bReady= FALSE;

	//! ins Arbeitverzeichnis wechseln + 'Datei nachladen'-Dialog oeffnen + Dateinamen prfen
	char Filter[]= "Curve Standard (*.crv)|*.crv|Compare Curve (*.bk)|*.bk|Curve Inquire Data (*.dtn)|*.dtn|";
	char NewFilename[ _MAX_PATH ];
	sprintf( NewFilename, "*.%s", szExtension );
	_chdir( szDataPath );
	if ( !FileOpenDialog( szMsgLine110, Filter, NewFilename, szDataPath) ) 
		return FALSE; // 'Abbruch' geklickt
	if ( strlen(NewFilename)==0 || strcmp(NewFilename, "*")==0 ) 
		return FALSE;
	char drv[ _MAX_DRIVE+1 ], dir[ _MAX_DIR+1 ], name[ _MAX_FNAME+1 ], ext[ _MAX_EXT+1 ];
	_splitpath( NewFilename, drv, dir, name, ext );
	if ( _stricmp(ext, ".CRV")!=0 && _stricmp(ext, ".BK")!=0 && _stricmp(ext, ".DTN")!=0 )
		return FALSE;
	strcpy( FileName, NewFilename);
	sprintf( szDataPath, "%s%s", drv, dir );

	Steering.Reset();
	bLineScanStarted= FALSE; // fr Steering.Reset() abschalten
	bInterrupted= FALSE;

	//! setzt Wartemauszeiger 
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );
	//! laden der Headerinformation mit abbruch und Fehlermeldung bei Fehler
	TTxtRead Datei(FileName);
	if ( !LoadMeasurementInfo(Datei) )
	{
		SetCursor( hOldCursor );
		MessageBox( szMsgLine108, szMessageScan, MBINFO );
		return FALSE;
	}
	//! oeffnen dieser Datei zum lesen und Abbruch und Fehlermeldung falls nicht
	//! moeglich
	hFile= OpenFile( FileName, &of, OF_READ );
	if ( hFile==HFILE_ERROR )
	{
		SetCursor( hOldCursor );
		MessageBox( szMsgLine111, szMsgFailureScan, MBINFO );
		return FALSE;
	}
	//! Statuszeilenmeldung festlegen
	if (eScanType == stContinuousScan)
		strcpy(buf2, szMsgLine114);
	else
		strcpy(buf2, szMsgLine112);
	//! loeschen der aktuellen Kurve
	MainCurve->New();

	// 07.05.2004 MainCurve->FastOpen();
	LPSTR lpBuf= new char [ LLength ];
	//! test ob Werte hinter [DATA] folgen
	if ( !SetFPOnData( hFile ) )
		return FALSE;
	//! zeilenweises einlesen und ablegen der Punkte in Kurve sowie Ausgabe der
	//! Anzahl der gelesenen tripel in 30er schritten bis Ende der Datei erreicht
	//! oder Zeile zu lang ?
	//! FIX Fehler 7
	for ( cnt= 0; !bReady; cnt++ )
		switch ( GetFileLine( hFile, lpBuf, LLength ) )
		{
			case R_Overflow:
				//! hier SetInfo eingebaut, damit korrekte Ausgabe der Anzahl der Punkte
				sprintf( buf, buf2, ++cnt );
				SetInfo( buf );
				bReady= TRUE;
				continue;

			case R_EndOfFile:
				//! hier SetInfo eingebaut, damit korrekte Ausgabe der Anzahl der Punkte
				sprintf( buf, buf2, ++cnt );
				SetInfo( buf );
				bReady= TRUE;
				//Fehler? Kullmann+Reinecker: Fehlt hier vielleicht ein break?

			default:
				if ( 3 != sscanf( lpBuf, "%f %f %f", &x, &y, &z ) )
					continue;
				if ( 0 == ( cnt % 30 ) )
				{
					sprintf( buf, buf2, cnt );
					SetInfo( buf );
				}
				//! zu zeichnene Kurve aus Datei erstellen (abhaengig von Scanart)
				if (eScanType == stContinuousScan)
				{
					//! intensitaeten ueber bereichsmitte abtragen
					x= (x + y) / 2;
					MainCurve->PAdd( x, z, y); // 07.05.2004 FastP...
				}
				else
					MainCurve->PAdd( x, y, z ); // 07.05.2004 FastP...
		}

	//! setzen des norm. Mauszeigers + schliessen der akt. Kurve + setzen des
	//! x-Bereichs
	SetCursor( hOldCursor );
	//! eingefuegt fuer dtn File Achsenbeschriftung...
	//! im dtnFile ist Omega zu Anfang immer am kleinsten und steigt dann
	//! aber zugehoeriges Theta muss erst noch bestimmt werden...
	if (eLoadFormat == ffDtnFile)
	{
		float xtemp, ytemp, ztemp;
		MainCurve->SetPP();
		MainCurve->PGet(x, y, z); // 07.05.2004 FastP...
		MainCurve->SetPPLast();
		MainCurve->PGet(xtemp, ytemp, ztemp); // 07.05.2004 FastP...
		CoorSys.zMin= z;
		CoorSys.zMax= ztemp;
	}

	// 07.05.2004 MainCurve->FastClose();
	//! bei kont. scan keine anpassung des koor.systems an position der kurve
	if ( eScanType != stContinuousScan)
	{
		dArgumentMin= MainCurve->GetMin( P_X );
		dArgumentMax= MainCurve->GetMax( P_X );
	}
	_FREELIST(lpBuf);
	//! variabl. setzen, um fenster ohne weitere Speicheranfrage verlassen zu
	//! koennen y-bereich neu festlegen + koord.system neu zeichnen
	bIsNewFile= FALSE;
	SetRanges();
	UpdateWnd();
	//! akt. Kurve wurde geladen (Fehler)
	bOldDataLoaded= TRUE;
	return TRUE;
};
//*****************************************************************************

//#############################################################################
// Mausbedienung
//#############################################################################

void TScanWindow::OnPopupMenuInit(WPARAM, LPARAM lParam)
{
	if (eSaveFormat == ffDtnFile)
		EnableMenuItem(TheMenu, cm_SetupStepScan, MF_GRAYED);
	else
		EnableMenuItem(TheMenu, cm_SetupStepScan, MF_ENABLED);
#ifndef ContinuousScanCapability
	EnableMenuItem( TheMenu, cm_SetupContinuousScan, MF_GRAYED );
#endif

	//! dieses if eingefuegt, damit bei eingelesenem dtnfile keine Setupmenuaufruf moeglich
	if (eSaveFormat == ffDtnFile)
	{
		EnableMenuItem(TheMenu, cm_SetupStepScan, MF_GRAYED);
		EnableMenuItem(TheMenu, cm_InitializeScan, MF_GRAYED);
		EnableMenuItem(TheMenu, cm_FreezeCurve, MF_GRAYED);
		EnableMenuItem(TheMenu, cm_KillSecondCurve, MF_GRAYED);
		EnableMenuItem(TheMenu, cm_SaveSecondCurve, MF_GRAYED);
	}
	else
	{
		EnableMenuItem(TheMenu, cm_SetupStepScan, MF_ENABLED);
		//! abhaengig von eingestellter scanart menueeintrag fuer scanstart festlegen
		if (eScanType == stContinuousScan)
			ModifyMenu( TheMenu, cm_InitializeScan, MF_STRING | MF_BYCOMMAND, cm_InitializeScan,
						szMsgLine121 );
		else
			ModifyMenu( TheMenu, cm_InitializeScan, MF_STRING | MF_BYCOMMAND, cm_InitializeScan,
						szMsgLine122 );
		//! scanstart soll nur moeglich sein wenn keine Messung aktiv , akt. Messung
		//! unterbrochen , eine Einstellungsbox aufgerufen wurde
		//! FIX Fehler 77
		if ( ( bLineScanStarted && !bInterrupted ) || !bScanSetupOk )
			EnableMenuItem(TheMenu, cm_InitializeScan, MF_GRAYED);
		else
			EnableMenuItem(TheMenu, cm_InitializeScan, MF_ENABLED);
		//! neu fixscan
		if (1 > SecondCurve->GetPNumber())
		{
			EnableMenuItem( TheMenu, cm_FreezeCurve, MF_ENABLED );
			EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_GRAYED );
			EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_GRAYED );
			//!       ModifyMenu( TheMenu, 5, MF_STRING|MF_BYPOSITION,5,"Scan" );
		}
		else
		{
			EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
			EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_ENABLED );
			EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_ENABLED );
			//!       ModifyMenu( TheMenu, 5, MF_STRING|MF_BYPOSITION,5,"fixierten Scan" );
		}
	}
};
/*2104.2004 //*****************************************************************************

//scheinbar ueberfluessig nur fuer TScan def. nicht geerbt
BOOL TScanWindow::SaveDataBase( void )
{
	return TRUE;
};*/
