//##############################################################################
//                                                                            //
// S_INTERN.CPP                                                               //
//                                                                            //
// Subsystem: Diffraktometrie/ Reflektometrie                                 //
//            intern genutzte Fenster fr Continious-, Step- und DynamicStepScan//
// Benutzung durch andere Subsysteme erforderlich: NEIN                       //
//                                                                            //
//##############################################################################
//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include "help\help_def.h"     // Help-IDs
#pragma hdrstop

#include "difrkmty\s_intern.h" // SCHNITTSTELLE fr diese Datei
#include "difrkmty\s_extern.h" // TScanWindow

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//#############################################################################
// globale Typen und Konstanten
//#############################################################################

const UINT _MAXTIMEDIGITS= 1;
const UINT _MAXCOUNTSDIGITS= 1;
const UINT _THETASTARTDIGITS= 3; // war vorher nicht nher spezifiert
const UINT _INTENSITYDIGITS= 0;
const UINT _FACTORDIGITS= 2;
const UINT _STATICDIGITS= 0;

//#############################################################################
// sprachspezifische Konstanten
//#############################################################################

#ifdef GermanVersion
	char szMessageDlg[]= "Meldung";
	char szMsgFailureDlg[]= "Fehler";
	char szMsgLine130[]= "Die Parameter Bereichsgre und Mezeit\nverursachen eine ungltige Geschwindigkeit!";
	char szMsgLine131[]= "Die Parameter Bereichsgre, Startpunkt und Endpunkt\nverursachen eine ungltige Mepunkteanzahl!";
	char szMsgLine132[]= "Durch die Einbeziehung des Beschleunigungs- bzw.\nBremsweges (%s) kommt es zu ungltigen Motorpositionen!";

	char szMsgLine400[]= "Kein Monitor";
	char szMsgLine401[]= "Min muss kleiner Max sein!\n\nMin und Max wurden ausgetauscht.";
#else
	char szMessageDlg[]= "Message";
	char szMsgFailureDlg[]= "Failure";
	char szMsgLine130[]= "The Parameters Areasize and Time\ncauses an invalid Velocity!";
	char szMsgLine131[]= "The Parameters Areasize, Startpoint and Endpoint\ncauses an invalid Pointnumber!";
	char szMsgLine132[]= "the inclusion of the acceleration or\nbraking distance (%s) causes invalid motorpositions!";

	char szMsgLine400[]= "No Monitor";
	char szMsgLine401[]= "Min should be smaller than Max!\n\nMin and Max were exchanged against each other.";
#endif

//##############################################################################
// TSetupStepScanDlg
//##############################################################################

TSetupStepScanDlg::TSetupStepScanDlg( TScanWindow* aScan ) : TModalDlg( "SCANPARAMETERS", GetMainInstance() ), Scan(0), hScanTypeList(0)
{
	// ! neu (11.03.2004) Kullmann+Reinecker: alle Memberattribute initialisiert
	Scan= aScan; //! Parameter von Scanfenster uebernehmen
	dArgumentMin= Scan->dArgumentMin;
	dArgumentMax= Scan->dArgumentMax;
	dArgumentWidth= Scan->dArgumentWidth;
	dwMaxCounts= Scan->dwMaxCounts;
	fMaxTime= Scan->fMaxTime;
	bSaveOnReady= Scan->bSaveOnReady;
	/*	 if ( Scan->eScanType == ContinuousScan )
			  Scan->eScanType= StandardScan;*/ 
	eScanType= Scan->eScanType;	
	bSaveContinuous= Scan->bSaveContinuous;
	strcpy( szPath, Scan->szDataPath );
	d2ThetaStart= Scan->d2ThetaStart;
	// 21.04.2004 eSaveFormat= Scan->eSaveFormat;
};
//*****************************************************************************

//! setzt Defaultwerte in Dialogbox
//! Rueckkehrcode immer true
BOOL TSetupStepScanDlg::Dlg_OnInit( HWND, HWND hwndCtl, LPARAM lParam )
{
	//! Handles der Comboboxen uebergeben + uebergeben der akt. Motor, Detekt.,
	//! Monit.
	hScanTypeList= GetDlgItem( GetHandle(), id_ChooseScanType );
	//! eintragen der Comboboxauswahlelemente fuer Scantyp, Detektor und
	//! Scanachse vorauswahl der aktiven geraete
	ComboBox_AddString( hScanTypeList, "Standard" );
	//! Omega2Thetamodus nur bei exist. Theta erlauben
	if (mlIsAxisValid(Theta))
		ComboBox_AddString( hScanTypeList, "Omega-2Theta" );

	HWND hDetectorList= GetDlgItem( GetHandle(), id_ChooseDetector );
	TDetectorManager::DetectorManager().FillDetectorComboBox(hDetectorList, 0);
	ComboBox_SelectString( hDetectorList, 0, Scan->Detector->GetCharacteristic() );

	//! aufnehmen aller verfuegbaren Detektoren in Combobox
	HWND hMonitorList= GetDlgItem( GetHandle(), id_ChooseMonitor );

	ComboBox_AddString( hMonitorList, szMsgLine400 );
	TDetectorManager::DetectorManager().FillDetectorComboBox( hMonitorList);

	if (Scan->Monitor != 0)
		ComboBox_SelectString( hMonitorList, 0 , Scan->Monitor->GetCharacteristic() );
	else
		ComboBox_SelectString( hMonitorList, 0 , szMsgLine400 );

	HWND hMotorList= GetDlgItem( GetHandle(), id_ChooseMotor );
	for (int i=0; i < mlGetAxisNumber(); i++ )
	{
		mlSetAxis( i );
		ComboBox_AddString( hMotorList, mGetAxisName() );
	}
	mlSetAxis( Scan->nMotor );
	ComboBox_SelectString( hMotorList, 0, mGetAxisName() );

	//! Aenderung Dynamische Schrittweite
	//! aktivieren von Checkbutton und Einstellungsbox fuer Dyn. Schrittweite
	//! abhaengig von Param.
	CheckDlgButton( GetHandle(), id_DynamicActive, Scan->bDynamicStepWidth );
	CtrlSetEnabled(cm_DynamicSetup, Scan->bDynamicStepWidth );

	//! setzt dialoginhalte
	CheckDlgButton( GetHandle(), id_SaveOnReady, Scan->bSaveOnReady );
	CheckDlgButton( GetHandle(), id_SaveContinuous, Scan->bSaveContinuous );

	//! wahrscheinlich ueberfluessig
	SetFocus( GetDlgItem( GetHandle(), id_ChooseMotor ) );
	//! wenn ScanTyp Omega2Theta dann Motorcombobox ausgrauen sonst nicht
	switch ( eScanType )
	{
		case stStandardScan:
			ComboBox_SelectString( hScanTypeList, 0, "Standard" );
			CtrlSetEnabled(id_ChooseMotor, TRUE );
			CtrlSetEnabled(id_2Theta, FALSE );
			break;

		case stOmega2ThetaScan:
			ComboBox_SelectString( hScanTypeList, 0, "Omega-2Theta" );
			CtrlSetEnabled(id_ChooseMotor, FALSE );
			break;
	}

	// HotKey's fr Hilfe
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_SetupStepScanDlg)) ); // Accelerator aus Ressourcen laden

	//! bewirkt Aufruf von Dlg_OnCommand mit Kommando cm_ParamSet
	FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, hwndCtl, 0, SendMessage );
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );
	return TRUE;
};
//*****************************************************************************

//! behandelt alle Kommandos in der Dialogbox
void TSetupStepScanDlg::Dlg_OnCommand( HWND, int id, HWND hwndCtl,
									   UINT codeNotify )
{
	//! Aenderung Dynamische Schrittweite
	TModalDlg * dlg;

	//! abhaengig von dialogelement bzw. Kommando
	switch ( id )
	{
		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_SetupStepScanDlg);
			break;

		//! initialisierung ?(siehe Fehler)
		case cm_ParamSet:
			OnParamSet(); 
			OnChooseScanType(codeNotify);
			break; 

		//! auswahl von Scan-Typ-Combobox erfolgt
		case id_ChooseScanType:
			OnChooseScanType(codeNotify);
			break;

		//! Scan-Achsen-Combobox ausgewaehlt
		case id_ChooseMotor:
			OnChooseMotor(codeNotify);
			break;

		//! Detektor-combobox ausgewaehlt
		case id_ChooseDetector:
			OnChooseDetector(codeNotify);
			break;

		//! Monitor-ComboBox ausgewaehlt
		case id_ChooseMonitor:
			OnChooseMonitor(codeNotify);
			break;

		//! FIX Fehler 71
		case id_SaveContinuous:
			CheckDlgButton(GetHandle(), id_SaveOnReady, FALSE);
			break;

		case id_SaveOnReady:
			CheckDlgButton(GetHandle(), id_SaveContinuous, FALSE);
			break;

		//! Aenderung Dynamische Schrittweite
		//! Start der Dialogbox 'Einstellungen Dyn. Schrittweite' bei Auswahl des
		//! Einstellungs-Button
		case cm_DynamicSetup:
			dlg= ( TSetupDynamicStepDlg * ) new TSetupDynamicStepDlg( Scan );
			if ( dlg ) dlg->ExecuteDialog( GetHandle() );
			_FREEOBJ(dlg);
			break;

		//! Aenderung Dynamische Schrittweite
		//! bei Auswahl der Aktivieren-Checkbox automatisches Oeffnen der
		//! Einstellungsbox fuer dyn. Schrittweite
		case id_DynamicActive:
			OnDynamicActive();
			break;

		//! hier werden IDOK,IDCANCEL und IDABBORT behandelt
		default:
			TModalDlg::Dlg_OnCommand( GetHandle(), id, hwndCtl, codeNotify );
	}
};
//*****************************************************************************

void TSetupStepScanDlg::OnChooseScanType(UINT codeNotify)
{
	//! scheinbar ueberfluessig (getestet)
	switch ( eScanType )
	{
		case stStandardScan:
			SendMessage( hScanTypeList, WM_SETTEXT, 0, ( LPARAM ) "Standard" );
			break;

		case stOmega2ThetaScan:
			SendMessage( hScanTypeList, WM_SETTEXT, 0, ( LPARAM ) "Omega-2Theta" );
			break;
	}

	//! test ob aenderung in Combobox
	if ( codeNotify == CBN_SELCHANGE )
	{
		//! wenn ja => was wurde ausgewaehlt
		switch ( ComboBox_GetCurSel( hScanTypeList ) )
		{
			case 0:   // stStandardScan
				eScanType= stStandardScan;
				ComboBox_SelectString( hScanTypeList, 0, "Standard" );
				CtrlSetEnabled(id_ChooseMotor, TRUE );
				CtrlSetEnabled(id_2Theta, FALSE );
				break;

			case 1:   // stOmega2ThetaScan
				eScanType= stOmega2ThetaScan;
				//! test ob auch omega und theta motoren vorhanden
				if ( !mlIsAxisValid( Omega ) || !mlIsAxisValid( Theta ) )
				{
					//! nicht vorhanden => standard-scan setzen + abbruch
					eScanType= stStandardScan;
					ComboBox_SelectString( hScanTypeList, 0, "Standard" );
					break;
				}
				//! motoren vorhanden => omega-motor setzen + omega2theta-scan
				//! setzen + Scan-Achsen-combobox sperren
				Scan->nMotor= mlGetIdByName( Omega );
				mlSetAxis( Scan->nMotor );
				ComboBox_SelectString( hScanTypeList, 0, "Omega-2Theta" );
				CtrlSetEnabled(id_ChooseMotor, FALSE );
				CtrlSetEnabled(id_2Theta, TRUE );
				break;
		}
	}
}
//*****************************************************************************

void TSetupStepScanDlg::OnParamSet()
{
	//! setzen der zum Motor gehoerigen Einheit
	CtrlSetText( id_Unit, mGetUnitName() );

	//! alt // Bereich sollte den Motor nicht beeinflussen
	//! test auf korrekte Bezieh. zwischen Min und Max
	//! eintragen von korrekten Werten in Dialogbox
	CtrlSetDouble(id_AngleWidth, Scan->dArgumentWidth, mGetDigits()+1, _DECIMAL);

	if ( Scan->dArgumentMax >= mGetValue( MaxDistanceRel ) )
		Scan->dArgumentMax= mGetValue( MaxDistanceRel ) - mGetValue( MinWidth );
	CtrlSetDouble(id_AngleMax, Scan->dArgumentMax, mGetDigits(), _DECIMAL);

	if ( Scan->dArgumentMin <= mGetValue(MinDistanceRel) )
		Scan->dArgumentMin= mGetValue(MinDistanceRel) + mGetValue( MinWidth );
	CtrlSetDouble(id_AngleMin, Scan->dArgumentMin, mGetDigits(), _DECIMAL);

	CtrlSetText( id_Catalog, ( LPSTR ) Scan->szDataPath );
	ComboBox_SelectString( GetDlgItem(GetHandle(), id_ChooseMotor), 0, mGetAxisName() );
	ComboBox_SelectString( GetDlgItem(GetHandle(), id_ChooseDetector), 0, Scan->Detector->GetCharacteristic() );

	HWND hMonitorList= GetDlgItem( GetHandle(), id_ChooseMonitor );

	if (Scan->Monitor != 0)
		ComboBox_SelectString( hMonitorList, 0 , Scan->Monitor->GetCharacteristic() );
	else
		ComboBox_SelectString( hMonitorList, 0 , szMsgLine400 );

	//! FIX Fehler 8
    CtrlSetDouble( id_MaxTime, Scan->fMaxTime, _MAXTIMEDIGITS, _DECIMAL );
	CtrlSetDouble(id_MaxCounts, Scan->dwMaxCounts, _MAXCOUNTSDIGITS, _DECIMAL);
	//! neu 2Theta
	CtrlSetDouble(id_2Theta, d2ThetaStart, _THETASTARTDIGITS, _DECIMAL);
}
//*****************************************************************************

void TSetupStepScanDlg::OnChooseMotor(UINT codeNotify)
{
	//! test ob aenderung in combobox
	if ( codeNotify == CBN_SELCHANGE)
	{
		//! ja => setzen des Motors
		int idx= ComboBox_GetCurSel( GetDlgItem(GetHandle(), id_ChooseMotor) );

		if ( idx == CB_ERR )
			return;

		if ( Scan->nMotor != idx )
		{
			mlSetAxis( idx );
			Scan->nMotor= mlGetAxis();
		}
		//! FIX Fehler 9
		FORWARD_WM_COMMAND(GetHandle(), cm_ParamSet, 0, 0, PostMessage );
	}
}
//*****************************************************************************

void TSetupStepScanDlg::OnChooseDetector(UINT codeNotify)
{
	if ( codeNotify == CBN_SELCHANGE )
	{
		int idx= ComboBox_GetCurSel( GetDlgItem(GetHandle(), id_ChooseDetector) );

		if (idx == CB_ERR)
			return;

		Scan->Detector= TDetectorManager::DetectorManager().GetDetector( idx, 0 );
	}
}
//*****************************************************************************

void TSetupStepScanDlg::OnChooseMonitor(UINT codeNotify)
{
	if ( codeNotify == CBN_SELCHANGE )
	{
		int idx= ComboBox_GetCurSel( GetDlgItem(GetHandle(), id_ChooseMonitor) ) - 1;

		if (idx == CB_ERR)
			return;

		Scan->Monitor= TDetectorManager::DetectorManager().GetDetector( idx );
	}
}
//*****************************************************************************

void TSetupStepScanDlg::OnDynamicActive()
{
	if ( IsDlgButtonChecked( GetHandle(), id_DynamicActive ) )
	{
		CtrlSetEnabled(cm_DynamicSetup, TRUE );
		PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_DynamicSetup, 0 );
	}
	else
		CtrlSetEnabled(cm_DynamicSetup, FALSE );
}
//*****************************************************************************

BOOL TSetupStepScanDlg::CanClose( void )
{
	BOOL bFailure= FALSE;
	float valueF;
	long valueL;
	BOOL bValid= TRUE;

	//! uebernehmen der Einstellungen Staendig sichern und Bei Beenden speichern
	Scan->bSaveContinuous= IsDlgButtonChecked( GetHandle(), id_SaveContinuous );
	Scan->bSaveOnReady= IsDlgButtonChecked( GetHandle(), id_SaveOnReady );

	//! Aenderung Dynamische Schrittweite
	//! uebernehmen der Einstellungen Dyn. Schrittweite aktivieren
	Scan->bDynamicStepWidth= IsDlgButtonChecked( GetHandle(), id_DynamicActive );

	//! liest Schrittweite aus Dialogbox und uebernimmt diesen wenn Wert <> 0
	//! sonst Box wird nicht geschlossen (Fehler)
	valueF= CtrlGetDouble( id_AngleWidth, mGetDigits()+1, _DECIMAL, bValid);
	//! FIX Fehler 8
	if (!bValid) bFailure= TRUE;
	else if ( mGetValue( MinWidth )<=valueF )
		Scan->dArgumentWidth= valueF;
	else {
		MessageBeep(0);
		CtrlSetFocus(id_AngleWidth);
		bFailure= TRUE;
	}

	//! liest Wert fuer Maximumwinkel und testet ob dieser kleiner ist als der
	//! max. erlaubte(fuer akt. Motor) wenn kleiner uebernehmen sonst uebernehmen
	//! von max. erlaubten Winkel - 1* Schrittweite + schreiben in die Box (Box
	//! wird nicht geschlossen)
	valueF= CtrlGetDouble( id_AngleMax, mGetDigits(), _DECIMAL, bValid);
	if (!bValid) bFailure= TRUE;
	else if ( valueF<=mGetValue(MaxDistanceRel) )
		Scan->dArgumentMax= max( mGetValue(MinDistanceRel), valueF);
	else
	{
		Scan->dArgumentMax= mGetValue(MaxDistanceRel) - mGetValue(MinWidth);
		MessageBeep(0);
		CtrlSetFocus(id_AngleMax);
		bFailure= TRUE;
	}

	//! liest Minimum aus Dialogbox und testet ob >= als min. erlaubter Winkel
	//! des akt. Motors
	valueF= CtrlGetDouble( id_AngleMin, mGetDigits(), _DECIMAL, bValid);
	if (!bValid) bFailure= TRUE;
	else if ( valueF>=mGetValue(MinDistanceRel) )
	{		
		valueF= min( mGetValue(MaxDistanceRel), valueF);
		//! test ob min >= max dann neu setzen + box wird nicht geschlossen
		if ( valueF >= Scan->dArgumentMax ) // deshalb erst id_AngleMax auslesen
		{
			Scan->dArgumentMin= Scan->dArgumentMax;
			Scan->dArgumentMax= valueF;
			MessageBox(szMsgLine401, szMessageDlg, MBINFO);
			CtrlSetFocus(id_AngleMax);
			bFailure= TRUE;
		} else Scan->dArgumentMin= valueF;
	}
	else
	{
		//! sonst Dialogelement auf motormin+10*Motorschrittweite setzen + Box wird
		//! nicht geschlossen
		Scan->dArgumentMin= mGetValue(MinDistanceRel) + 10.0 * mGetValue( MinWidth );
		MessageBeep(0);
		CtrlSetFocus(id_AngleMin);
		bFailure= TRUE;
	}

	//! liest die Zeit (Beschraenkung) aus Dialogbox und schliesst Box nur wenn
	//! Wert <>0 (Fehler)
	valueF= CtrlGetDouble( id_MaxTime, _MAXTIMEDIGITS, _DECIMAL, bValid );
	//! FIX Fehler 8
	if (!bValid) bFailure= TRUE;
	else if ( valueF>0.0 )
		Scan->fMaxTime= valueF;
	else {
		Scan->fMaxTime= 0.1f;
		CtrlSetDouble( id_MaxTime, Scan->fMaxTime, _MAXTIMEDIGITS, _DECIMAL );
		MessageBeep(0);
		CtrlSetFocus(id_MaxTime);
		bFailure= TRUE;
	}    

	//! liest die Impulse (Beschraenkung) aus Dialogbox und schliesst Box nur
	//! wenn Wert<>0 (Fehler)
	valueL= CtrlGetDouble(id_MaxCounts, _MAXCOUNTSDIGITS, _DECIMAL, bValid);
	//! FIX Fehler 8
	if (!bValid) bFailure= TRUE;
	else if ( valueL>0 )
		Scan->dwMaxCounts= valueL;
	else {
		MessageBeep(0);
		CtrlSetFocus(id_MaxCounts);
		bFailure= TRUE;
	}
	//! liest Sicherungs-Verzeichnis aus Dialogbox und testet ob Verzeichnis
	//! exist. durch anlegen der Datei 'check.tmp' wenn erfolgreich dann setzen
	//! des Pfades sonst setzen von 'C:\\' + Box wird nicht verlassen
	CtrlGetText( id_Catalog, ( LPSTR ) Scan->szDataPath, _MAX_PATH );
	if ( !PathCanWrite(Scan->szDataPath) ) {
		strcpy( Scan->szDataPath, "c:\\" );
		CtrlSetFocus(id_Catalog);
		MessageBeep(0);
		bFailure= TRUE;
	}

	//! test ob 2Theta innerhalb von gueltigem Bereich (sowohl 1. als auch
	//! letzter 2Thetawert
	if ((!bFailure) && (eScanType == stOmega2ThetaScan))
	{
		int nTheta= mlGetIdByName(Theta);
		d2ThetaStart= CtrlGetDouble( id_2Theta, _THETASTARTDIGITS, _DECIMAL, bValid );
		valueF= d2ThetaStart + (Scan->dArgumentMax - Scan->dArgumentMin) * 2.0;
		if (!bValid) bFailure= TRUE;
		else if ( (d2ThetaStart >= mlGetValue(nTheta, MinDistanceRel)) && (valueF <= mlGetValue(nTheta, MaxDistanceRel)) )
			Scan->d2ThetaStart= d2ThetaStart;
		else
		{
			MessageBox("Bereichsberschreitung(Theta)", szMessageDlg, MBINFO);
			CtrlSetFocus(id_2Theta);
			bFailure= TRUE;
		}

	}

	//! sorgt dafuer, dass bei aufgetretenen Fehlern die Box nicht verlassen wird
	if ( bFailure )
	{
		PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0 );
		return FALSE;
	}
	//! uebernehmen der restlichen Dialogeinstell. + Box kann geschlossen werden
	Scan->eScanType= eScanType;

	//! Achsenbeschriftung
	strcpy(Scan->abzisse, mGetAxisName());
	return TRUE;
};

//##############################################################################
// TSetupContinuousScanDlg
//##############################################################################

TSetupContinuousScanDlg::TSetupContinuousScanDlg( TScanWindow *aScan ) : TModalDlg( "CONTINUOUSSCAN", GetMainInstance() ), Scan(0), hDetectorList(0), hMotorList(0)
{
	// ! neu (11.03.2004) Kullmann+Reinecker: alle Memberattribute initialisiert		
	Scan= aScan; //! Parameter von Scanfenster uebernehmen (Fehler)
	// 11.03.2004 nMotor= Scan->nMotor;
	// 11.03.2004 Detector= Scan->Detector;
	dArgumentMin= Scan->dArgumentMin;
	dArgumentMax= Scan->dArgumentMax;
	dArgumentWidth= Scan->dArgumentWidth;
	dSpeed= Scan->dSpeed;
	nCollectionAmount= Scan->nCollectionAmount;
	fMaxTime= Scan->fMaxTime;
	bSaveOnReady= Scan->bSaveOnReady;	
	
	Scan->bSaveContinuous= FALSE;
};
//*****************************************************************************

BOOL TSetupContinuousScanDlg::Dlg_OnInit( HWND, HWND hwndCtl, LPARAM lParam )
{
	//! Min und max event. auf gueltige werte setzen
	if ( dArgumentMax >= mGetValue( MaxDistanceRel ) )
		dArgumentMax= mGetValue( MaxDistanceRel ) - mGetValue( MinWidth );
	if ( dArgumentMin <= mGetValue( MinDistanceRel ) )
		dArgumentMin= mGetValue( MinDistanceRel ) + mGetValue( MinWidth );
	//! Speicheroptionen in dialog eintragen
	CheckDlgButton( GetHandle(), id_SaveOnReady, bSaveOnReady );
	CtrlSetText( id_Path, Scan->szDataPath );

	//! eintragen der Comboboxauswahlelemente fuer Detektor und Scanachse
	//! vorauswahl der aktiven geraete
	hDetectorList= GetDlgItem( GetHandle(), id_ChooseDetector );
	TDetectorManager::DetectorManager().FillDetectorComboBox(hDetectorList, 0);
	ComboBox_SelectString( hDetectorList, 0, Scan->Detector->GetCharacteristic() );

	//! Handles der Comboboxen uebergeben
	hMotorList= GetDlgItem( GetHandle(), id_ChooseMotor );
	for (int i=0; i<mlGetAxisNumber(); i++) 
	{
		mlSetAxis( i );
		ComboBox_AddString( hMotorList, mGetAxisName() );
	}
	mlSetAxis( Scan->nMotor );
	ComboBox_SelectString( hMotorList, 0, mGetAxisName() );

	// HotKey's fr Hilfe
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_SetupContinuousScanDlg)) ); // Accelerator aus Ressourcen laden

	//! eintragen der Messzeit in Dialogbox
	//! bewirkt Aufruf von Dlg_OnCommand mit Kommando cm_ParamSet
	FORWARD_WM_COMMAND( GetHandle(), IDRESET, hwndCtl, 0, SendMessage );
	// OK fokussieren
	CtrlSetFocus(IDOK);
	return TRUE;
};
//*****************************************************************************

void TSetupContinuousScanDlg::Dlg_OnCommand( HWND, int id, HWND hwndCtl,
		UINT codeNotify )
{
	int idx;
	BOOL bValid= TRUE;

	//! abhaengig von dialogelement bzw. Kommando
	switch ( id )
	{
		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_SetupContinuousScanDlg);
			break;

		//! zur initialisierung und bei aenderungen in Comboboxen aufgerufen
		case IDRESET:
			//! eintragen der Messzeit in Dialogbox
			CtrlSetDouble( id_MaxTime, fMaxTime, _MAXTIMEDIGITS, _DECIMAL );
			//! Bereichsgroesse
			CtrlSetDouble(id_StepWidth, dArgumentWidth, mGetDigits()+1, _DECIMAL);
			//! Endpunkt
			CtrlSetDouble(id_AngleMax, dArgumentMax, mGetDigits(), _DECIMAL);
			//! Startpunkt
			CtrlSetDouble(id_AngleMin, dArgumentMin, mGetDigits(), _DECIMAL);
			//Fehler? Kullmann+Reinecker: Hier fehlt sicherlich ein break!

		//! Geschwindigkeit, messbereiche, einheit ... aktualisieren
		//! (event. vorher berechnen)
		case cm_SetupParameters:
		case cm_ParamSet:
			dArgumentMin= CtrlGetDouble( id_AngleMin, mGetDigits(), _DECIMAL, bValid);
			if (!bValid) return;
			dArgumentMax= CtrlGetDouble( id_AngleMax, mGetDigits(), _DECIMAL, bValid);
			if (!bValid) return;
			
			//! Messpunkte
			dArgumentWidth= CtrlGetDouble( id_StepWidth, mGetDigits()+1, _DECIMAL, bValid);
			if (!bValid) return;
			else if ( dArgumentWidth!=0.0 )
			{
				nCollectionAmount= ( dArgumentMax - dArgumentMin ) /
									dArgumentWidth;
				CtrlSetLong(id_NumberSteps, nCollectionAmount);
			} else {
				MessageBeep(0);
				CtrlSetFocus(id_StepWidth);
				return;
			}

			//! Geschwindigkeit
			fMaxTime= CtrlGetDouble( id_MaxTime, _MAXTIMEDIGITS, _DECIMAL, bValid );
			if (!bValid) return;
			else if ( fMaxTime!=0.0)
			{
				dSpeed= dArgumentWidth / fMaxTime;
				CtrlSetDouble(id_Velocity, dSpeed, mGetDigits(), _DECIMAL);
			} else {
				MessageBeep(0);
				CtrlSetFocus(id_MaxTime);
				return;
			}

			//! Motor/Detektor
			ComboBox_SelectString( hMotorList, 0, mGetAxisName() );
			ComboBox_SelectString( hDetectorList, 0, Scan->Detector->GetCharacteristic() );
			//! Einheit
			CtrlSetText( id_Unit, mGetUnitName() );
			//Fehler? Kullmann+Reinecker: Hier fehlt sicherlich ein break!

		//! Scan-Achsen-Combobox ausgewaehlt
		case id_ChooseMotor:
			//! test ob aenderung in combobox
			if ( codeNotify==CBN_SELCHANGE )
			{
				idx= ComboBox_GetCurSel( hMotorList );
				if ( idx != CB_ERR && Scan->nMotor != idx )
				{
					mlSetAxis( idx );
					Scan->nMotor= mlGetAxis();
					FORWARD_WM_COMMAND( GetHandle(), cm_ParamSet, 0, 0, PostMessage );
				}
			}
			break;

		//! Detektor-combobox ausgewaehlt
		case id_ChooseDetector:
			//! test ob aenderung in combobox
			if ( codeNotify == CBN_SELCHANGE )
			{
				idx= ComboBox_GetCurSel( hDetectorList );

				if ( idx == CB_ERR )
					break;

				TDetector* newDetector= TDetectorManager::DetectorManager().GetDetector( idx, 0 );

				//! ja => setzen des Detektors
				//! und senden cm_ParamSet (hier nicht sinnvoll) <- Reinecker: "Und wer soll sonst die Parameter setzen?"
				if ( Scan->Detector != newDetector )
				{
					Scan->Detector= newDetector;
					PostMessage( GetHandle(), WM_COMMAND, cm_ParamSet, 0 );
				}
			}
			break;

		//! hier werden IDOK, IDCANCEL und IDABBORT behandelt
		default:
			TModalDlg::Dlg_OnCommand( GetHandle(), id, hwndCtl, codeNotify );
	}
};
//*****************************************************************************

BOOL TSetupContinuousScanDlg::CanClose( void )
{
	char buf[ MaxString ];
	float valueF;
	BOOL bFailure= FALSE;
	double dAccelerationDistance= 0.0;
	BOOL bValid= TRUE;

	mlSetAxis(Scan->nMotor);
	//! Speicher-Optionen
	bSaveOnReady= IsDlgButtonChecked( GetHandle(), id_SaveOnReady );
	CtrlGetText(id_Path, ( LPSTR ) Scan->szDataPath, _MAX_PATH	);
	if ( !PathCanWrite(Scan->szDataPath) ) {
		strcpy( Scan->szDataPath, "c:\\" );
		CtrlSetFocus(id_Catalog);
		MessageBeep(0);
		bFailure= TRUE;
	}
	//! Messpunkte
	nCollectionAmount= CtrlGetLong(id_NumberSteps, bValid);
	if (!bValid) bFailure= TRUE;
	else if ( 0 >= nCollectionAmount )
	{		
		MessageBox(szMsgLine131, szMsgFailureDlg, MBINFO);
		CtrlSetFocus(id_NumberSteps);
		bFailure= TRUE;
	}
	//! Messzeit
	valueF= CtrlGetDouble( id_MaxTime, _MAXTIMEDIGITS, _DECIMAL, bValid);
	if (!bValid) bFailure= TRUE;
	else if ( 0.0 < valueF )
		fMaxTime= valueF;
	else
	{
		fMaxTime= 0.1f;
		CtrlSetDouble( id_MaxTime, fMaxTime, _MAXTIMEDIGITS, _DECIMAL );
		MessageBeep(0);
		CtrlSetFocus(id_MaxTime);
		bFailure= TRUE;
	}
    
	//! Geschwindigkeit
	valueF= dArgumentWidth / fMaxTime;
	if (!bFailure)
		if ( ( mGetValue( MaxSpeed ) >= valueF ) && (valueF > 0.0))
			dSpeed= valueF;
		else
		{
			MessageBox(szMsgLine130, szMsgFailureDlg, MBINFO);
			bFailure= TRUE;
		}

	if (!bFailure)
	{
		//! Beschleunigungs- bzw. Bremsweg berechnen
		valueF= (float)mGetValue( Acceleration );
		//! vorerst auskommentiert, da die ini-datei-param. nicht stimmen
		//! dAccelerationDistance= 0.5 * (dSpeed * dSpeed) / valueF;
	}

	//! Bereichsgroesse
	valueF= CtrlGetDouble( id_StepWidth, mGetDigits()+1, _DECIMAL, bValid);
	if (!bValid) bFailure= TRUE;
	else if ( mGetValue( MinWidth ) <= valueF )
		dArgumentWidth= valueF;
	else
	{
		dArgumentWidth= mGetValue( MinWidth );
		MessageBeep(0);
		CtrlSetFocus(id_StepWidth);
		bFailure= TRUE;
	}


	//! Endpunkt + Bremsweg
	valueF= CtrlGetDouble( id_AngleMax, mGetDigits(), _DECIMAL, bValid) + dAccelerationDistance;
	if (!bValid) bFailure= TRUE;
	else if ( (valueF <= mGetValue(MaxDistanceRel)) && (valueF >= (mGetValue(MinDistanceRel) + mGetValue( MinWidth))) )
		dArgumentMax= max( mGetValue(MinDistanceRel), valueF - dAccelerationDistance);
	else
	{
		dArgumentMax= mGetValue(MaxDistanceRel) - mGetValue( MinWidth ) -
					   dAccelerationDistance;
		char buf2[MaxString]; //! neu cont
		sprintf(buf2, mGetDF(), dAccelerationDistance);
		sprintf(buf, szMsgLine132, buf2);
		MessageBox(buf, szMsgFailureDlg, MBINFO);
		CtrlSetFocus(id_AngleMax);
		bFailure= TRUE;
	}

	//! Startpunkt - beschleunigungsweg
	valueF= CtrlGetDouble( id_AngleMin, mGetDigits(), _DECIMAL, bValid) + dAccelerationDistance; //! neu cont
	if (!bValid) bFailure= TRUE;
	else if ( (valueF >= mGetValue(MinDistanceRel)) && (valueF <= mGetValue(MaxDistanceRel)) )
	{
		valueF= min( mGetValue(MaxDistanceRel), valueF);
		//! test ob min >= max dann neu setzen + box wird nicht geschlossen
		if ( valueF >= dArgumentMax ) // deshalb erst id_AngleMax auslesen
		{
			dArgumentMin= dArgumentMax;
			dArgumentMax= valueF;
			MessageBox(szMsgLine401, szMessageDlg, MBINFO);
			CtrlSetFocus(id_AngleMin);
			bFailure= TRUE;
		} else dArgumentMin= valueF;
	}
	else
	{
		char buf2[MaxString];
		dArgumentMin= mGetValue(MinDistanceRel) + dAccelerationDistance;
		sprintf(buf2, mGetDF(), dAccelerationDistance); //! neu cont
		sprintf(buf, szMsgLine132, buf2);
		MessageBox(buf, szMsgFailureDlg, MBINFO);
		CtrlSetFocus(id_AngleMin);
		bFailure= TRUE;
	}
	//! Messpunkte
	nCollectionAmount= ( dArgumentMax - dArgumentMin ) /
						dArgumentWidth + 1;

	if ( bFailure )
	{
		PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) IDRESET, 0 );
		return FALSE;
	}
	//! wenn keine Fehler
	if (!bFailure)
	{
		//! Parameter uebernehmen
		Scan->dArgumentMin= dArgumentMin;
		Scan->dArgumentMax= dArgumentMax;
		Scan->dArgumentWidth= dArgumentWidth;
		Scan->dSpeed= dSpeed;
		Scan->nCollectionAmount= nCollectionAmount;
		Scan->fMaxTime= fMaxTime;
		Scan->bSaveOnReady= bSaveOnReady;
		//! Scantyp
		Scan->eScanType= stContinuousScan;
		//! Achsenbeschriftung
		strcpy(Scan->abzisse, mGetAxisName());
	}
	return TRUE;
};

//##############################################################################
// TSetupDynamicStepDlg
//##############################################################################

TSetupDynamicStepDlg::TSetupDynamicStepDlg( TScanWindow* aScan ) : TModalDlg( "DYNAMICSTEPWIDTH", GetMainInstance() ), Scan(0), ScalerDummy(2*nMaxScaleIdx, 0.0)
{
	// ! neu (11.03.2004) Kullmann+Reinecker: alle Memberattribute initialisiert
	Scan= aScan;
};
//*****************************************************************************

int TSetupDynamicStepDlg::GetStaticId(UINT aBereich) {
	switch (aBereich) {
		case 0:
			return id_Static_0;

		case 1:
			return id_Static_1;

		case 2:
			return id_Static_2;

		case 3:
			return id_Static_3;

		case 4:
			return id_Static_4;

		case 5:
			return id_Static_5;

		case 6:
			return id_Static_6;

		case 7:
			return id_Static_7;

		case 8:
			return id_Static_8;

		case 9:
			return id_Static_9;

		default: // unbekannter Bereich
			return -1;
	}
}
//*****************************************************************************

int TSetupDynamicStepDlg::GetFactorId(UINT aBereich) {
	switch (aBereich) {
		case 0:
			return id_Factor_0;

		case 1:
			return id_Factor_1;

		case 2:
			return id_Factor_2;

		case 3:
			return id_Factor_3;

		case 4:
			return id_Factor_4;

		case 5:
			return id_Factor_5;

		case 6:
			return id_Factor_6;

		case 7:
			return id_Factor_7;

		case 8:
			return id_Factor_8;

		case 9:
			return id_Factor_9;

		default: // unbekannter Bereich
			return -1;
	}
}
//*****************************************************************************

int TSetupDynamicStepDlg::GetIntensityId(UINT aBereich) {
	switch (aBereich) {
		case 0:
			return id_Intensity_0;

		case 1:
			return id_Intensity_1;

		case 2:
			return id_Intensity_2;

		case 3:
			return id_Intensity_3;

		case 4:
			return id_Intensity_4;

		case 5:
			return id_Intensity_5;

		case 6:
			return id_Intensity_6;

		case 7:
			return id_Intensity_7;

		case 8:
			return id_Intensity_8;

		case 9:
			return id_Intensity_9;

		default: // unbekannter Bereich
			return -1;
	}
}
//*****************************************************************************

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TSetupDynamicStepDlg::Dlg_OnInit(HWND, HWND hwndCtl, LPARAM lParam)
{
	// HotKey's fr Hilfe
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_SetupDynamicStepDlg)) ); // Accelerator aus Ressourcen laden	
	
	PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) IDRESET, 0 );
	//! Focus auf OK-Button der Box
	CtrlSetFocus( IDOK );
	return TRUE;
};
//*****************************************************************************

//! behandelt alle kommandos der Dialogbox
void TSetupDynamicStepDlg::Dlg_OnCommand(HWND, int id, HWND hwndCtl, UINT codeNotify)
{
	int idx;

	switch ( id )
	{		
		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_SetupDynamicStepDlg);
			break;

		case cm_ParamSet: //! Kommando cm_ParamSet
			//! Eintragen der Dialogbox-Elemente
			for ( idx= 0; idx < nMaxScaleIdx; idx++ )
			{
				CtrlSetDouble(GetIntensityId(idx), ScalerDummy[idx], _INTENSITYDIGITS, _DECIMAL);
				CtrlSetDouble(GetFactorId(idx), ScalerDummy[idx + nMaxScaleIdx], _FACTORDIGITS, _DECIMAL);
			}
			CtrlSetDouble(GetStaticId(0), 0, _STATICDIGITS, _DECIMAL);
			for ( idx= 1; idx < nMaxScaleIdx; idx++ )
			{
				CtrlSetDouble(GetStaticId(idx), ScalerDummy[idx - 1] + 1, _STATICDIGITS, _DECIMAL);
			}
			break;
		
		case IDRESET: //! Kommando IDRESET
			//! Uebernahme der Ursprungswerte in die Arbeits-Variablen + Kommando
			//! cm_ParamSet senden
			for ( idx= 0; idx < nMaxScaleIdx; idx++ )
			{
				ScalerDummy[idx]= Scan->Scaler[idx];
				ScalerDummy[idx + nMaxScaleIdx]= Scan->Scaler[idx + nMaxScaleIdx];
			}
			PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0 );
			break;
		
		default: //! behandelt IDOK, IDCANCEL
			TModalDlg::Dlg_OnCommand( GetHandle(), id, hwndCtl, codeNotify );
	}
};
//*****************************************************************************

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen
//! der Dialogbox (durch OK-Button)
//! Rueckkehrcode False wenn die Dlg.box nicht geschlossen werden kann
//! (Werte inkonsistent) sonst true
BOOL TSetupDynamicStepDlg::CanClose()
{
	int idx= 0;
	float fMaxIntensity= 0.0;
	BOOL retval= TRUE;
	BOOL bValid= TRUE;

	//! Auslesen der Dialogbox-Elemente
	for ( idx; idx < nMaxScaleIdx; idx++ )
	{
		ScalerDummy[ idx ]= CtrlGetDouble(GetIntensityId(idx), _INTENSITYDIGITS, _DECIMAL, bValid);
		if (!bValid) retval= FALSE;
		ScalerDummy[ idx + nMaxScaleIdx ]= CtrlGetDouble( GetFactorId(idx), _FACTORDIGITS, _DECIMAL, bValid);
		if (!bValid) retval= FALSE;
	}

	//! Bestimmung der maximal vorkommenden Intensitaet
	for ( idx= 0; idx < nMaxScaleIdx; idx++ )
		if ( ScalerDummy[ idx ] > fMaxIntensity )
			fMaxIntensity= ScalerDummy[ idx ];

	//! inkorrekte Intensitaeten bestimmen
	//! Faktor auf 1 und Intensitaet auf Maximalen Wert +1 setzen
	for ( idx= 0; idx < nMaxScaleIdx; idx++ )
		if ( ScalerDummy[ idx ] <= 0 )
		{
			ScalerDummy[ idx ]= ++fMaxIntensity;
			ScalerDummy[ idx + nMaxScaleIdx ]= 1.0;
			retval= FALSE;
		}

	// Sortieren der Intensitaeten
	float dummy;
	for ( idx= 0; idx < nMaxScaleIdx - 1; idx++ )
		for ( int idy= idx + 1; idy < nMaxScaleIdx; idy++ )
		{
			if ( ScalerDummy[ idx ] > ScalerDummy[ idy ] )
			{
				dummy= ScalerDummy[ idx ];
				ScalerDummy[ idx ]= ScalerDummy[ idy ];
				ScalerDummy[ idy ]= dummy;
				dummy= ScalerDummy[ idx + nMaxScaleIdx ];
				ScalerDummy[ idx + nMaxScaleIdx ]= ScalerDummy[ idy + nMaxScaleIdx ];
				ScalerDummy[ idy + nMaxScaleIdx ]= dummy;
				retval= FALSE;
			}
		}

	//! Behandlung doppelt vorkommender Intensitaeten
	//! Faktor auf 1 und Intensitaet auf Maximalen Wert +1 setzen
	for ( idx= 1; idx < nMaxScaleIdx; idx++ )
	{
		if ( ScalerDummy[ idx - 1 ] == ScalerDummy[ idx ] )
		{
			ScalerDummy[ idx ]= ++fMaxIntensity;
			ScalerDummy[ idx + nMaxScaleIdx ]= 1.0;
			retval= FALSE;
		}
	}

	// erneutes Sortieren der Intensitaeten
	for ( idx= 0; idx < nMaxScaleIdx - 1; idx++ )
		for ( int idy= idx + 1; idy < nMaxScaleIdx; idy++ )
		{
			if ( ScalerDummy[ idx ] > ScalerDummy[ idy ] )
			{
				dummy= ScalerDummy[ idx ];
				ScalerDummy[ idx ]= ScalerDummy[ idy ];
				ScalerDummy[ idy ]= dummy;
				dummy= ScalerDummy[ idx + nMaxScaleIdx ];
				ScalerDummy[ idx + nMaxScaleIdx ]= ScalerDummy[ idy + nMaxScaleIdx ];
				ScalerDummy[ idy + nMaxScaleIdx ]= dummy;
			}
		}

	//! Test auf korrekte Faktor-Werte
	for ( idx= 0; idx < nMaxScaleIdx; idx++ )
		if ( ScalerDummy[ idx + nMaxScaleIdx ] <= 0 )
		{
			ScalerDummy[ idx + nMaxScaleIdx ]= 1;
			retval= FALSE;
		}

	//! bei Fehler: Korrektur und Dialog bleibt geoeffnet
	if ( !retval )
		PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0 );
	else
		for ( idx= 0; idx < nMaxScaleIdx; idx++ )
		{
			Scan->Scaler[idx]= ScalerDummy[idx];
			Scan->Scaler[idx + nMaxScaleIdx]= ScalerDummy[idx + nMaxScaleIdx];
		}
	return retval;
};