//##############################################################################
//                                                                            //
// S_INTERN.H                                                                 //
//                                                                            //
// Subsystem: Diffraktometrie/ Reflektometrie                                 //
//            intern genutzte Fenster fr Continious-, Step- und DynamicStepScan//
// Benutzung durch andere Subsysteme erforderlich: NEIN                       //
//                                                                            //
//##############################################################################

#ifndef _S_INTERN_H
#define _S_INTERN_H

#include "utils\u_utils.h" // fr TModalDlg

#include "difrkmty\d_extern.h" // fr TSaveFormat

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

class TScanWindow; // forward;

//##############################################################################
// TSetupStepScanDlg
//##############################################################################
// Dialog zum Einstellen der StepScan-Parameter 

class TSetupStepScanDlg : public TModalDlg
{
public:
	TSetupStepScanDlg( TScanWindow* );

// berschriebenes aus der (Fenster-)Basisklasse
private:
	virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	virtual void Dlg_OnCommand( HWND, int, HWND, UINT );
	virtual BOOL CanClose( void );

// Event handler
private:
	void OnChooseScanType(UINT);
	void OnParamSet();
	void OnChooseMotor(UINT);
	void OnChooseDetector(UINT);
	void OnChooseMonitor(UINT);
	void OnDynamicActive();

// ATTRIBUT(E)
private:
	//! zugehoeriges StepScanfenster
	TScanWindow *Scan; // nicht im Destruktor freigeben, wird im Konstruktor bergeben und muss vom Aufrufer verwaltet werden

	//! handle auf Scantyp-combobox
	HWND hScanTypeList;

	double dArgumentMin, //! Wert Minimum in Dlg.box
   		   dArgumentMax, //! Wert Maximum in Dlg.box
		   dArgumentWidth; //! Wert Schrittweite in Dlg.box

	//! Wert Impulse in Dlg.box
	DWORD dwMaxCounts;

	//! Wert Zeit in Dlg.box
	float fMaxTime;

	//! Wert Bei Beenden speichern
	BOOL bSaveOnReady;

	//! Wert Scan-Typ in Dlg.box
	ExScanType eScanType;

	//! Wert Staendig Sichern in Dlg.box
	BOOL bSaveContinuous;

	//! Wert Sicherungsverzeichnis
	char szPath[ _MAX_PATH ];

	//! Wert 2Theta
	double d2ThetaStart;

	//! ?? ueberfluessig
	// 21.04.2004 EFileFormat eSaveFormat;
};

//##############################################################################
// TSetupContinuousScanDlg
//##############################################################################
// Dialog zum Einstellen der ContinuousScan-Parameter 

class TSetupContinuousScanDlg : public TModalDlg
{
public:
	TSetupContinuousScanDlg( TScanWindow* );

// berschriebenes aus der (Fenster-)Basisklasse
private:
	virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	virtual void Dlg_OnCommand( HWND, int, HWND, UINT );
	virtual BOOL CanClose( void );

// ATTRIBUT(E)
private:
	//! Zeiger auf zugehoeriges StepScanfenster
	TScanWindow *Scan; // nicht im Destruktor freigeben, wird im Konstruktor bergeben und muss vom Aufrufer verwaltet werden

	//! handles auf motor/detektor-comboboxen
	HWND hDetectorList, hMotorList;

	double dArgumentMin,//! Wert Startpunkt in Dlg.box
		   dArgumentMax, //! Wert Endpunkt in Dlg.box	
		   dArgumentWidth, //! Bereichsgroesse
		   dSpeed; //! Wert Geschwindigkeit in Dlg.box

	//! Wert Messpunkte in Dlg.box
	int nCollectionAmount;

	//! Wert Messzeit in Dlg.box
	float fMaxTime;

	//! automatisch Speichern nach Beendigung der Messung
	BOOL bSaveOnReady;

	//! Nummer des ausgewaehlten Motors
	// int  nMotor;
	//! Zeiger auf ausgewaehlten Detektor
	// TDetector* Detector;
};

//##############################################################################
// TSetupDynamicStepDlg
//##############################################################################
// Dialog zum Einstellen der DynamicStepScan-Parameter 

class TSetupDynamicStepDlg : public TModalDlg
{
public:
	TSetupDynamicStepDlg( TScanWindow* );

// berschriebenes aus der (Fenster-)Basisklasse
private:
	virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	virtual void Dlg_OnCommand( HWND, int, HWND, UINT );
	virtual BOOL CanClose( void );

// zur komfortableren Arbeit mit Ressourcen-IDs - gibt die Ressourcen-Id fr den jeweiligen Bereich zurck
private:	
	int GetStaticId(UINT aBereich);
	int GetFactorId(UINT aBereich);
	int GetIntensityId(UINT aBereich);

//Attribute
private:
	//! zugehoeriges StepScanfenster
	TScanWindow* Scan; // nicht im Destruktor freigeben, wird im Konstruktor bergeben und muss vom Aufrufer verwaltet werden

	//! zur Sicherung der Dialogbox-Einstellungen, um sie bei Reset zurcksetzen
	//! zu koennen
	TFloatList ScalerDummy;
};

#endif // _S_INTERN_H

//#############################################################################
// LastLine
//#############################################################################