//#############################################################################
//                                                                           //
// MJ_OGUI.H                                                                 //
//                                                                           //
// Subsystem : alte Manuelle Justage / Oberflche                            //
// Benutung durch andere Subsysteme erforderlich: JA                         //
//---------------------------------------------------------------------------//
// Autoren: Thomas Kullmann, Gnther Reinecker                               //
// Stand  : 12.10.2002                                                       //
//                                                                           //
//#############################################################################

#ifndef __MJ_OGUI_H
#define __MJ_OGUI_H

#include "manjust\mj_ofunk.h" // die Funktionalitt

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//#############################################################################
// TAngleCtlDlg
//#############################################################################

class TAngleCtlDlg : public TModalDlg, public ITimer
{
	//*****************************************************************************
	// KONSTRUKTOR-DESTRUKTOR
public:
	TAngleCtlDlg ( void );
	virtual  ~TAngleCtlDlg ( void );

	//*****************************************************************************
	// EREIGNISSE DER BASISKLASSE
protected:
	virtual BOOL Dlg_OnInit ( HWND, HWND, LPARAM );
	virtual void Dlg_OnCommand ( HWND, int, HWND, UINT );
	virtual void Dlg_OnHScrollBar ( HWND, HWND, UINT, int );
	virtual void Interrupt ( void );
	virtual void LeaveDialog ( void );

	virtual void OnTimer ( TBasicTimer *const );

	//*****************************************************************************
	// Methoden fr die bernahme der Bewegungsparameter
private:
	// der erste Parameter ist der Index des Antriebs, dessen Parameter gesetzt werden sollen; der zweite regelt ob das Folgesteuerelemenet fokussiert werden soll
	void OnNewAngleEntered ( const BOOL ); // Zielposition             wird in die Funktionalitt bernommen
	void OnAngleWidthEntered ( const BOOL ); // Schrittweite
	void OnSpeedEntered ( const BOOL ); // Bewegungsgeschwindigkeit

	//*****************************************************************************
	// potentielle Funktionalittskandidaten
private:
	void OnInit ( void );
	BOOL OnSuperviseMove ( void );
	void OnMotorInit ( void );
	void OnParamSet ( void );
	void OnSetAngleZero ( void );
	void OnCancelRelativeZero ( void );
	void OnStartMeasureHWB ( void );
	void OnStopMeasureHWB ( void );
	void OnSteeringReady ( void );
	void OnCounterSet ( void );
	void OnStepMode ( void );
	void OnLongMoveMode ( void );
	void OnChooseMotor ( int );
	void OnChooseMotor( const EAxisType );
	void OnIDOK ( void );
	void OnScrollbarLine ( const BOOL );
	void OnScrollbarEndscroll ( void );
	void OnInterrupt ( void );
	void OnLeave ( void );

	//*****************************************************************************
	// Methoden zur Positionsumrechnung Scrollbar <-> Antriebsposition
private:
	double GetBarScale ( void ) const;
	int GetBarEgde ( const BOOL ) const;
	int GetBarPos ( void ) const;

	//*****************************************************************************
	// Ereignisse
private:
	// die Bewegung wurde gestartet
	void OnMotionStarts ( void );

	// die Bewegung ist im vollen Gange
	void OnMotionProgress ( void );

	// die Bewegung hatgestoppt
	void OnMotionStops ( void );


	// die Makroverarbeitung wurde gestartet
	void OnMeasureStarts ( void );

	// .. ist beendet
	void OnMeasureStops ( void );

	//*****************************************************************************
	// ATTRIBUTE
private:
	TAngleCtl *m_lnkAngleCtl; // die Funktionalitt
	TInterfaceTimer *m_lnkTimer; // POLLING-Timer

	HWND m_BarHandle; // Handle zur Bildlaufleiste
	int m_Selected;   // Index des ausgewhlten Antriebs innerhalb der Auswahl- und Motorenliste (lpMList)
	BOOL *m_StepMode; // TRUE= Schrittbetrieb; FALSE= Fahrbetrieb des jeweiligen Antriebs
};

#endif //__MJ_OGUI.H

//#############################################################################
// LastLine
//#############################################################################