//******************************************************************************
//Datei     : TProtocolManagePrintDlg.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolManagePrintDlg
//******************************************************************************
//!neu klier Protokollbuch

class TProtocolManagePrintDlg
{
public:
	TProtocolManagePrintDlg( int, int, int );

	void EnableButton( BOOL );
	void SearchNew( void );

protected:
	TManageComboboxProtocolDlg ProtocolCombobox;

	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	BOOL Dlg_OnCommand( HWND, int, UINT );
	void Dlg_OnNotify( HWND, int, UINT, UINT );

    BOOL PListView_InsertColumn(HWND, int, LPCSTR);
    void PListView_InsertItem(HWND, int, LPCSTR);
    void PListView_SetItemText(HWND, int, int, LPSTR);

	void AbortPrintSelection( HWND );
	BOOL PrintSelection( HWND , int, int );

	BOOL InitializePrint( HWND );
	void PrintError( LPCSTR );
	BOOL PrintNewPage( int&, int );
	BOOL EndPrint( LPCSTR, LPCSTR, LPCSTR );
	BOOL Print( LPCSTR, LPCSTR, LPCSTR );

	virtual int GetPages( int )= 0;
	virtual int GetColumn( void )= 0;
	virtual LPSTR GetSelLfdNr( LPSTR, int )= 0;
	virtual BOOL PrintSkizze( int )= 0;
	virtual BOOL PrintLine( int )= 0;
	virtual void GetParameterName( int&, LPSTR )= 0;
	virtual BOOL GetParameter( int&, LPSTR, LPCSTR )= 0;

	typedef char TSearchDate[2][MaxString];
	typedef char TSearchParameter[4][MaxString];

	virtual LPSTR GetDlgItemText_LfdNr( HWND, LPSTR )= 0;
	virtual void GetDlgItemText_SearchParameter( HWND, TSearchParameter )= 0;
	virtual BOOL SearchProtocolString( LPCSTR, const TSearchDate, const TSearchParameter )= 0;
	virtual void MakeListString( int )= 0;

	TProtocolDlg *ProtocolDlg;

	HWND hSuchList, hMaterialList;
	char tmpLfdNr[MaxString];
	int Felder, Spalten;
	PRINTDLG pd;
	DOCINFO di;
	int PrintX, PrintY, xmax, ymax, xRand;
	float zoom;
	RECT Rect;
	BOOL bDelete, bSearchActiv;

	// Dialogfensterhandle wird von einigen Funktionen benoetigt
	HWND hwndDlg;

	// Zeiger auf die aktuelle Instanz der Protokollbuchklasse
	TProtocol *Protocol;
};

// LastLine


