// File rc_def.h
// 1993,1994 Heiko Damerow MPG AG "Rntgenbeugung"
#ifndef __RC_DEF_H
#define __RC_DEF_H

//Include fr GermanVersion
#ifndef RC_INVOKED
 #include "..\include\internls\evrythng.h"
#else
 #include "..\internls\evrythng.h"
#endif

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//sortiert nach Dialogfenstern, wo Ressourcen-ID's benutzt werden

//compileruebergreifende Konstanten; Quelle: VisualC 6, WINUSER.H
//#define IDOK				1		ScsParameter, CommonDevParam, PsdParameter, CalibratePsd, TopographyParam, ImageParam, ScanParameters, CcdParameter, CounterShowParam, AreaScanParameters, ContinuousScan, Aquisition, ChooseScan, PSDRemoteSync, AquisitionEng, CalibratePsdEng, DynamicStepWidth, DynamicStepWidthEng, ChooseScanEng, ScanParametersEng, ComposeDatabase, DismantleDatabase, AreaScanParametersEng, DismantleDatabaseEng, ComposeDatabaseEng, ContinuousScanEng, CalibrateMotors, DriveSettings, OptimizeDC_832, OptimizeDC_812, CalibrateMotorsEng, DriveSettingsEng, ImageSaveOptions, MotorOffsetDlg, MotorOffsetDlgEng, PsdOffsetDlg, PsdOffsetDlgEng
//#define IDCANCEL		2		CommonDevParam, PsdParameter, CalibratePsd, TopographyParam, ExecuteCmd, ScanParameters, TopographyExecute, DataShowParam, AreaScanParameters, ContinuousScan, CrossTableControl, Aquisition, ExecuteMacroEng, ChooseScan, UserScal, DataShowParamEng, UserScalEng, AquisitionEng, CalibratePsdEng, DynamicStepWidth, DynamicStepWidthEng, ChooseScanEng, ScanParametersEng, ComposeDatabase, DismantleDatabase, AreaScanParametersEng, DismantleDatabaseEng, ComposeDatabaseEng, ContinuousScanEng, PositionControl, CalibrateMotors, DriveSettings, OptimizeDC_832, OptimizeDC_812, CalibrateMotorsEng, DriveSettingsEng, LineScanParameters, ImageSaveOptions, About, MotorOffsetDlg, MotorOffsetDlgEng, PsdOffsetDlg, PsdOffsetDlgEng
//#define IDABORT			3		AngleControl, AngleControlEng, ExecuteMacro
//#define IDRETRY			4		ungenutzt
//#define IDIGNORE		5		ungenutzt
//#define IDYES				6		ungenutzt
//#define IDNO				7		ungenutzt

//nur bei Borland 4.5 bentigt
#ifndef IDCLOSE // ungenutzt
 #define IDCLOSE			8
#endif //IDCLOSE

#ifndef IDHELP // ManualAdjustmentDlg, ManualAdjustmentDlgEng
 #define IDHELP			9
#endif //IDHELP

//GermanVersion jetzt in EVRYTHNG.H
#ifdef GermanVersion // in Deutsch auch "," zulassen
 #define _DECIMAL ','
 #define _THOUSAND '.'
#else // im Englischen kein Tausendertrennzeichen
 #define _DECIMAL '.'
 #define _THOUSAND '\0'
#endif

//Bezeichung der Titelleiste des Hauptprogramms
#ifdef GermanVersion
 #define APPLICATIONTITLE "XCtl-Programm"
#else
 #define APPLICATIONTITLE "XCtl-Program"
#endif

/////////////////////////////////////////////////////////////////////////////
//
// Ressourcen-IDs
//

//ExecuteMacro, ExecuteMacroEng
#define cm_Interrupt				10200
#define cm_Start					10201
#define id_DetailedReport			10202
#define id_SaveReport				10203

//ExecuteMacro, ExecuteMacroEng, CalibrateMotors, CalibrateMotorsEng
#define id_Report					10300

//AngleControl, AngleControlEng
#define cm_CancelRelativeZero		10500
#define cm_MeasureHWB				10501
#define cm_SetCollimator			10502
#define cm_SetFine					10503
#define cm_SetTilt					10504

//AngleControl, AngleControlEng, CrossTableControl
#define id_StepUnit					10600

//AngleControl, AngleControlEng, ScanParameters, AreaScanParameters, CrossTableControl, ScanParametersEng, AreaScanParametersEng, DriveSettings, DriveSettingsEng, LineScanParameters
#define id_AngleWidth				10700

//AngleControl, AngleControlEng, CrossTableControl
#define cm_SetAngleZero				10800
#define id_LongMoveMode				10801
#define id_SpeedUnit				10802
#define id_SpeedValue				10803
#define id_StepMode					10804

//Aquisition, AquisitionEng
#define id_AddedPoints				11000
#define id_DX						11001
#define id_DY						11002
#define id_LinePoints				11003
#define id_RL						11004

//Aquisition, AquisitionEng, DismantleDatabase, DismantleDatabaseEng
#define id_FileName					11100

//AreaScanParameters, AreaScanParametersEng
#define IDC_COMBOBOX1	101
#define IDC_STATICTEXT1	102
#define IDC_STATICTEXT2	101
#define IDC_STATICTEXT3	103 
//#define id_ChooseDetector	12900  // Testgruppe: doppelt definiert!
#define id_ChooseMonitor  12901
#define id_AbsorberUsed				11201
#define id_Akkumulation				11202
#define id_Final					11203
#define id_FixThetaAxis				11204
#define id_Relation					11207
#define id_ThetaWidth				11208
#define id_ThetaWindow				11209

//AutomaticAngleControl
#define cm_start_justage			11300
#define ID_ActivateIntenseDiff		11301
#define ID_CANCEL					11302
#define ID_CC_Intervall				11303
#define ID_DF_Intervall				11304
#define ID_Durchlauf				11305
#define ID_Help						11306
#define ID_IntenseDifferenz			11307
#define ID_Logfile					11308
#define ID_MeasureCount				11309
#define ID_Optionen_Gruppe			11310
#define ID_Status					11311
#define ID_Status_Gruppe			11312
#define ID_TextMaxIntDiff			11313
#define ID_TL_Intervall				11314
#define ID_Toleranz					11315
#define IDC_GROUPBOX1				11316
#define IDC_GROUPBOX2				11317

//AutomaticAngleControl, ManualAdjustmentDlg, ManualAdjustmentDlgEng, ManualAdjustmentAccel
#define cm_Help                 11350

//CalibrateMotors, CalibrateMotorsEng
#define cm_CarryOnZero				11400
#define cm_SetHome					11401
#define id_AllMotorsReset			11402
#define id_HoldPosition				11403
#define id_ValidCalibrationData		11404

//CalibratePsd, AngleControl, AngleControlEng, CalibratePsdEng
#define id_NewAngle					11500

//CalibratePsd, AngleControl, AngleControlEng, DataShowParam, ChooseScan, DataShowParamEng, CalibratePsdEng, ChooseScanEng, PositionControl
#define id_Bar						11600

//CalibratePsd, AngleControl, AngleControlEng, TopographyExecute, CalibratePsdEng

//CalibratePsd, CalibratePsdEng
#define cm_LeftPositionReached		11800
#define cm_RightPositionReached		11801

//CalibratePsd, TopographyParam, AngleControl, AngleControlEng, ScanParameters, AreaScanParameters, ContinuousScan, CalibratePsdEng, ScanParametersEng, AreaScanParametersEng, ContinuousScanEng, DriveSettings, DriveSettingsEng, LineScanParameters
#define id_Unit						11900

//CcdParameter
#define cm_DataTransmission			12000
#define cm_GrabPicture				12001
#define cm_SendExposureTime			12002
#define id_FastScan					12003
#define id_ScanTime					12004
#define id_SkipTime					12005
#define id_SlowScan					12006

//ChooseScan, ChooseScanEng
#define id_ChooseInfo				12100
#define id_CurveShow				12101
#define id_Info						12102
#define id_Omega					12103
#define id_PeakIntensity			12104
#define id_PeakPosition				12105
#define id_ScanNumber				12106

//ChooseScan, ChooseScanEng, DriveSettings, DriveSettingsEng
#define id_Limit					12200

//CommonDevParam
#define id_ExposureCounts			12300
#define id_ShowCounter				12301
#define id_SoundSwitch				12302
#define id_StaticFailure			12303

//CommonDevParam
#define id_Failure					12400

//CommonDevParam, AreaScanParameters, AreaScanParametersEng
#define cm_SpecificParameters		12500

//ScanParameters, ScanParametersEng, AreaScanParameters, AreaScanParametersEng
//Datum: 06.08.2002 CommonDevParam
#define cm_RotateDetector				12700

//CommonDevParam, TopographyExecute, CcdParameter, LineScanParameters
#define id_ExposureTime				12800

//CommonDevParam, TopographyParam, ScanParameters, AreaScanParameters, ContinuousScan, ScanParametersEng, AreaScanParametersEng, ContinuousScanEng
#define id_ChooseDetector				12900

//ComposeDatabase, ComposeDatabaseEng
#define cm_StartFile				13000
#define id_LastFile					13001
#define id_NumberSpectrum			13002

//ContinuousScan, ContinuousScanEng
#define id_NumberSteps				13100
#define id_Path						13101

//ContinuousScan, ContinuousScanEng, DriveSettings, OptimizeDC_832, OptimizeDC_812, DriveSettingsEng
#define id_Velocity					13200

//CounterShowParam
//Konstante(n):						103
#define id_BarNumber				13300
#define id_ShowAsLog				13301

//CrossTableControl
#define id_AngleType				13400
#define id_x_Bar					13401
#define id_y_Bar					13402

//DataShowParam
#define id_Bar2						13500

//DataShowParam, AreaScanParameters, ContinuousScan, UserScal, DataShowParamEng, UserScalEng, AreaScanParametersEng, ContinuousScanEng
#define cm_SetupParameters			13600

//DataShowParam, CounterShowParam, DataShowParamEng
#define id_MaxIntensity				13700
#define id_Dotted					13701
#define id_Filter					13702
#define	id_FilterStrength			13703

//DataShowParam, DataShowParamEng
#define cm_UserScal					13800
#define id_Dilatation				13801
#define id_Graustufen				13802
#define id_MinIntensity				13803
#define id_ScaleTypeY				13804
#define id_ShowDataType				13805
#define id_tilesx					13806
#define id_tilesy					13807
#define id_X_Scala					13808
#define id_XY_Scaling				13809
#define id_Z_Scala					13810

//DataShowParam, UserScal, DataShowParamEng, UserScalEng
#define id_Standard					13900

//DataShowParamEng
#define IDC_HSCROLL2				14000

//DriveSettings
//Konstante(n):						111

//DriveSettings, DriveSettingsEng
//Konstante(n):						109, 110
#define cm_SwitchLimitWatch			14100

//DriveSettings, OptimizeDC_832, OptimizeDC_812, DriveSettingsEng
#define id_PositionWidth			14200

//DynamicStepWidth, DynamicStepWidthEng
#define id_Factor_0					14300
#define id_Factor_1					14301
#define id_Factor_2					14302
#define id_Factor_3					14303
#define id_Factor_4					14304
#define id_Factor_5					14305
#define id_Factor_6					14306
#define id_Factor_7					14307
#define id_Factor_8					14308
#define id_Factor_9					14309
#define id_Intensity_0				14310
#define id_Intensity_1				14311
#define id_Intensity_2				14312
#define id_Intensity_3				14313
#define id_Intensity_4				14314
#define id_Intensity_5				14315
#define id_Intensity_6				14316
#define id_Intensity_7				14317
#define id_Intensity_8				14318
#define id_Intensity_9				14319
#define id_Static_0					14320
#define id_Static_1					14321
#define id_Static_2					14322
#define id_Static_3					14323
#define id_Static_4					14324
#define id_Static_5					14325
#define id_Static_6					14326
#define id_Static_7					14327
#define id_Static_8					14328
#define id_Static_9					14329
#define IDRESET						14330

//ExecuteCmd
//Konstante(n):						402
#define id_CommandLine				14400
#define id_Response					14401

//ExecuteMacro, ExecuteMacroEng
#define cm_DeleteMacro				14500
#define cm_LoadMacro				14501
#define id_ChooseMacro				14502

//GetData
#define id_GetDataText				14600
#define id_GetDataValue				14601

//ImageParam
//Konstante(n):						1
#define id_BinaryLevel				14700
#define id_FramesNumber				14701
#define id_Source					14702
#define id_xo1						14703
#define id_xo2						14704
#define id_yo1						14705
#define id_yo2						14706

//ImageParam, DataShowParam, DataShowParamEng
#define id_dx1						14800
#define id_dx2						14801
#define id_dy1						14802
#define id_dy2						14803

//ImageSaveOptions
#define id_8Bit_TIFF				14900
#define id_FreeMemory				14901
#define id_RAW12					14902
#define id_RAW8						14903
#define id_UserScaling				14904

//LineScanParameters
#define cm_ImageControl				15000
#define ExIDOK						15001
#define id_ChooseLens				15002
#define id_FirstChannel				15003
#define id_LastChannel				15004
#define id_NumberScans				15005

//OptimizeDC_812
#define id_DynamicGain				15100
#define id_Gain						15101
#define id_Torque					15102

//OptimizeDC_832
#define id_kd						15200
#define id_ki						15201
#define id_kl						15202
#define id_kp						15203

//OptimizeDC_832, OptimizeDC_812
#define cm_StartMoveScan			15300
#define id_Acceleration				15301

//PositionControl
#define id_NewPosition				15400
#define id_Position					15401

//PsdParameter
#define cm_InitializePsd			15501
#define cm_SetEnergyRange			15502
#define cm_SetPositionRange			15503
#define id_EnergyControl			15504
#define id_LeftConnectedZero		15505
#define id_LeftConnectedZero2		15506
#define id_EnergScale1				15507
#define id_EnergScale2				15508
#define id_EnergScale3				15509
#define id_EnergScale4				15510
#define id_PosScale1				15511
#define id_PosScale2				15512
#define id_PosScale3				15513
#define id_PosScale4				15514

//PsdParameter
#define id_AngleRange				15600
#define id_AngleRangeUnit			15601

//PsdParameter, CalibratePsd, TopographyParam
#define id_StepWidthUnit			15650

//PsdParameter, CalibratePsd, TopographyParam, ContinuousScan, CalibratePsdEng, ContinuousScanEng
#define id_StepWidth				15700

//PsdParameter, DriveSettings, DriveSettingsEng
#define id_PositionMax				15800
#define id_PositionMin				15801

//PsdParameter, LineScanParameters
#define id_AddedChannels			15900

//PSDRemoteSync
#define IDC_DirPSDCycle				16000
#define IDC_Extension				16001
#define IDC_InterruptPSDCycle		16002
#define IDC_Messages				16003
#define IDC_StartPSDCycle			16004
#define IDC_StopPSDCycle			16005
#define IDC_TargetName				16006

//ScanParameters, AreaScanParameters, ContinuousScan, ScanParametersEng, AreaScanParametersEng, ContinuousScanEng, DriveSettings, DriveSettingsEng
#define id_AngleMax					16100
#define id_AngleMin					16101
#define id_SaveOnReady				16102

//ScanParameters, AreaScanParameters, ScanParametersEng, AreaScanParametersEng
#define id_2Theta					16200
#define id_MonitorUsed				16201
#define id_SaveContinuous			16202

//ScanParameters, AreaScanParameters, ScanParametersEng, DismantleDatabase, AreaScanParametersEng, DismantleDatabaseEng, ImageSaveOptions
#define id_Catalog					16300

//ScanParameters, ScanParametersEng
#define cm_DynamicSetup				16400
#define id_ChooseScanType			16401
#define id_DynamicActive			16402

//ScsParameter
#define id_HighVoltage				16500

//ScsParameter, PsdParameter, ImageSaveOptions
#define id_LowerLevel				16600
#define id_UpperLevel				16601

//TopographyExecute
#define cm_GotoWorkPoint			16800
#define cm_SwitchControl			16801
#define cm_TopographyParam			16802
#define id_RemainderCyclus			16803
#define id_RemainderTime			16804
#define id_Text						16805

//TopographyParam
#define id_ControlRange				16900
#define id_ControlStep				16901
#define id_From					16902
#define id_MaxAngleEscape			16903
#define id_MoveStep				16904
#define id_MultibleShot				16905
#define id_Shots					16906
#define id_WorkPoint				16907
#define id_ControlStepUnit			16908
#define id_MoveStepUnit				16909
#define id_FromUnit					16910

//TopographyParam, AngleControl, AngleControlEng, ScanParameters, ContinuousScan, ScanParametersEng, ContinuousScanEng, PositionControl, CalibrateMotors, DriveSettings, CalibrateMotorsEng, DriveSettingsEng
#define id_ChooseMotor				17000
#define id_MultipleShot				16905

//Datum: 06.08.2002 TopographyParam, ExecuteCmd, AngleControl, AngleControlEng, PositionControl, CalibrateMotors, DriveSettings, CalibrateMotorsEng, DriveSettingsEng
//Datum: 06.08.2002 #define cm_RotateMotor				17100

//TopographyParam, ScanParameters, AreaScanParameters, ContinuousScan, ScanParametersEng, AreaScanParametersEng, ContinuousScanEng
#define id_MaxTime					17200

//TopographyParam, ScanParameters, AreaScanParameters, ScanParametersEng, AreaScanParametersEng
#define id_MaxCounts				17300

//TopographyParam, TopographyExecute
#define id_MeasurementTime			17400

//UserScal, UserScalEng
#define IDBereichMin				17501
#define IDBereich1					17502
#define IDBereich2					17503
#define IDBereich3					17504
#define IDBereich4					17505
#define IDBereich5					17506
#define IDBereich6					17507
#define IDBereich7					17508
#define IDBereich8					17509
#define IDBereichMax				17500
#define IDFarbeMin					30242
#define IDFarbe1					17511
#define IDFarbe2					17512
#define IDFarbe3					17513
#define IDFarbe4					17514
#define IDFarbe5					17515
#define IDFarbe6					17516
#define IDFarbe7					17517
#define IDFarbe8					17518
#define IDFarbeMax					17510

//ManualAdjustmentDlg, ManualAdjustmentDlgEng, ManualAdjustmentAccel
#define cm_ChooseTB             16600
#define	id_p1_DirectMode	      17601
#define	id_p1_DriveMode	        17602
#define	id_p1_StepMode	        17603
#define	id_p2_DirectMode	      17604
#define	id_p2_DriveMode	        17605
#define	id_p2_StepMode	        17606
#define	id_p3_DirectMode	      17607
#define	id_p3_DriveMode	        17608
#define	id_p3_StepMode	        17609

//ManualAdjustmentDlg, ManualAdjustmentDlgEng
#define	cm_HwbMeasure	          17610
#define	cm_p1_Offset	          17611
#define	cm_p1_ResetRelativeZero 17612
#define	cm_p1_SetRelativeZero   17613
#define	cm_p1_Start	            17614
#define	cm_p2_Offset	          17615
#define	cm_p2_ResetRelativeZero	17616
#define	cm_p2_SetRelativeZero   17617
#define	cm_p2_Start	            17618
#define	cm_p3_Offset	          17619
#define	cm_p3_ResetRelativeZero	17620
#define	cm_p3_SetRelativeZero   17621
#define	cm_p3_Start	            17622
#define	cm_PsdOffset	          17623
#define	id_HwbState	            17624
#define	id_p1_Angle	            17625
#define	id_p1_AngleDest	        17626
#define	id_p1_MotorList	        17627
#define	id_p1_OffsetState	      17628
#define	id_p1_RelativePos	      17629
#define	id_p1_StepWidth	        17630
#define	id_p1_Speed   	        17631
#define	id_p2_Angle	            17632
#define	id_p2_AngleDest	        17633
#define	id_p2_MotorList	        17634
#define	id_p2_OffsetState	      17635
#define	id_p2_RelativePos	      17636
#define	id_p2_StepWidth	        17637
#define	id_p2_Speed   	        17638
#define	id_p3_Angle	            17639
#define	id_p3_AngleDest	        17640
#define	id_p3_MotorList	        17641
#define	id_p3_OffsetState	      17642
#define	id_p3_RelativePos	      17643
#define	id_p3_StepWidth	        17644
#define	id_p3_Speed   	        17645
#define	txt_p1_AngleDestUnit	  17646
#define	txt_p1_AngleUnit	      17647
#define	txt_p1_RelativePosMax	  17648
#define	txt_p1_RelativePosMin	  17649
#define	txt_p1_RelativePosUnit	17650
#define	txt_p1_StepWidthUnit	  17651
#define	txt_p1_SpeedUnit	      17652
#define	txt_p1_RefPoint	        17653
#define	txt_p2_AngleDestUnit	  17654
#define	txt_p2_AngleUnit	      17655
#define	txt_p2_RelativePosMax	  17656
#define	txt_p2_RelativePosMin	  17657
#define	txt_p2_RelativePosUnit	17658
#define	txt_p2_StepWidthUnit	  17659
#define	txt_p2_SpeedUnit	      17660
#define	txt_p2_RefPoint	        17661
#define	txt_p3_AngleDestUnit	  17662
#define	txt_p3_AngleUnit	      17663
#define	txt_p3_RelativePosMax	  17664
#define	txt_p3_RelativePosMin	  17665
#define	txt_p3_RelativePosUnit	17666
#define	txt_p3_StepWidthUnit	  17667
#define	txt_p3_SpeedUnit	      17668
#define	txt_p3_RefPoint	        17669

//MotorOffsetDlg, MotorOffsetDlgEng
#define	id_Angle	                 17700
#define	id_AngleDest	             17701
#define	id_AngleMode	             17702
#define	id_Offset	                 17703
#define	id_OffsetDest	             17704
#define	id_OffsetMode	             17705
#define	txt_AngleUnit	             17706
#define	txt_AngleDestUnit	         17707
#define	txt_OffsetUnit	           17708
#define	txt_OffsetDestUnit	       17709

//PsdOffsetDlg, PsdOffsetDlgEng
#define	id_ChannelDest	           17800
#define id_PsdAngle	               17801
#define	id_PsdAnglePerChannel	     17802
#define	id_PsdAngleDest	           17803
#define	id_PsdOffsetDest	         17804
#define txt_PsdAngle	             17805
#define txt_PsdAngleDestUnit	     17806
#define txt_PsdAnglePerChannelUnit 17807
#define txt_PsdAngleUnit	         17808
#define txt_PsdOffsetDest          17809
#define txt_PsdOffsetDestUnit      17810

/////////////////////////////////////////////////////////////////////////////
//
// StringTable-Eintrge
//

// neue Manuelle Justage
#define sth_mj_NoAction			25000
#define sth_mj_HasRefPoint		25001
#define sth_mj_NoRefPoint		25002
#define sth_mj_ErrTitle			25003
#define sth_mj_Start			25004
#define sth_mj_Stop				25005
#define sth_mj_StartMeasure		25006
#define sth_mj_StopMeasure		25007
#define sth_mj_IsMeasuring		25008
#define sth_mj_MeasureValue		25009
#define sth_mj_MeasureInterrupted	25010
#define sth_mj_Progress 		25011
#define sth_mj_HasOffset		25012
#define sth_mj_NoOffset			25013
#define sth_mj_NoMotor			25014
#define sth_mj_Sec				25015
#define sth_mj_DoubleMotor		25016
#define sth_mj_DontChange		25017
#define sth_mj_NoScroll			25018
#define sth_mj_MotorOffsetTitle	25019
#define sth_mj_PsdOffset		25020
#define sth_mj_PsdOffsetTitle	25021
#define sth_mj_PsdActPos		25022
#define sth_mj_PsdOffsetDest	25023

//neue Topographie
#define sth_tp_NoOmega					25100
#define sth_tp_StartSingleExposure		25101
#define sth_tp_StartMultiExposure		25102
#define sth_tp_StopSingleExposure		25103
#define sth_tp_StopMultiExposure		25104
#define sth_tp_MeasureTimeEnd			25105
#define sth_tp_GoToStartpoint			25106
#define sth_tp_StartpointReached		25107
#define sth_tp_MsgBoxInfo				25108
#define sth_tp_MsgBoxError				25109
#define sth_tp_SettingsIncomplete1		25110
#define sth_tp_SettingsIncomplete2		25111
#define sth_tp_SettingsIncomplete3		25112
#define sth_tp_SettingsComplete1		25113
#define sth_tp_SettingsComplete2		25114
#define sth_tp_SettingsComplete3		25115
#define sth_tp_ValueExposureRange		25116
#define sth_tp_ValueExposureStep		25117
#define sth_tp_ValueExposureTime		25118
#define sth_tp_ValueMultiStep			25119
#define sth_tp_ValueMultiStart			25120
#define sth_tp_ValueWorkpointStep		25121
#define sth_tp_ValueWorkpointPos		25122
#define sth_tp_ValueMaxTime				25123
#define sth_tp_ValueMaxAngle			25124
#define sth_tp_ValueCycles				25125
#define sth_tp_ValueCounts				25126
#define sth_tp_ExceptionOnIntensity		25127
#define sth_tp_ExceptionOnWorkPoint		25128
#define sth_tp_ExceptionOnTime			25129
#define sth_tp_MsgBoxProtocol			25130
#define sth_tp_SaveAtProtocol			25131

//!neu klier Allgemeine Einstellungen
#define id_Target                  17901
#define id_WaveLength              17902
#define id_Current                 17904
#define id_Voltage                 17905
#define id_Reflection              17906
#define id_Orientation             17907
#define id_TargetBulk              17908
#define id_Comment                 17909
#define id_User                    17910
#define id_Status                  17911
#define id_IniFile                 17912
#define id_IniSuchen	             17913
#define id_ProtocolFile            17914
#define id_ProtocolSuchen          17915

// Hauptmen, Datei
#define cm_New						         18000
#define cm_Open						         18001
#define cm_Save						         18002
#define cm_SaveAs					         18003
#define cm_Exit						         18004

// Hauptmen, Bearbeiten
#define cm_Copy						         18100 
//Datum: 29.11.2002 #define cm_Cut						         18101
//Datum: 29.11.2002 #define cm_Clear					         18102

// Hauptmen, ffnen
#define cm_CallExecuteScan			   18200
#define cm_CallExecuteAreaScan		 18201

// Hauptmen, Ausfhren
#define cm_CallExecuteTopograpy		 18300
#define cm_CallTopographyExec		 18306
#define cm_ManualJustage           18301
#define cm_AngleControl				     18302
#define cm_AutomaticAngleControl	 18303
#define cm_CallExecuteMacro			   18304
#define cm_InterruptAction			   18305

// Hauptmen, Einstellungen
#define cm_MotorParam				          18400 
//Datum: 29.11.2002 #define cm_ExecuteCmd                 18401
#define cm_PosControl				          18402
#define cm_SetAngleDefault			      18403
#define cm_Calibrate				          18404
#define cm_OptimizeDC				          18405
#define cm_MeasurementParameterDlg    18406
#define cm_ProtocolTopographyDlg      18407
#define cm_ProtocolDiffractometryDlg  18408
#define cm_TopograpyParam			        18409
#define cm_TopographyAdjust			        18415
#define cm_SensorParam				        18410

// Hauptmen, Fenster
#define cm_Cascade				18500
#define cm_Tile						18501
#define cm_ArrangeIcons		18502

// Hauptmen, Hilfe
#define cm_H_Index				18600 
//Datum: 29.11.2002 #define cm_HelpHelp			  18601
#define cm_Version				18602
#define cm_About					18603

// Hint fr Hauptmen, Datei
//24.04.2004 #define sth_FileNew					18700
//24.04.2004 #define sth_FileOpen				18701
//24.04.2004 #define sth_FileSave				18702
//24.04.2004 #define sth_FileSaveAs			18703
//24.04.2004 #define sth_FileExit				18704

// Hint fr Hauptmen, Fenster
//24.04.2004 #define sth_WindowCascade			18800
//24.04.2004 #define sth_WindowTile				18801
//24.04.2004 #define sth_WindowArrange			18802

// Hint fr Hauptmen, Hilfe
//24.04.2004 #define sth_HelpAbout				  19900

//ICO-Dateien
#define icon_XControl				20000
#define icon_Application			20001
#define icon_MdiWindow				20002
#define icon_ScanWindow				20003

//Tastenkombinationen
#define ACC_Main					20100
#define ACC_ManualAdjustment        20101
#define ACC_AngleControl            20102
#define ACC_CalibrateMotor          20103
#define ACC_AreaScan			    20104
#define ACC_SetupAreaScanDlg        20105
#define ACC_Scan                    20106
#define ACC_SetupStepScanDlg		20107
#define ACC_SetupContinuousScanDlg	20108
#define ACC_SetupDynamicStepDlg	    20109

#define menu_Main                   20200 
#define menu_AreaScan               20202
#define menu_Scan                   20204
#define menu_Counter                20206

// StringTable-Eintrge
#define sth_CannotCreateFile		30245
#define sth_CannotOpenFile			30246
#define sth_StopContiniousPsd		30277
//24.04.2004 #define sth_AskForSavingData		30244
//24.04.2004 #define sth_CommunicationError		30247
//24.04.2004 #define sth_Edit					30248
//24.04.2004 #define sth_File					30249
//24.04.2004 #define sth_FileExistContinue		30250
//24.04.2004 #define sth_FilePrint				30254
//24.04.2004 #define sth_Help					30257
//24.04.2004 #define sth_HelpIndex				30259
//24.04.2004 #define sth_HelpSearch				30260
//24.04.2004 #define sth_HelpTopic				30261
//24.04.2004 #define sth_HelpUsing				30262
//24.04.2004 #define sth_Info					30263
//24.04.2004 #define sth_Measurement				30264
//24.04.2004 #define sth_Mouse					30265
//24.04.2004 #define sth_NewNameAndRestart		30266
//24.04.2004 #define sth_NoPsdValid				30267
//24.04.2004 #define sth_NoValidParamFile		30268
//24.04.2004 #define sth_Open					30269
//24.04.2004 #define sth_Save					30275
//24.04.2004 #define sth_SaveAs					30276
//24.04.2004 #define sth_Option					30270
//24.04.2004 #define sth_OptionsDirectory		30271
//24.04.2004 #define sth_OptionsEnvironment		30272
//24.04.2004 #define sth_OptionsOpen				30273
//24.04.2004 #define sth_OptionsSave				30274
//24.04.2004 #define sth_TimeOutFailure			30278
//24.04.2004 #define sth_View					30279
//24.04.2004 #define sth_ViewWindowIsOpen		30280
//24.04.2004 #define sth_Window					30281
//24.04.2004 #define sth_WindowCloseAll			30284
//24.04.2004 #define sth_WindowIcon				30285

// Statuszeile ID
#define id_STATUS_BAR				30300

// Bitmaps
#define bmp_Background				30350
#define bmp_CenterBack				30351
#define bmp_Logo					30352

// intern zur Fensterkommunikation versendet
#define cm_SteeringReady			30153
#define cm_SteeringReset			30330
#define cm_UpdateRanges				30154

//nicht als Ressourcen-IDs von Steuerelementen benutzt
//hp #define bmp_StatusBar				30001
//hp #define bmp_StatusBar25				30002
//hp #define bmp_StatusLine				30003
//hp #define bmp_StatusLine25			30004 
//Datum 16.05.2003: #define cm_AccuPicture				30006
#define cm_ActivateChanges			30007
#define cm_AllVersions				30010
#define cm_BinaryPicture			30014
#define cm_BvTest					30015
#define cm_CalibratePsd				30018
#define cm_CallExecuteCmd			30023
#define cm_CallExecuteCounter		30024
#define cm_ChooseScan				30032
#define cm_CloseAll					30034
#define cm_ComposeDB				30035
#define cm_ConvolPicture			30037
#define cm_CounterSet				30039
#define cm_DataAquisition			30041
#define cm_Delete					30042
#define cm_Directories				30043
#define cm_DismantleDB				30044
#define cm_DistanceSet				30045
#define cm_DrawInfoBar				30046
#define cm_Environment				30047 
//Datum 16.05.2003: #define cm_EventCounting			30048
#define cm_FailureSet				30050
#define cm_FreezeCurve				30051 
//Datum 16.05.2003: #define cm_GetHistogram				30052
#define cm_GetPeakProperties		30053
#define cm_Glossary					30054
//DATUM: 01.12.2002 #define cm_H_Help					30057  Hilfethema ist nicht mehr vorhanden
#define cm_HelpIndex				30061 
//Datum 16.05.2003: #define cm_ImageSaveOptions			30063
#define cm_Index					30064
#define cm_IndexArrived				30065
#define cm_Information				30066
#define cm_Initialize				30068
#define cm_InitializeAreaScan		30070
#define cm_InitializeLineScan		30072
#define cm_InitializeMotors			30073
#define cm_InitializeScan			30074 
//Datum 16.05.2003: #define cm_InquireCCDLine			30075
#define cm_InquireExeption			30076
#define cm_InquireRelevantData		30077
#define cm_InterruptMeasurement		30079
#define CM_KEY101					30080
#define cm_KillSecondCurve			30081
#define cm_LabelPicture				30082
#define cm_LimitHit					30083
#define cm_LimitHitOccure			30084
#define cm_LoadCurve				30085
#define cm_LoadDataBase				30086
#define cm_LoadPicture				30087
#define cm_Logging					30088
#define cm_Measurement				30090
#define cm_MIL0						30091
#define cm_MIL1						30092
#define cm_MIL2						30093
#define cm_MotorInit				30095
#define cm_MoveButton				30097
#define cm_MoveScanReady			30098
#define cm_OptionsSave				30105
#define cm_PaintPoint				30106
#define cm_ParamSet					30107 
//Datum 16.05.2003: #define cm_PlotCurve				30108
#define cm_Preferences				30111
#define cm_Print					30112 
//Datum 16.05.2003: #define cm_PSD_AreaScan				30113
//Datum 16.05.2003: #define cm_PSD_Scan					30114
#define cm_PutCommand				30116
#define cm_ResponseAvail			30117
#define cm_Restart					30118
#define cm_SavePicture				30121
#define cm_SaveSecondCurve			30122
#define cm_ScanParameters			30123
#define cm_SetCurveScale			30127 
//Datum 16.05.2003: #define cm_SetProperties			30128
#define cm_SetPsdParameters			30129 
//Datum 16.05.2003: #define cm_SetRanges				30130
#define cm_SetupAreaScan			30131 
//Datum 16.05.2003: #define cm_SetupCCDLineScan			30133
#define cm_SetupContinuousScan		30134
#define cm_SetupDlgItem				30135
#define cm_SetupPosition			30136
#define cm_SetupPsd					30137
#define cm_SetupStepScan			30138
#define cm_SetWatchIndicator		30139
#define cm_ShowAnalog				30140
#define cm_ShowCounter				30141
#define cm_ShowCounterParam			30142
#define cm_ShowCurveParam			30143
#define cm_ShowDigital				30144 
//Datum 16.05.2003: #define cm_ShowHistogram			30145
#define cm_ShowPsdE_Data			30146
#define cm_ShowPsdP_Data			30147
#define cm_StartAdjustment			30148
#define cm_StartControl				30149
#define cm_StartPosition			30150
#define cm_StartStop				30151
#define cm_StatusSet				30152
#define cm_StopAll					30154
#define cm_StopMeasurement			30155
#define cm_TargetSet				30156
#define cm_Timer					30158
#define cm_UpdateFile				30160
#define cm_WakeUpSteering			30162
#define id_Activity					30165
#define id_Actor					30166
#define id_Analysator				30167
#define id_BitmapShow				30168
#define id_CameraActivated			30169
#define id_CfgFileDir				30170
#define id_ClearWindow				30171
#define id_Continuous				30172
#define id_Copies					30173
#define id_CounterValue				30174
#define id_CurrentDir				30175
#define id_Deceleration				30176
#define id_Desktop					30177
#define id_DIB_Format				30178
#define id_DiffCurve				30179
#define id_DirList					30180
#define id_Diskriminator			30181
#define id_DynGain					30182
#define id_EditorFiles				30183
#define id_Enlargement				30184
#define id_Environment				30185
#define id_FileList					30186
#define id_GotoZero					30187
#define id_Graph					30188
#define id_GraphicDir				30189
#define id_Graphics					30190
#define id_HalfWidth				30191
#define id_Home						30192
#define id_HorzScroller				30193
#define id_Image					30194
#define id_IncludeDir				30195
#define id_Intensimeter				30196
#define id_Intensity				30197
#define id_InverseColor				30198
#define id_LeftFlank				30199
#define id_Level					30200
#define id_Level_0					30201
#define id_Level_1					30202
#define id_Level_10					30203
#define id_Level_11					30204
#define id_Level_12					30205
#define id_Level_13					30206
#define id_Level_2					30207
#define id_Level_3					30208
#define id_Level_4					30209
#define id_Level_5					30210
#define id_Level_6					30211
#define id_Level_7					30212
#define id_Level_8					30213
#define id_Level_9					30214
#define id_LevelBar					30215
#define id_LevelValue				30216
#define id_LibDir					30217
#define id_LowerLimit				30218
#define id_MotorActivated			30219
#define id_MotorId					30220
#define id_Partial					30221
#define id_Print					30222
#define id_PrinterSetup				30223
#define id_ProcessIt				30224
#define id_ReciprokeLattice			30225
#define id_RevMouseButton			30226
#define id_RightFlank				30227
#define id_ScinValue				30228
#define id_Sensor					30229
#define id_ShiftedMatrix			30230
#define id_SurfaceId				30231
#define id_TextDir					30232
#define id_ThetaUnit				30233
#define id_TiffImage				30234
#define id_To						30235
#define id_TopicSearch				30236
#define id_Unity					30237
#define id_UserQuery				30238
#define id_Volumne					30239
#define id_WindowValue				30240
#define IDC_EDIT1					30241

#endif //__RC_DEF_H

