//******************************************************************************
//Datei     : rc_prtow.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Resourcen der Klassen TProtocolTopographyDlg,
//                                  TProtocolTopographyManagePrintDlg
//                                  TProtocolDiffractometryDlg
//                                  TProtocolDiffractometryManagePrintDlg
//******************************************************************************
//!neu klier Protokollbuch
#ifndef __RC_PRTOW_H
#define __RC_PRTOW_H

//Include fr GermanVersion
#ifndef RC_INVOKED
 #include "..\include\internls\evrythng.h"
#else
 #include "..\internls\evrythng.h"
#endif

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//Resourcen der Klassen TProtocolTopographyDlg, TProtocolDiffractometryDlg

#define id_GruppeProbe                 19001
#define id_GruppeSkizze                19002
#define id_LfdNrText                   19003
#define id_DatumText                   19004
#define id_NutzerText                  19005
#define id_ProbenNrText                19006
#define id_MaterialText                19007
#define id_LfdNr                       19008
#define id_Datum                       19009
#define id_Nutzer                      19010
#define id_ProbenNr                    19011
#define id_Material                    19012
#define id_Skizze                      19013
#define id_EditText                    19014
// Button
#define id_Tab                         19019
#define id_Back                        19020
#define id_Next                        19021
#define id_Copy                        19022
#define id_ReadOnly                    19023
#define id_OKEdit                      19024
#define id_UnDo                        19025
#define id_PointButton                 19026
#define id_LineButton                  19027
#define id_PointText                   19028
#define id_LineText                    19029
#define id_Loeschen                    19030
#define id_Cancel                      19031
#define id_Edit                        19032
#define IDPRINT                        19033
#define id_Help                        19034
#define id_Bemerkung                   19035
#define id_StatusLine                  19036


//Resourcen der Klasse TProtocolTopographyDlg

#define id_LfdNrBereich                19101
#define id_RTKNr                       19102
#define id_LieferantText               19103
#define id_MerkmalText                 19104
#define id_WinkelText                  19105
#define id_GroesseText                 19106
#define id_ReflexText                  19107
#define id_EinfallswinkelText          19108
#define id_BeugungswinkelText          19109
#define id_Lieferant                   19110
#define id_Merkmal                     19111
#define id_Winkel                      19112
#define id_GroesseY                    19113
#define id_GroesseX                    19114
#define id_Reflex                      19115
#define id_Einfallswinkel              19116
#define id_Beugungswinkel              19117
#define id_WinkelEinheit               19118
#define id_GroesseEinheit              19119
#define id_EinfallswinkelEinheit       19120
#define id_BeugungswinkelEinheit       19121

// Gruppe Kollomator/Roehre
#define id_GruppeKollimator            19201
#define id_KMaterialText               19202
#define id_KMaterial                   19203
#define id_KReflexText	               19204
#define id_KReflex                     19205
#define id_KNrText                     19206
#define id_KNr                         19207
#define id_KKruemmungText              19208
#define id_KKruemmung                  19209
#define id_KKruemmungEinheit           19210
#define id_GruppeRoehre	               19211
#define id_RMaterialText               19212
#define id_RMaterial                   19213
#define id_RStromText                  19214
#define id_RStrom                      19215
#define id_RStromEinheit               19216
#define id_RSpannungText               19217
#define id_RSpannung                   19218
#define id_RSpannungEinheit            19219
#define id_RImpMaxText                 19220
#define id_RImpMax                     19221

// Gruppe Messung/Filme
#define id_GruppeMessung               19301
#define id_GruppeFilme                 19302
#define id_MImpMaxText	               19303
#define id_MImpMax                     19304
#define id_MSpannungText               19305
#define id_MSpannung                   19306
#define id_MSpannungEinheit            19307
#define id_MStromText	               19308
#define id_MStrom                      19309
#define id_MStromEinheit               19310
#define id_HWBText                     19311
#define id_HWB                         19312
#define id_FAnzahlText                 19313
#define id_FAnzahl                     19314
#define id_PGroesseXText               19315
#define id_PGroesseYText               19316
#define id_PGroesseX                   19317
#define id_PGroesseY                   19318
#define id_PGroesseEinheit             19319
#define id_FMaterialText               19320
#define id_FMaterial                   19321
#define id_FAbstandText                19322
#define id_FAbstand                    19323
#define id_FAbstandEinheit             19324

// Gruppe Beginn Messung
#define id_GruppeBeginnMessung         19401
#define id_STEText                     19402
#define id_STE                         19403
#define id_STEEinheit                  19404
#define id_CRTText                     19405
#define id_CRT                         19406
#define id_CRTEinheit                  19407
#define id_INCDFText                   19408
#define id_INCDF                       19409
#define id_INCDFEinheit                19410
#define id_NBEXPOSText                 19411
#define id_NBEXPOS                     19412
#define id_ABEText                     19413
#define id_ABE                         19414
#define id_ABEEinheit                  19415
#define id_RSAText                     19416
#define id_RSA                         19417
#define id_RSAEinheit                  19418
#define id_CONLIMITText                19419
#define id_CONLIMIT                    19420
#define id_CONLIMITEinheit             19421
#define id_CONPOINTText                19422
#define id_CONPOINT                    19423
#define id_CONPOINTEinheit             19424
#define id_EXPTText                    19425
#define id_EXPT                        19426
#define id_EXPTEinheit                 19427

// Gruppe Ende Messung
#define id_GruppeEndeMessung           19501
#define id_GruppeRegelung              19502
#define id_ImpsvorText                 19503
#define id_Impsvor                     19504
#define id_ImpsnachText                19505
#define id_Impsnach                    19506
#define id_DFvorText                   19507
#define id_DFvor                       19508
#define id_DFnachText                  19509
#define id_DFnach                      19510
#define id_BemerkungText               19511


//Resourcen der Klasse TProtocolDiffractometryDlg

#define id_GruppeScanart               19601
#define id_GruppeFehlschnitt           19602
#define id_FehlWinkelText              19603
#define id_FehlRichtungText            19604
#define id_OrientierungText            19605
#define id_UReflexText                 19606
#define id_ScanartText                 19607
#define id_ScanmethodeText             19608
#define id_FehlWinkel                  19609
#define id_FehlRichtung                19610
#define id_Orientierung                19611
#define id_UReflex                     19612
#define id_Scanart                     19613
#define id_Scanmethode                 19614
#define id_FehlWinkelEinheit           19615

// Gruppe Messung
#define id_GruppeMessungParameter      19700
#define id_SpannungText                19701
#define id_Spannung                    19702
#define id_SpannungEinheit             19703
#define id_StromText                   19704
#define id_Strom                       19705
#define id_StromEinheit                19706
#define id_WellenlaengeText            19707
#define id_Wellenlaenge                19708
#define id_WellenlaengeEinheit         19709
#define id_MessdateiText               19710
#define id_Messdatei                   19711

// Gruppe Scan
#define id_GruppeScan                  19800
#define id_ScantypText                 19801
#define id_Scantyp                     19802
#define id_ScanachseText               19803
#define id_Scanachse                   19804
#define id_SOffsetText                 19805
#define id_SOffset                     19806
#define id_MinimumText                 19807
#define id_Minimum                     19808
#define id_MaximumText                 19809
#define id_Maximum                     19810
#define id_SchrittweiteText            19811
#define id_Schrittweite                19812
#define id_GeschwindigkeitText         19813
#define id_Geschwindigkeit             19814
#define id_Scanachse1	               19815
#define id_Scanachse2	               19816

// Gruppe Blende/Absorber
#define id_GruppeBlende                19900
#define id_BhorizontalText             19901
#define id_BvertikalText               19902
#define id_BPSvertikalEinheit          19903
#define id_BPShorizontalEinheit        19904
#define id_BPSvertikal	               19905
#define id_BPShorizontal               19906
#define id_BPSText                     19907
#define id_BDText                      19908
#define id_BDhorizontal                19909
#define id_BDvertikal                  19910
#define id_BDhorizontalEinheit         19911
#define id_BDvertikalEinheit           19912
#define id_GruppeAbsorber              19913
#define id_AFaktorText                 19914
#define id_AFaktor                     19915
#define id_AArtText                    19916
#define id_AArt                        19917

// Gruppe Detektor
#define id_GruppeDetektor              20000
#define id_GruppePSD                   20001
#define id_DetektorText                20002
#define id_Detektor                    20003
#define id_MesszeitText                20004
#define id_Messzeit                    20005
#define id_MesszeitEinheit             20006
#define id_ImpulseText                 20007
#define id_Impulse                     20008
#define id_DistanzText                 20009
#define id_Distanz                     20010
#define id_DistanzEinheit              20011
#define id_MesskanalText               20012
#define id_Messkanal                   20013
#define id_WinkelbereichText           20014
#define id_Winkelbereich               20015
#define id_WinkelbereichEinheit        20016
#define id_KanalabstandText            20017
#define id_Kanalabstand                20018
#define id_KanalabstandEinheit         20019
#define id_AddiereText                 20020
#define id_Addiere                     20021
#define id_AddiereEinheit              20022
#define id_MonitorText                 20023
#define id_Monitor                     20024
#define id_GruppeMonitor               20025

// Gruppe Bemerkung
#define id_GruppeBemerkung             20100


//Resourcen der Klasse TProtocolTopographyManagePrintDlg, TProtocolDiffractometryManagePrintDlg

#define id_PrnLfdNrText                20201
#define id_PrnDatumText                20202
#define id_PrnProbenNrText             20203
#define id_PrnMaterialText             20204
#define id_PrnLfdNr                    20205
#define id_PrnDatum1                   20206
#define id_PrnDatum2                   20207
#define id_PrnProbenNr                 20208
#define id_PrnMaterial                 20209

// Gruppe Suchen/Drucken
#define id_GruppeSuchkriterien         20210
#define id_GruppeSuchergebnis          20211
#define id_SuchList                    20212
#define id_Delete                      20213
#define IDSEARCH                       20214
#define IDVIEW                         20215
#define IDDELETE                       20216
#define IDIMPORT                       20217
#define id_Parameter                   20218
#define id_PrnStatusLine               20219


//Resourcen der Klasse TProtocolTopographyManagePrintDlg
#define cm_ProtocolTopographyManagePrintDlg  20300

#define id_PrnLfdNrBereich             20301
#define id_PrnRTKNr                    20303
#define id_PrnLieferantText            20307
#define id_PrnLieferant                20308


//Resourcen der Klasse TProtocolDiffractometryManagePrintDlg
#define cm_ProtocolDiffractometryManagePrintDlg 20400


//Resourcen der Klasse TProtocolPasswortDlg
#define cm_ProtocolPasswortDlg	       20500
#define id_Passwort                     20501

//Resourcen der Klasse TProtocolParameterDlg
#define cm_ProtocolParameterDlg	       20600
#define id_GruppeProtocolFile           20601
#define id_ProtoFileText                20602
#define id_ProtoFile	                   20603
#define id_ProtoBackupPathText          20604
#define id_ProtoBackupPath              20605
#define id_GruppeSortParameter          20606
#define id_SortLfdNr                    20607
#define id_SortDate                     20608
#define id_NoSortNew                    20609
#define id_Durchsuchen                  20610
#define id_Warnung                      20611

//Resourcen des Systemmenues zur Sprachauswahl
#define cm_ProtcolDeutsch               20700
#define cm_ProtcolEnglisch              20701

// LastLine

#endif // __RC_PRTOW_H
