//#############################################################################
//                                                                           //
// MJ_OLD.CPP                                                                //
//                                                                           //
// Subsystem : alte Manuelle Justage / Oberflche                            //
// Benutung durch andere Subsysteme erforderlich: JA                         //
//---------------------------------------------------------------------------//
// Quelle: verschoben aus M_DLG.CPP                                          //
// Stand : 11.01.2003                                                        //
//                                                                           //
//#############################################################################

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include "help\help_def.h"     // Help-IDs

#include "manjust\mj_old.h" // SCHNITTSTELLE fr diese Datei

#include "workflow\workflow.h" // extern Steering

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TSteering Steering; // aus M_STEERG.CPP
extern BOOL bManualMovesCorrected; // aus MAIN.CPP

//#############################################################################
// TAngleControlDlg
//#############################################################################

TAngleControlDlg::TAngleControlDlg(void): TModalDlg( "ANGLECONTROL", GetMainInstance() )
{
	bMoveActive= FALSE; // Alle Motoren befinden sich im Stillstand
	AskTime= 100;   // Zeit fr den Timer (msec)
	bLongMove= FALSE; // Fahrbetrieb "aus" bei Initialisierung
	bMeasureHwb= FALSE; // Halbwertsbreite noch nicht gemessen
	bStepMode= TRUE;  // Schrittbetrieb "ein" bei Initialisierung
	// Liste der Geschwindigkeiten: Lnge=Anzahl der Motoren
	MoveSpeed= new double [mlGetAxisNumber()];
};

//! neu Kullmann+Reinecker
BOOL TAngleControlDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
	int cnt;

	//Datum: 27.07.2002 TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
	nMotor= mlGetAxis();  // nMotor= Anzahl der Motoren bzw. Achsen
	Sensor= TDetectorManager::DetectorManager().GetDetector(); // Pointer auf den akt. Sensor
	BarHandle= GetDlgItem(hwnd, id_Bar); // Handle auf die Scrollbar
	// Handle auf die Motorenliste, nicht zu verwechseln mit der Motorenliste
	// MPlist, hier geht es um die Liste die in der Combobox erscheint
	// Ist also nur Dialogbezogen
	hMotorList= GetDlgItem(hwnd, id_ChooseMotor);
	// Eingabetextfeld fr Schrittbetrieb einblenden (d.h.Eingabe ist mglich)
	EnableWindow(GetDlgItem(hwnd, id_AngleWidth), bStepMode);
	// Eingabetextfeld fr Geschwindigkeitsangabe eingrauen (keine Eingabe mglich)
	EnableWindow(GetDlgItem(hwnd, id_SpeedValue), !bStepMode);
	if (!mlIsAxisValid(Omega))   // Wenn Omega nicht da,
	{
		// dann blende die Schnellauswahl-Schaltelemente Beugung fein
		// bzw. Omega(eng.) und "Halbwertsbreite messen" aus(eingrauen)
		EnableWindow(GetDlgItem(hwnd, cm_SetFine), FALSE);
		EnableWindow(GetDlgItem(hwnd, cm_MeasureHWB), FALSE);
	}
	if (!mlIsAxisValid(Psi))  // Wenn Psi nicht da,
		// dann Schnellauswahlschalter Tilt ausblenden (eingrauen)
		EnableWindow(GetDlgItem(hwnd, cm_SetTilt), FALSE);
	if (!Steering.GetMacroById(InquireHwb)) // Wenn das Makro InquireHWB nicht
		//verfgbar, dann "Halbwertsbreite messen" ausblenden (eingrauen)
		EnableWindow(GetDlgItem(hwnd, cm_MeasureHWB), FALSE);
	if (!mlIsAxisValid(Collimator)) // Wenn Achse Collimator nicht verfgbar ist,
		// dann blende "Collimator" aus der Schnellauswahl aus (eingrauen)
		EnableWindow(GetDlgItem(hwnd, cm_SetCollimator), FALSE);
	// Den Checkbutton "Fahren" als nichtgedrckt(Schalter aus) kennzeichnen
	CheckDlgButton(hwnd, id_LongMoveMode, !bStepMode);
	cnt= 0;
	while (cnt < mlGetAxisNumber()) // alle Achsen durchgehen
	{
		mlSetAxis(cnt++); // alle Achsen durchgehen und jede Achse in die
		ComboBox_AddString(hMotorList, mGetAxisName()); // Motorenliste eintragen
	}
	// Timer setzen fr Multitasking bei Windows 3.1 (unechtes MT)
	SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
	// Sichern der Motor-Einstellungen
	for (cnt= 0; cnt < mlGetAxisNumber(); cnt++)
	{
		mlSetAxis(cnt);
		mPushSettings();
		//Geschwindigkeiten fr die einzelnen Motoren eintragen
		MoveSpeed[cnt]= mGetValue(Speed);
	}
	mlSetAxis(nMotor);
	FORWARD_WM_COMMAND(hwnd, cm_MotorInit, hwndCtl, 0, SendMessage);
	FORWARD_WM_COMMAND(hwnd, cm_ParamSet, hwndCtl, 0, SendMessage);

	bMoveActive= TRUE;
	SetTimer(hwnd, TimerIdInformation, AskTime, NULL);

	// HotKey's Hilfe laden (nur Win32)
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_AngleControl)) ); // Accelerator aus Ressourcen laden

	return TRUE;
};

// Wurde vom Programierer hchstwahrscheinlich fr Testzwecke verwendet
#define TestCall KillTimer(GetHandle(),TimerIdInformation); \
  if(Motor->IsMoveFinish())                                 \
  {                                                         \
    if(!Motor->GetAngle(1))                                 \
    {                                                       \
	  SetDefaultCursor( IDC_WAIT );\
      SetTimer(GetHandle(),TimerIdInformation,AskTime,NULL);\
      return TRUE;                                          \
    }                                                       \
    bLongMove= FALSE;                                      \
    Motor->dAngleNew= Motor->dAngle;                       \
    sprintf(buf,Motor->pOFmt(),Motor->dAngleNew);           \
    SetDlgItemText(GetHandle(),id_NewAngle,(LPSTR)buf);     \
    sprintf(buf,Motor->pOFmt(),Motor->dAngle);              \
    SetDlgItemText(GetHandle(),id_Angle,(LPSTR)buf);        \
	SetScrollPos(BarHandle,SB_CTL,GetBarPos(),TRUE);		\
    bMoveActive= FALSE;                                    \
	SetDefaultCursor( IDC_ARROW );\
  }                                                         \
  else                                                      \
  {                                                         \
    if(bLongMove)                                           \
    {                                                       \
      Motor->GetAngle(0);                                   \
      sprintf(buf,Motor->pOFmt(),Motor->dAngle);            \
      SetDlgItemText(GetHandle(),id_Angle,(LPSTR)buf);      \
	  SetScrollPos(BarHandle,SB_CTL,GetBarPos(),TRUE);		\
    }                                                       \
	SetDefaultCursor( IDC_WAIT );\
  }                                                         \


void TAngleControlDlg::Dlg_OnTimer(HWND hwnd,UINT id)
{
	char buf[MaxString];
	double dDistance;

	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	scrInfo.fMask= SIF_POS;

	switch (id)
	{
		case TimerIdInformation:
			KillTimer(hwnd, TimerIdInformation);
			if (mIsMoveFinish())
			{
				if (!mGetDistance(dDistance))
				{
					SetDefaultCursor( IDC_WAIT );
					SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
					return;
				}
				bLongMove= FALSE;
				sprintf(buf, mGetDF(), dDistance);
				SetDlgItemText(hwnd, id_NewAngle, (LPSTR)buf);
				SetDlgItemText(hwnd, id_Angle, (LPSTR)buf);
				scrInfo.nPos= GetBarPos();
				SetScrollInfo(BarHandle,SB_CTL,&scrInfo,TRUE);
				bMoveActive= FALSE;
				SetFocus(BarHandle);
				SetDefaultCursor( IDC_ARROW );
			}
			else
			{
				if (bLongMove)
				{
					sprintf(buf, mGetDF(), mGetDistanceProcess());
					SetDlgItemText(hwnd, id_Angle, buf);
				}
				SetDefaultCursor( IDC_WAIT );
				SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
			}
	}
};

void TAngleControlDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	static HWND hDlgItem;
	long varl= 0;
	int idx;
	char buf[MaxString];

	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	switch (id)
	{
		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_AngleControlDlg);
			break;

		case cm_ParamSet:
			// Wird mit relativen Positionen gearbeitet ?
			if (mIsDistanceRelative())
				// Wenn ja, dann aktiviere Schalter "Relative Null aufheben" (ausgrauen)
				EnableWindow(GetDlgItem(hwnd, cm_CancelRelativeZero), TRUE);
			else
				// Ansonsten wird Schalter eingegraut
				EnableWindow(GetDlgItem(hwnd, cm_CancelRelativeZero), FALSE);
			sprintf(buf, mGetDF(), mGetValue(Distance));
			// Position bei Textfeld "Winkel:" unter der Scrollbar eintragen
			SetDlgItemText(hwnd, id_Angle, (LPSTR)buf);
			// Textfeld "Neuer Winkel" bekommt erstmal den selben Wert
			SetDlgItemText(hwnd, id_NewAngle, (LPSTR)buf);
			// Aktuellen Antrieb in der Combobox anzeigen
			ComboBox_SelectString(hMotorList, 0, mGetAxisName());
			// Einheit vom aktuellen Antrieb hinter "Neuer Winkel" eintragen
			SetDlgItemText(hwnd, id_Unit, mGetUnitName());
			// Einheit vom akt. Antrieb hinter Schrittbetrieb eintragen
			SetDlgItemText(hwnd, id_StepUnit, mGetUnitName());
			// Initialisieren des Motor-Scroll-Bars
			scrInfo.fMask= SIF_RANGE;
			scrInfo.nMin= GetBarEgde(sbsLeft);
			scrInfo.nMax= GetBarEgde(sbsRight);
			SetScrollInfo(BarHandle,SB_CTL,&scrInfo,TRUE);
			// Focus auf die Scrollbar setzen
			SetFocus(BarHandle);
			break;

		case cm_SetAngleZero:   // Relative Null setzen
			// Wenn Motor aktiv, dann gleich wieder raus
			if (bMoveActive)
				break;
			// Ansonsten rel. Null setzen
			mSetRelativeZero(TRUE, mGetValue(Distance));
			// entsprechend die Schalter ein- bzw. ausblenden
			if (mIsDistanceRelative())
				EnableWindow(GetDlgItem(hwnd, cm_CancelRelativeZero), TRUE);
			else
				EnableWindow(GetDlgItem(hwnd, cm_CancelRelativeZero), FALSE);
			// Motor aktivieren
			bMoveActive= bLongMove= TRUE;
			// Motoreinstellungen sichern
			mPushSettings();
			SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
			SetFocus(BarHandle);
			break;

		case cm_CancelRelativeZero:   // Relative Null aufheben
			// Wenn der Motor in Benutzung, dann gleich abbrechen
			if (bMoveActive)
				break;
			// relative Null fr akt. Motor aufheben
			mSetRelativeZero(FALSE, 0.0);
			// Motor aktivieren
			bMoveActive= bLongMove= TRUE;
			SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
			// Schalter "Relative Null aufheben" ausblenden
			EnableWindow(GetDlgItem(hwnd, cm_CancelRelativeZero), FALSE);
			SetFocus(BarHandle);
			break;

		case cm_MotorInit:
			// Moduswechsel, Shortcuts und Motorwechsel
			// Textfeld fr Schrittbetrieb ausgrauen oder auch nicht ("bStepMode")
			EnableWindow(GetDlgItem(hwnd, id_AngleWidth), bStepMode);
			// Wechselseitiger Ausschlu der Textfelder von Schrittbetrieb und
			// Fahrbetrieb, je nachdem wie die bStepMode gesetzt ist
			EnableWindow(GetDlgItem(hwnd, id_SpeedValue), !bStepMode);
			// Checkbutton entsprechend von bStepMode setzen
			CheckDlgButton(hwnd, id_StepMode, bStepMode);
			if (bStepMode)
				// Wenn Schrittbetrieb, dann Geschwindigkeit auf 10000 (akt. Motor)
				mSetValue(Speed, 10000.0);
			else
				// Ansonsten setze den Speed so wie er in der "MoveSpeed"-Liste steht
				mSetValue(Speed, MoveSpeed[nMotor]);
			sprintf(buf, mGetSF(), mGetValue(Width));
			// Schrittweite und Geschwindigkeit in den Textfelder eintragen
			SetDlgItemText(hwnd, id_AngleWidth, (LPSTR)buf);
			sprintf(buf, mGetDF(), (float)mGetValue(Speed));
			SetDlgItemText(hwnd, id_SpeedValue, (LPSTR)buf);
			// Aktiviere den Motor
			mActivateDrive();
			if (bManualMovesCorrected)
				mSetCorrectionState(TRUE);
			//####################################################################
			// berprfung der Kalibrierungskurven Correction aktivieren
			//####################################################################
			// Initialisieren des Positions-Eingabefenster's
			bMoveActive= TRUE;
#ifdef GermanVersion
			if (mIsCalibrated())
				sprintf(buf, "Manuelle Justage");
			else
				sprintf(buf, "Manuelle Justage : Kein gltiger Referenzpunktlauf");
#else
			if (mIsCalibrated())
				sprintf(buf, "Manual Adjustment");
			else
				sprintf(buf, "Manual Adjustment : No valid Reference Point");
#endif

			SetWindowText(hwnd, (LPCSTR)buf);
			SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
			break;

		case id_StepMode:   // Schrittbetrieb aktivieren
			// Wenn Motor aktiviert, dann gleich wieder raus
			if (bMoveActive)
				break;
			// wenn noch nicht in Schrittbetrieb
			if (!bStepMode)
			{
				bStepMode= TRUE;  // Flag setzen
				// cm_MotorInit auslsen
				SendMessage(hwnd, WM_COMMAND, cm_MotorInit, 0);
				SetFocus(BarHandle);
			}
			else
			{
				// ansonsten Focus auf Eingabefeld setzen
				SetFocus(GetDlgItem(hwnd, id_AngleWidth));
				hDlgItem= GetDlgItem(hwnd, id_AngleWidth);
			}
			break;

		case id_LongMoveMode:   // Fahrbetrieb aktivieren
			// wenn in Schrittbetrieb
			if (bStepMode)
			{
				bStepMode= FALSE; // dann Flag auf false setzen
				// cm_MotorInit ausfhren
				FORWARD_WM_COMMAND(hwnd, cm_MotorInit, 0, 0, SendMessage);
				SetFocus(BarHandle);
			}
			else
			{
				// ansonsten Focus auf Eingabefeld setzen
				hDlgItem= GetDlgItem(hwnd, id_SpeedValue);
				ReplyMessage(varl);
				SetFocus(GetDlgItem(hwnd, id_SpeedValue));
			}
			break;

		case cm_MeasureHWB:   // Halbwertsbreite messen
			if (bMeasureHwb)
			{
				// Messung abbrechen
				bMeasureHwb= FALSE;
				Steering.ToggleInterrupt();
#ifdef GermanVersion
				SetWindowText(GetDlgItem(hwnd, cm_MeasureHWB), "&Halbwertsbreite messen");
#else
				SetWindowText(GetDlgItem(hwnd, cm_MeasureHWB), "Measure &Halfwidth");
#endif
				mlSetAxis(nMotor);
				SendMessage(hwnd, WM_COMMAND, cm_MotorInit, 0);
				SendMessage(hwnd, WM_COMMAND, cm_ParamSet, 0);
				bMoveActive= TRUE;
				SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
				break;
			}
			if (bMoveActive)
				break;
			bMeasureHwb= TRUE;
			bMoveActive= TRUE;
			Steering.Reset();
			Steering.StartUp(hwnd, nMotor, Sensor);
			Steering.Visualising( TRUE, FALSE );
#ifdef GermanVersion

			SetWindowText(GetDlgItem(hwnd, cm_MeasureHWB), "&Messung abbrechen");
#else

			SetWindowText(GetDlgItem(hwnd, cm_MeasureHWB), "Skip &Measurement");
#endif
			// Makro Inquire Hwb ausfhren
			Steering.StartMacroExecution(Steering.GetMacroById(InquireHwb), hwnd);
			break;

		case cm_CounterSet:
			Sensor->UpdateViews(TRUE);
			Steering.DetectorRequest();
			break;

		case cm_SteeringReady:
			mlSetAxis(nMotor);
			FORWARD_WM_COMMAND(hwnd, cm_MotorInit, 0, 0, SendMessage);
			FORWARD_WM_COMMAND(hwnd, cm_ParamSet, 0, 0, SendMessage);
			bMoveActive= TRUE;
			SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
			MessageBeep(0);
			bMeasureHwb= FALSE;
#ifdef GermanVersion
			sprintf(buf, "HWB= %.2f Sekunden", Steering.GetHwb()); // ! neu Kullmann+Reinecker: fHwb durch Accessor-Methode GetHwb() ersetzt
			SetInfo(buf);
			SetWindowText(GetDlgItem(hwnd, cm_MeasureHWB), "&Halbwertsbreite messen");
#else
			sprintf(buf, "HWB= %.2f arcsec", Steering.GetHwb()); // ! neu Kullmann+Reinecker: fHwb durch Accessor-Methode GetHwb() ersetzt
			SetInfo(buf);
			SetWindowText(GetDlgItem(hwnd, cm_MeasureHWB), "Measure &Halfwidth");
#endif
			break;

		case id_ChooseMotor:   // Motor aus der Combobox auswhlen
			if (codeNotify==CBN_SELCHANGE) {
				idx= ComboBox_GetCurSel(hMotorList);
				if ((idx != CB_ERR) && (nMotor != idx))
				{
					nMotor= idx;
					mlSetAxis(nMotor);
					FORWARD_WM_COMMAND(hwnd, cm_ParamSet, 0, 0, SendMessage);
					FORWARD_WM_COMMAND(hwnd, cm_MotorInit, 0, 0, PostMessage);
				}
			}
			break;

			//Datum: 02.08.2002
		/*case cm_RotateMotor: // Die Motoren in der Combobox rotieren
			// der Schalter ist aber ausgeblendet im Dialog
			if (bMoveActive) break;
			if (!hDlgItem) break;
			mlSetAxis(++nMotor); // einen Motor weiterschalten
			nMotor= mlGetAxis(); // merken, welcher aktiv ist
			FORWARD_WM_COMMAND(hwnd,cm_ParamSet,0,0,SendMessage);
			FORWARD_WM_COMMAND(hwnd,cm_MotorInit,0,0,PostMessage);
			break;*/

		case cm_SetFine:   // in Schnellauswahl "Beugung Fein" auswhlen
			if (bMoveActive)
				break;
			// Welche ID hat "Beugung Fein" ? Die Achse mit dieser ID aktivieren
			mlSetAxis(mlGetIdByName(Omega));
			nMotor= mlGetAxis(); // merken welcher Antrieb aktiviert ist
			FORWARD_WM_COMMAND(hwnd, cm_ParamSet, 0, 0, SendMessage);
			FORWARD_WM_COMMAND(hwnd, cm_MotorInit, 0, 0, PostMessage);
			break;

		case cm_SetTilt:   // Tilt in Schnellauswahl auswhlen
			if (bMoveActive)
				break;
			// Analog wie oben
			mlSetAxis(mlGetIdByName(Psi));
			nMotor= mlGetAxis();
			FORWARD_WM_COMMAND(hwnd, cm_ParamSet, 0, 0, SendMessage);
			FORWARD_WM_COMMAND(hwnd, cm_MotorInit, 0, 0, PostMessage);
			break;

		case cm_SetCollimator:   // Kollimator in Schnellauswahl auswhlen
			if (bMoveActive)
				break;
			// analog wie oben
			mlSetAxis(mlGetIdByName(Collimator));
			nMotor= mlGetAxis();
			FORWARD_WM_COMMAND(hwnd, cm_ParamSet, 0, 0, SendMessage);
			FORWARD_WM_COMMAND(hwnd, cm_MotorInit, 0, 0, PostMessage);
			break;

		case id_AngleWidth:
			hDlgItem= GetDlgItem(hwnd, id_AngleWidth);
			break;

		case id_SpeedValue:
			hDlgItem= GetDlgItem(hwnd, id_SpeedValue);
			break;

		case id_NewAngle:
			hDlgItem= GetDlgItem(hwnd, id_NewAngle);
			break;

		case IDOK:
			if (!hDlgItem)
			{
				TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
				break;
			}
			// Der Nutzer hat mit Return eine neue Position, eine neue Geschwindigkeit
			// oder eine neue Schrittweite eingegeben
			for (;;)
			{
				if (hDlgItem == GetDlgItem(hwnd, id_AngleWidth))
				{
					GetDlgItemText(hwnd, id_AngleWidth, (LPSTR)buf, 10);
					mSetValue(Width, atof(buf));
					sprintf(buf, mGetSF(), mGetValue(Width));
					SetDlgItemText(hwnd, id_AngleWidth, (LPSTR)buf);
					scrInfo.fMask= SIF_RANGE | SIF_POS;
					scrInfo.nMin= GetBarEgde(sbsLeft);
					scrInfo.nMax= GetBarEgde(sbsRight);
					scrInfo.nPos= GetBarPos();
					SetScrollInfo(BarHandle,SB_CTL,&scrInfo,TRUE);
					break;
				}
				if (hDlgItem == GetDlgItem(hwnd, id_NewAngle))
				{
					if (!bMoveActive)
					{
						GetDlgItemText(hwnd, id_NewAngle, (LPSTR)buf, 10);
						bMoveActive= TRUE;
						bLongMove= TRUE;
						mMoveToDistance(atof(buf));
						FORWARD_WM_COMMAND(hwnd, cm_MoveButton, 0, 0, PostMessage);
					}
					break;
				}
				if (hDlgItem == GetDlgItem(hwnd, id_SpeedValue))
				{
					GetDlgItemText(hwnd, id_SpeedValue, (LPSTR)buf, 10);
					mSetValue(Speed, atof(buf));
					MoveSpeed[nMotor]= mGetValue(Speed);
					sprintf(buf, mGetSF(), (float)MoveSpeed[nMotor]);
					SetDlgItemText(hwnd, id_SpeedValue, (LPSTR)buf);
					break;
				}
			}
			hDlgItem= NULL;
			SetFocus(BarHandle);
			break;

		case cm_MoveButton:
			bMoveActive= TRUE;
			SetDefaultCursor( IDC_WAIT );
			SetTimer(hwnd, TimerIdInformation, AskTime, NULL);
			break;

		default:
			TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
	}
};

void TAngleControlDlg::Interrupt(void)
{
	mStopDrive(TRUE);
	DelayTime(5);
};


void TAngleControlDlg::Dlg_OnHScrollBar(HWND hwnd, HWND hwndCtl, UINT code, int pos)
{
	if (bMeasureHwb)
		return;
	switch (code)
	{
		case SB_LINEUP:
			if (bMoveActive)
				return;
			if (bStepMode)
				mMoveToDistance(mGetValue(Distance) - mGetValue(Width));
			else
			{
				mMoveToDistance(mGetValue(MinDistance));
				bLongMove= TRUE;
			}
			FORWARD_WM_COMMAND(hwnd, cm_MoveButton, 0, 0, SendMessage);
			break;

		case SB_LINEDOWN:
			if (bMoveActive)
				return;
			if (bStepMode)
				mMoveToDistance(mGetValue(Distance) + mGetValue(Width));
			else
			{
				mMoveToDistance(mGetValue(MaxDistance));
				bLongMove= TRUE;
			}
			FORWARD_WM_COMMAND(hwnd, cm_MoveButton, 0, 0, SendMessage);
			break;

		case SB_ENDSCROLL:
			// Bewegung stoppen, wenn lnger gefahren wurde
			if (bLongMove)
				Interrupt();
			break;
	}
};

int TAngleControlDlg::GetBarEgde(EScrollBarSide side)
{
	long steps;
	int ret;

	if (side == sbsLeft)
	{
		steps= (long)((mGetValue(MaxDistance) - mGetValue(MinDistance)) / mGetValue(Width));
		BarFactor= (int)(steps / 20000l) + 1;
		ret= (int)(mGetValue(MinDistance) / (mGetValue(Width) * BarFactor));
	}
	else
	{
		ret= (int)(mGetValue(MaxDistance) / (mGetValue(Width) * BarFactor));
	}
	return ret;
};

int TAngleControlDlg::GetBarPos()
{
	int ret;

	ret= (int)(mGetValue(Distance) / (mGetValue(Width) * BarFactor));
	return ret;
};

void TAngleControlDlg::LeaveDialog(void)
{
	int cnt;

	cnt= KillTimer(GetHandle(), TimerIdInformation);
	if (Sensor != TDetectorManager::DetectorManager().GetDetector(0, 1))
	{
		Sensor->MeasureStop();
		Sensor->PopSettings();
		Sensor->MeasureStart();
	}
	mStopDrive(TRUE);
	for (cnt= 0; cnt < mlGetAxisNumber(); cnt++)
	{
		mlSetAxis(cnt);
		mPopSettings(ThisPosition);
		mSetCorrectionState(FALSE);
	}
	mlSetAxis(nMotor);
};
