//******************************************************************************
//Datei     : TProtocolTopography.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolTopography <-- TProtocol
//******************************************************************************
//!neu klier Protokollbuch
#include "internls\evrythng.h"
#include <ctype.h>

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolTopography.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--


TProtocolTopography::TProtocolTopography() : TProtocol(Feldelemente)
{
	int i= 0;

	if ( Parameter != NULL )
	{
		strcpy(Parameter[i].Name, "Lfd.-Nr.");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "RTK-Nr.");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Datum");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Nutzer");
		Parameter[i++].MaxLen= 15;
		strcpy(Parameter[i].Name, "Probennummer");
		Parameter[i++].MaxLen= 25;
		strcpy(Parameter[i].Name, "Lieferant");
		Parameter[i++].MaxLen= 20;
		strcpy(Parameter[i].Name, "Merkmal");
		Parameter[i++].MaxLen= 20;
		strcpy(Parameter[i].Name, "Material");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Winkel");
		Parameter[i++].MaxLen= 4;
		strcpy(Parameter[i].Name, "Gre");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Gre-b");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Reflex");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Einfallswinkel");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Beugungswinkel");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Kollimator-Material");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Kollimator-Reflex");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Kollimator-Nr.");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Kollimator-Krmmung");
		Parameter[i++].MaxLen= 7;
		strcpy(Parameter[i].Name, "Rhre-Material");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Rhre-Strom");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Rhre-Spannung");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Imp/s Max");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Messung-Imp/s Max");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Messung-Strom");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Messung-Spannung");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "HWB");
		Parameter[i++].MaxLen= 7;
		strcpy(Parameter[i].Name, "Film-Anzahl");
		Parameter[i++].MaxLen= 1;
		strcpy(Parameter[i].Name, "Aufnahmematerial");
		Parameter[i++].MaxLen= 5;
		strcpy(Parameter[i].Name, "Plattengre");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Plattengre-b");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Abstand");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "stat. Fehler");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Zhlzeit");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Schrittweite");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Anzahl Belichtungen");
		Parameter[i++].MaxLen= 2;
		strcpy(Parameter[i].Name, "Winkel zw. Belichtungen");
		Parameter[i++].MaxLen= 5;
		strcpy(Parameter[i].Name, "kleinster Startwinkel");
		Parameter[i++].MaxLen= 5;
		strcpy(Parameter[i].Name, "proz. Abweichung");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Arbeitspunkt");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Belichtungszeit");
		Parameter[i++].MaxLen= 4;
		strcpy(Parameter[i].Name, "Imp/s vor Messung");
		Parameter[i++].MaxLen= 5;
		strcpy(Parameter[i].Name, "Imp/s nach Messung");
		Parameter[i++].MaxLen= 5;
		strcpy(Parameter[i].Name, "DF vor Messung");
		Parameter[i++].MaxLen= 7;
		strcpy(Parameter[i].Name, "DF nach Messung");
		Parameter[i++].MaxLen= 7;
		strcpy(Parameter[i].Name, "Bemerkung");
		Parameter[i++].MaxLen= 80;
		strcpy(Parameter[i].Name, "Status");
		Parameter[i++].MaxLen= 1;
	}
	strcpy(szProtocolSection, "ProtocolTopography");
};

void TProtocolTopography::InitializeDefaultParameter( void )
{
	if ( bDebug )
		MessageBox(GetFocus(), "InitializeDefaultParameter!", "Debug Info", MBINFO);
	if (IsProtocolOn() && IsProtocolOnBegin())
	{
		GetProtocolValue(KKruemmung, DefaultKKruemmung);
		GetProtocolValue(ImpMax, DefaultImpMax);
		GetProtocolValue(HWB, DefaultHWB);
		GetProtocolValue(STE, DefaultSTE);
		GetProtocolValue(CONLIMIT, DefaultCONLIMIT);
		GetProtocolValue(CRT, DefaultCRT);
		GetProtocolValue(INCDF, DefaultINCDF);
		GetProtocolValue(NBEXPOS, DefaultNBEXPOS);
		GetProtocolValue(RSA, DefaultRSA);
		GetProtocolValue(ABE, DefaultABE);
		GetProtocolValue(EXPT, DefaultEXPT);
		GetProtocolValue(CONPOINT, DefaultCONPOINT);
	}
	else
	{
		strcpy(DefaultKKruemmung, "");
		strcpy(DefaultImpMax, "");
		strcpy(DefaultHWB, "");
		strcpy(DefaultSTE, "");
		strcpy(DefaultCONLIMIT, "");
		strcpy(DefaultCRT, "");
		strcpy(DefaultINCDF, "");
		strcpy(DefaultNBEXPOS, "");
		strcpy(DefaultRSA, "");
		strcpy(DefaultABE, "");
		strcpy(DefaultEXPT, "");
		strcpy(DefaultCONPOINT, "");
	}
};

void TProtocolTopography::SetDefaultParameter( void )
{
	if ( bDebug )
		MessageBox(GetFocus(), "SetDefaultParameter!", "Debug Info", MBINFO);
	SetProtocolValue(KKruemmung, DefaultKKruemmung);
	SetProtocolValue(ImpMax, DefaultImpMax);
	SetProtocolValue(HWB, DefaultHWB);
	SetProtocolValue(STE, DefaultSTE);
	SetProtocolValue(CONLIMIT, DefaultCONLIMIT);
	SetProtocolValue(CRT, DefaultCRT);
	SetProtocolValue(INCDF, DefaultINCDF);
	SetProtocolValue(NBEXPOS, DefaultNBEXPOS);
	SetProtocolValue(RSA, DefaultRSA);
	SetProtocolValue(ABE, DefaultABE);
	SetProtocolValue(EXPT, DefaultEXPT);
	SetProtocolValue(CONPOINT, DefaultCONPOINT);
};

void TProtocolTopography::SetOnDefaultParameterReadOnly( void )
{
	if ( bDebug )
		MessageBox(GetFocus(), "SetDefaultParameter!", "Debug Info", MBINFO);
	SetAllParameterReadWrite();
	SetParameterReadOnly(KKruemmung);
	SetParameterReadOnly(ImpMax);
	SetParameterReadOnly(HWB);
	SetParameterReadOnly(Impsvor);
	SetParameterReadOnly(Impsnach);
	//   SetParameterReadOnly(STE);
	//   SetParameterReadOnly(CONLIMIT);
	SetParameterReadOnly(CRT);
	SetParameterReadOnly(INCDF);
	SetParameterReadOnly(NBEXPOS);
	SetParameterReadOnly(RSA);
	SetParameterReadOnly(ABE);
	SetParameterReadOnly(EXPT);
	SetParameterReadOnly(CONPOINT);
	SetParameterReadOnly(DFvor);
	SetParameterReadOnly(DFnach);
};

void TProtocolTopography::SetDefaultParameterReadOnly( void )
{
	SetAllParameterReadWrite();
};

void TProtocolTopography::ClearOldParameter( void )
{
	SetProtocolValue(LfdNr, "");
	SetProtocolValue(RTKNr, "");
	ClearProtocolString(STE, Status);
	SetProtocolValue(KKruemmung, "");
	SetProtocolValue(HWB, "");
	SetProtocolValue(ImpMax, "");
};

BOOL TProtocolTopography::TestLfdNr( LPCSTR Value1, LPCSTR Value2, LPCSTR Value3 )
{
	int i;

	if ( (strlen(Value1) != 1) || (strlen(Value2) != 5) || (strlen(Value3) < 1) ||
			(strlen(Value3) > 2))
		return FALSE;
	if ( !isalpha(Value1[0]) )
		return FALSE;
	for (i= 0; i < 5; i++)
		if ( !isdigit(Value2[i]) )
			return FALSE;
	for (i= 0; i < strlen(Value3); i++)
		if ( !isdigit(Value3[i]) )
			return FALSE;
	return TRUE;
};

BOOL TProtocolTopography::TestLfdNr( LPCSTR Value1, LPCSTR Value2)
{
	int i;

	if ( (strlen(Value1) != GetParameterMaxLen(LfdNr)) || (strlen(Value2) < 1) || (strlen(Value2) > 2))
		return FALSE;
	if ( !isalpha(Value1[0]) )
		return FALSE;
	for (i= 1; i < GetParameterMaxLen(LfdNr); i++)
		if ( !isdigit(Value1[i]) )
			return FALSE;
	for (i= 0; i < strlen(Value2); i++)
		if ( !isdigit(Value2[i]) )
			return FALSE;
	return TRUE;
};

BOOL TProtocolTopography::TestLfdNr( LPCSTR Value )
{
	int i;

	if ( (strlen(Value) > (GetParameterMaxLen(LfdNr) + GetParameterMaxLen(RTKNr))) ||
			(strlen(Value) < (GetParameterMaxLen(LfdNr) + GetParameterMaxLen(RTKNr) - 1)) )
		return FALSE;
	if ( !isalpha(Value[0]) )
		return FALSE;
	for (i= 1; i < strlen(Value); i++)
		if ( !isdigit(Value[i]) )
			return FALSE;
	return TRUE;
};

BOOL TProtocolTopography::SearchProtocolString( LPCSTR lLfdNr )
{
	return TProtocol::SearchProtocolString( lLfdNr );
};

BOOL TProtocolTopography::SearchProtocolString( LPCSTR lLfdNr, LPCSTR lRTKNr,
		LPCSTR lDatum1, LPCSTR lDatum2, LPCSTR lProbenNr,
		LPCSTR lLieferant, LPCSTR lMaterial )
{
	char Date1[MaxDate], Date2[MaxDate];

	while ( currentINDEX != NULL )
	{
		if (iSearch++ > 0)
			currentINDEX= currentINDEX->next;
		if (currentINDEX == NULL)
			return FALSE;
		if ( strlen(lLfdNr) == 0 || strncmp(currentINDEX->LfdNr, lLfdNr, strlen(lLfdNr)) == 0 )
		{
			MakeDateString(lDatum1, Date1);
			MakeDateString(lDatum2, Date2);
			if ( strlen(lDatum1) == 0 || strcmp(currentINDEX->Date, Date1) >= 0 )
				if ( strlen(lDatum2) == 0 || strcmp(currentINDEX->Date, Date2) <= 0 )
				{
					if ( !LoadProtocolString( currentINDEX->Pos) )
						return FALSE;
					if ( strlen(lRTKNr) == 0 || strncmp(Parameter[RTKNr].Wert, lRTKNr, strlen(lRTKNr)) == 0 )
						if ( strlen(lProbenNr) == 0 || strncmp(Parameter[ProbenNr].Wert, lProbenNr, strlen(lProbenNr)) == 0 )
							if ( strlen(lMaterial) == 0 || strncmp(Parameter[Material].Wert, lMaterial, strlen(lMaterial)) == 0 )
								if ( strlen(lLieferant) == 0 || strncmp(Parameter[Lieferant].Wert, lLieferant, strlen(lLieferant)) == 0 )
									return TRUE;
				}
		}
	}
	return FALSE;
};

LPSTR TProtocolTopography::GetParameterLfdNr( LPSTR lLfdNr)
{
	strcpy(lLfdNr, Parameter[LfdNr].Wert);
	strcat(lLfdNr, Parameter[RTKNr].Wert);
	return lLfdNr;
};

LPSTR TProtocolTopography::GetParameterDate( LPSTR lDate)
{
	strcpy(lDate, Parameter[Datum].Wert);
	return lDate;
};

void TProtocolTopography::SetParameterDate( LPCSTR lDate)
{
	strcpy(Parameter[Datum].Wert, lDate);
};

void TProtocolTopography::SaveLfdNr( LPCSTR Value )
{
	strcpy(CurrentLfdNr, "");
	strncat(CurrentLfdNr, Value, 6);
	strcpy(Parameter[LfdNr].Wert, CurrentLfdNr);
	strncat(CurrentLfdNr, Value + 6, 2);
	strcpy(Parameter[RTKNr].Wert, "");
	strncat(Parameter[RTKNr].Wert, Value + 6, 2);
};

void TProtocolTopography::SaveLfdNr( LPCSTR Value1, LPCSTR Value2, LPCSTR Value3 )
{
	strcpy(CurrentLfdNr, Value1);
	strcat(CurrentLfdNr, Value2);
	strcpy(Parameter[LfdNr].Wert, CurrentLfdNr);
	strcat(CurrentLfdNr, Value3);
	strcpy(Parameter[RTKNr].Wert, Value3);
};

LPSTR TProtocolTopography::GetLfdNrBereich( LPSTR LfdNrBereich )
{
	if (strlen(CurrentLfdNr) > 6)
	{
		LfdNrBereich[0]= CurrentLfdNr[0];
		LfdNrBereich[1]= '\0';
	}
	else
		strcpy(LfdNrBereich, "");
	return LfdNrBereich;
};

LPSTR TProtocolTopography::GetLfdNrNummer( LPSTR LfdNrNummer )
{
	if (strlen(CurrentLfdNr) > 6)
	{
		for (int i= 0; i < 5; i++)
			LfdNrNummer[i]= CurrentLfdNr[i + 1];
		LfdNrNummer[5]= '\0';
	}
	else
		strcpy(LfdNrNummer, "");
	return LfdNrNummer;
};

LPSTR TProtocolTopography::GetRTKNr( LPSTR RTKNr )
{
	if (strlen(CurrentLfdNr) > 6)
	{
		for (int i= 0; i < strlen(CurrentLfdNr) - 6; i++)
			RTKNr[i]= CurrentLfdNr[i + 6];
		RTKNr[strlen(CurrentLfdNr) - 6]= '\0';
	}
	else
		strcpy(RTKNr, "");
	return RTKNr;
};

LPSTR TProtocolTopography::GetNewLfdNr( LPSTR lLfdNr )
{
	char buf[MaxLfdNr];

	GetPrivateProfileString(GetProtocolSection(), "LfdNrBereich", "C", lLfdNr, MaxLfdNr, GetCFile( ));
	strcat(lLfdNr, "00000");
	GetPrivateProfileString(GetProtocolSection(), "RTKNr", "12", buf, MaxLfdNr, GetCFile( ));
	strcat(lLfdNr, buf);
	if (lastINDEX != NULL)
	{
		strcpy(buf, "");
		strncat(buf, lastINDEX->LfdNr + 1, 5);
		do
		{
			sprintf(lLfdNr, "%ld", atol(buf) + 1);
			strcpy(buf, lLfdNr);
			strrev(lLfdNr);
			while (strlen(lLfdNr) < (GetParameterMaxLen(LfdNr) - 1))
				strcat(lLfdNr, "0");
			strncat(lLfdNr, lastINDEX->LfdNr, 1);
			strrev(lLfdNr);
			strncat(lLfdNr, lastINDEX->LfdNr + 6, 2);
		} while (SearchProtocolString(lLfdNr) && (atol(buf) < 99999));
	}
	return lLfdNr;
};

BOOL TProtocolTopography::IsMaxLfdNr( )
{
	char buf[MaxLfdNr], lLfdNr[MaxLfdNr];

	if (lastINDEX == NULL)
		return FALSE;
	strcpy(buf, "");
	strncat(buf, lastINDEX->LfdNr + 1, 5);
	if (atol(buf) == 99999)
		return TRUE;
	do
	{
		sprintf(lLfdNr, "%ld", atol(buf) + 1);
		strcpy(buf, lLfdNr);
		strrev(lLfdNr);
		while (strlen(lLfdNr) < (GetParameterMaxLen(LfdNr) - 1))
			strcat(lLfdNr, "0");
		strncat(lLfdNr, lastINDEX->LfdNr, 1);
		strrev(lLfdNr);
		strncat(lLfdNr, lastINDEX->LfdNr + 6, 2);
	} while (SearchProtocolString(lLfdNr) && (atol(buf) <= 99999));
	SearchProtocolString(GetLfdNr(lLfdNr));
	if (atol(buf) > 99999)
		return TRUE;
	return FALSE;
};

LPCSTR TProtocolTopography::GetPName( )
{
	return GetPTopoName();
};

LPCSTR TProtocolTopography::GetPDirectory( )
{
	return GetPTopoDirectory();
};

LPCSTR TProtocolTopography::GetPBackupDirectory( )
{
	return GetPTopoBackupDirectory();
};

BOOL TProtocolTopography::SetPBackupDirectory( LPCSTR lDir )
{
	return SetPTopoBackupDirectory(lDir);
};

LPCSTR TProtocolTopography::GetPFile( )
{
	return GetPTopoFile();
};

BOOL TProtocolTopography::SetPFile( LPCSTR FileName )
{
	if (!SetPTopoFile( FileName ))
		return FALSE;
	WritePrivateProfileString(szProtocolSection, "ProtocolFile", GetPTopoFile(), GetCFile());
	return TRUE;
};

// LastLine
